/*!
 * @fileOverview TouchSwipe - jQuery Plugin
 *
 * @author Matt Bryson http://www.github.com/mattbryson
 * @see https://github.com/mattbryson/TouchSwipe-Jquery-Plugin
 * @see http://labs.rampinteractive.co.uk/touchSwipe/
 * @see http://plugins.jquery.com/project/touchSwipe
 * @license
 * Copyright (c) 2010-2015 Matt Bryson
 * Dual licensed under the MIT or GPL Version 2 licenses.
 *
 */
(function(n){typeof define=="function"&&define.amd&&!1&&define.amd.jQuery?define(["jquery"],n):typeof module!="undefined"&&!1&&module.exports?n(require("jquery")):n(jQuery)})(function(n){var r="left",u="right",f="up",e="down",v="in",y="out",p="none",nt="auto",w="swipe",b="pinch",k="tap",tt="doubletap",it="longtap",d="horizontal",g="vertical",l="all",ut=10,rt="start",o="move",t="end",i="cancel",c="ontouchstart"in window,a=window.navigator.msPointerEnabled&&!window.navigator.pointerEnabled&&!c,s=(window.navigator.pointerEnabled||window.navigator.msPointerEnabled)&&!c,h="TouchSwipe";n.fn.swipe=function(t){var r=n(this),i=r.data(h);if(i&&typeof t=="string"){if(i[t])return i[t].apply(this,Array.prototype.slice.call(arguments,1));n.error("Method "+t+" does not exist on jQuery.swipe")}else if(i&&typeof t=="object")i.option.apply(this,arguments);else if(!i&&(typeof t=="object"||!t))return ft.apply(this,arguments);return r};n.fn.swipe.version="1.6.15";n.fn.swipe.defaults={fingers:1,threshold:75,cancelThreshold:null,pinchThreshold:20,maxTimeThreshold:null,fingerReleaseThreshold:250,longTapThreshold:500,doubleTapThreshold:200,swipe:null,swipeLeft:null,swipeRight:null,swipeUp:null,swipeDown:null,swipeStatus:null,pinchIn:null,pinchOut:null,pinchStatus:null,click:null,tap:null,doubleTap:null,longTap:null,hold:null,triggerOnTouchEnd:!0,triggerOnTouchLeave:!1,allowPageScroll:"auto",fallbackToMouseEvents:!0,excludedElements:"label, button, input, select, textarea, a, .noSwipe",preventDefaultEvents:!0};n.fn.swipe.phases={PHASE_START:rt,PHASE_MOVE:o,PHASE_END:t,PHASE_CANCEL:i};n.fn.swipe.directions={LEFT:r,RIGHT:u,UP:f,DOWN:e,IN:v,OUT:y};n.fn.swipe.pageScroll={NONE:p,HORIZONTAL:d,VERTICAL:g,AUTO:nt};n.fn.swipe.fingers={ONE:1,TWO:2,THREE:3,FOUR:4,FIVE:5,ALL:l};function ft(t){return t&&t.allowPageScroll===undefined&&(t.swipe!==undefined||t.swipeStatus!==undefined)&&(t.allowPageScroll=p),t.click!==undefined&&t.tap===undefined&&(t.tap=t.click),t||(t={}),t=n.extend({},n.fn.swipe.defaults,t),this.each(function(){var r=n(this),i=r.data(h);i||(i=new et(this,t),r.data(h,i))})}function et(ft,et){var et=n.extend({},et),si=c||s||!et.fallbackToMouseEvents,hi=si?s?a?"MSPointerDown":"pointerdown":"touchstart":"mousedown",ki=si?s?a?"MSPointerMove":"pointermove":"touchmove":"mousemove",di=si?s?a?"MSPointerUp":"pointerup":"touchend":"mouseup",ri=si?s?"mouseleave":null:"mouseleave",ci=s?a?"MSPointerCancel":"pointercancel":"touchcancel",at=0,vt=null,yt=null,lt=0,gt=0,ni=0,pt=1,bt=0,kt=0,li=null,ot=n(ft),st="start",ct=0,ht={},gi=0,ai=0,vi=0,nr=0,ti=0,fi=null,ei=null;try{ot.bind(hi,tr);ot.bind(ci,ui)}catch(ff){n.error("events not supported "+hi+","+ci+" on jQuery.swipe")}this.enable=function(){return ot.bind(hi,tr),ot.bind(ci,ui),ot};this.disable=function(){return lr(),ot};this.destroy=function(){lr();ot.data(h,null);ot=null};this.option=function(t,i){if(typeof t=="object")et=n.extend(et,t);else if(et[t]!==undefined){if(i===undefined)return et[t];et[t]=i}else if(t)n.error("Option "+t+" does not exist on jQuery.swipe.options");else return et;return null};function tr(t){if(!pu()&&!(n(t.target).closest(et.excludedElements,ot).length>0)){var r=t.originalEvent?t.originalEvent:t,f,u=r.touches,e=u?u[0]:r;return(st=rt,u?ct=u.length:et.preventDefaultEvents!==!1&&t.preventDefault(),at=0,vt=null,yt=null,kt=null,lt=0,gt=0,ni=0,pt=1,bt=0,li=ku(),dr(),wi(0,e),!u||ct===et.fingers||et.fingers===l||oi()?(gi=ii(),ct==2&&(wi(1,u[1]),gt=ni=cr(ht[0].start,ht[1].start)),(et.swipeStatus||et.pinchStatus)&&(f=wt(r,st))):f=!1,f===!1)?(st=i,wt(r,st),f):(et.hold&&(ei=setTimeout(n.proxy(function(){ot.trigger("hold",[r.target]);et.hold&&(f=et.hold.call(ot,r,r.target))},this),et.longTapThreshold)),pi(!0),null)}}function ir(n){var f=n.originalEvent?n.originalEvent:n;if(st!==t&&st!==i&&!yi()){var s,r=f.touches,h=r?r[0]:f,u=gr(h);if(ai=ii(),r&&(ct=r.length),et.hold&&clearTimeout(ei),st=o,ct==2&&(gt==0?(wi(1,r[1]),gt=ni=cr(ht[0].start,ht[1].start)):(gr(r[1]),ni=cr(ht[0].end,ht[1].end),kt=gu(ht[0].end,ht[1].end)),pt=du(gt,ni),bt=Math.abs(gt-ni)),ct===et.fingers||et.fingers===l||!r||oi()){if(vt=iu(u.start,u.end),yt=iu(u.last,u.end),uu(n,yt),at=nf(u.start,u.end),lt=tu(),bu(vt,at),s=wt(f,st),!et.triggerOnTouchEnd||et.triggerOnTouchLeave){var e=!0;if(et.triggerOnTouchLeave){var c=rf(this);e=uf(u.end,c)}!et.triggerOnTouchEnd&&e?st=fr(o):et.triggerOnTouchLeave&&!e&&(st=fr(t));(st==i||st==t)&&wt(f,st)}}else st=i,wt(f,st);s===!1&&(st=i,wt(f,st))}}function rr(n){var r=n.originalEvent?n.originalEvent:n,u=r.touches;if(u){if(u.length&&!yi())return yu(r),!0;if(u.length&&yi())return!0}return yi()&&(ct=nr),ai=ii(),lt=tu(),or()||!er()?(st=i,wt(r,st)):et.triggerOnTouchEnd||et.triggerOnTouchEnd==!1&&st===o?(et.preventDefaultEvents!==!1&&n.preventDefault(),st=t,wt(r,st)):!et.triggerOnTouchEnd&&br()?(st=t,dt(r,st,k)):st===o&&(st=i,wt(r,st)),pi(!1),null}function ui(){ct=0;ai=0;gi=0;gt=0;ni=0;pt=1;dr();pi(!1)}function ur(n){var i=n.originalEvent?n.originalEvent:n;et.triggerOnTouchLeave&&(st=fr(t),wt(i,st))}function lr(){ot.unbind(hi,tr);ot.unbind(ci,ui);ot.unbind(ki,ir);ot.unbind(di,rr);ri&&ot.unbind(ri,ur);pi(!1)}function fr(n){var r=n,f=ar(),u=er(),e=or();return!f||e?r=i:u&&n==o&&(!et.triggerOnTouchEnd||et.triggerOnTouchLeave)?r=t:!u&&n==t&&et.triggerOnTouchLeave&&(r=i),r}function wt(n,r){var u,f=n.touches;return(eu()||sr())&&(u=dt(n,r,w)),(fu()||oi())&&u!==!1&&(u=dt(n,r,b)),au()&&u!==!1?u=dt(n,r,tt):vu()&&u!==!1?u=dt(n,r,it):lu()&&u!==!1&&(u=dt(n,r,k)),r===i&&(sr()&&(u=dt(n,r,w)),oi()&&(u=dt(n,r,b)),ui(n)),r===t&&(f?f.length||ui(n):ui(n)),u}function dt(o,s,h){var c;if(h==w){if(ot.trigger("swipeStatus",[s,vt||null,at||0,lt||0,ct,ht,yt]),et.swipeStatus&&(c=et.swipeStatus.call(ot,o,s,vt||null,at||0,lt||0,ct,ht,yt),c===!1))return!1;if(s==t&&yr()){if(clearTimeout(fi),clearTimeout(ei),ot.trigger("swipe",[vt,at,lt,ct,ht,yt]),et.swipe&&(c=et.swipe.call(ot,o,vt,at,lt,ct,ht,yt),c===!1))return!1;switch(vt){case r:ot.trigger("swipeLeft",[vt,at,lt,ct,ht,yt]);et.swipeLeft&&(c=et.swipeLeft.call(ot,o,vt,at,lt,ct,ht,yt));break;case u:ot.trigger("swipeRight",[vt,at,lt,ct,ht,yt]);et.swipeRight&&(c=et.swipeRight.call(ot,o,vt,at,lt,ct,ht,yt));break;case f:ot.trigger("swipeUp",[vt,at,lt,ct,ht,yt]);et.swipeUp&&(c=et.swipeUp.call(ot,o,vt,at,lt,ct,ht,yt));break;case e:ot.trigger("swipeDown",[vt,at,lt,ct,ht,yt]);et.swipeDown&&(c=et.swipeDown.call(ot,o,vt,at,lt,ct,ht,yt))}}}if(h==b){if(ot.trigger("pinchStatus",[s,kt||null,bt||0,lt||0,ct,pt,ht]),et.pinchStatus&&(c=et.pinchStatus.call(ot,o,s,kt||null,bt||0,lt||0,ct,pt,ht),c===!1))return!1;if(s==t&&vr())switch(kt){case v:ot.trigger("pinchIn",[kt||null,bt||0,lt||0,ct,pt,ht]);et.pinchIn&&(c=et.pinchIn.call(ot,o,kt||null,bt||0,lt||0,ct,pt,ht));break;case y:ot.trigger("pinchOut",[kt||null,bt||0,lt||0,ct,pt,ht]);et.pinchOut&&(c=et.pinchOut.call(ot,o,kt||null,bt||0,lt||0,ct,pt,ht))}}return h==k?(s===i||s===t)&&(clearTimeout(fi),clearTimeout(ei),hr()&&!su()?(ti=ii(),fi=setTimeout(n.proxy(function(){ti=null;ot.trigger("tap",[o.target]);et.tap&&(c=et.tap.call(ot,o,o.target))},this),et.doubleTapThreshold)):(ti=null,ot.trigger("tap",[o.target]),et.tap&&(c=et.tap.call(ot,o,o.target)))):h==tt?(s===i||s===t)&&(clearTimeout(fi),clearTimeout(ei),ti=null,ot.trigger("doubletap",[o.target]),et.doubleTap&&(c=et.doubleTap.call(ot,o,o.target))):h==it&&(s===i||s===t)&&(clearTimeout(fi),ti=null,ot.trigger("longtap",[o.target]),et.longTap&&(c=et.longTap.call(ot,o,o.target))),c}function er(){var n=!0;return et.threshold!==null&&(n=at>=et.threshold),n}function or(){var n=!1;return et.cancelThreshold!==null&&vt!==null&&(n=nu(vt)-at>=et.cancelThreshold),n}function ru(){return et.pinchThreshold!==null?bt>=et.pinchThreshold:!0}function ar(){return et.maxTimeThreshold?lt>=et.maxTimeThreshold?!1:!0:!0}function uu(n,t){if(et.preventDefaultEvents!==!1)if(et.allowPageScroll===p)n.preventDefault();else{var i=et.allowPageScroll===nt;switch(t){case r:(et.swipeLeft&&i||!i&&et.allowPageScroll!=d)&&n.preventDefault();break;case u:(et.swipeRight&&i||!i&&et.allowPageScroll!=d)&&n.preventDefault();break;case f:(et.swipeUp&&i||!i&&et.allowPageScroll!=g)&&n.preventDefault();break;case e:(et.swipeDown&&i||!i&&et.allowPageScroll!=g)&&n.preventDefault()}}}function vr(){var n=pr(),t=wr(),i=ru();return n&&t&&i}function oi(){return!!(et.pinchStatus||et.pinchIn||et.pinchOut)}function fu(){return!!(vr()&&oi())}function yr(){var n=ar(),t=er(),i=pr(),r=wr(),u=or();return!u&&r&&i&&t&&n}function sr(){return!!(et.swipe||et.swipeStatus||et.swipeLeft||et.swipeRight||et.swipeUp||et.swipeDown)}function eu(){return!!(yr()&&sr())}function pr(){return ct===et.fingers||et.fingers===l||!c}function wr(){return ht[0].end.x!==0}function br(){return!!et.tap}function hr(){return!!et.doubleTap}function ou(){return!!et.longTap}function kr(){if(ti==null)return!1;var n=ii();return hr()&&n-ti<=et.doubleTapThreshold}function su(){return kr()}function hu(){return(ct===1||!c)&&(isNaN(at)||at<et.threshold)}function cu(){return lt>et.longTapThreshold&&at<ut}function lu(){return!!(hu()&&br())}function au(){return!!(kr()&&hr())}function vu(){return!!(cu()&&ou())}function yu(n){vi=ii();nr=n.touches.length+1}function dr(){vi=0;nr=0}function yi(){var n=!1;if(vi){var t=ii()-vi;t<=et.fingerReleaseThreshold&&(n=!0)}return n}function pu(){return!!(ot.data(h+"_intouch")===!0)}function pi(n){ot&&(n===!0?(ot.bind(ki,ir),ot.bind(di,rr),ri&&ot.bind(ri,ur)):(ot.unbind(ki,ir,!1),ot.unbind(di,rr,!1),ri&&ot.unbind(ri,ur,!1)),ot.data(h+"_intouch",n===!0))}function wi(n,t){var i={start:{x:0,y:0},last:{x:0,y:0},end:{x:0,y:0}};return i.start.x=i.last.x=i.end.x=t.pageX||t.clientX,i.start.y=i.last.y=i.end.y=t.pageY||t.clientY,ht[n]=i,i}function gr(n){var i=n.identifier!==undefined?n.identifier:0,t=wu(i);return t===null&&(t=wi(i,n)),t.last.x=t.end.x,t.last.y=t.end.y,t.end.x=n.pageX||n.clientX,t.end.y=n.pageY||n.clientY,t}function wu(n){return ht[n]||null}function bu(n,t){t=Math.max(t,nu(n));li[n].distance=t}function nu(n){return li[n]?li[n].distance:undefined}function ku(){var n={};return n[r]=bi(r),n[u]=bi(u),n[f]=bi(f),n[e]=bi(e),n}function bi(n){return{direction:n,distance:0}}function tu(){return ai-gi}function cr(n,t){var i=Math.abs(n.x-t.x),r=Math.abs(n.y-t.y);return Math.round(Math.sqrt(i*i+r*r))}function du(n,t){var i=t/n*1;return i.toFixed(2)}function gu(){return pt<1?y:v}function nf(n,t){return Math.round(Math.sqrt(Math.pow(t.x-n.x,2)+Math.pow(t.y-n.y,2)))}function tf(n,t){var r=n.x-t.x,u=t.y-n.y,f=Math.atan2(u,r),i=Math.round(f*180/Math.PI);return i<0&&(i=360-Math.abs(i)),i}function iu(n,t){var i=tf(n,t);return i<=45&&i>=0?r:i<=360&&i>=315?r:i>=135&&i<=225?u:i>45&&i<135?e:f}function ii(){var n=new Date;return n.getTime()}function rf(t){t=n(t);var i=t.offset();return{left:i.left,right:i.left+t.outerWidth(),top:i.top,bottom:i.top+t.outerHeight()}}function uf(n,t){return n.x>t.left&&n.x<t.right&&n.y>t.top&&n.y<t.bottom}}});!function(n){"function"==typeof define&&define.amd&&!1?define(["jquery"],n):"object"==typeof exports&&!1?module.exports=n:n(jQuery)}(function(n){function u(i){var u=i||window.event,p=c.call(arguments,1),l=0,s=0,o=0,a=0,w=0,b=0;if(i=n.event.fix(u),i.type="mousewheel","detail"in u&&(o=-1*u.detail),"wheelDelta"in u&&(o=u.wheelDelta),"wheelDeltaY"in u&&(o=u.wheelDeltaY),"wheelDeltaX"in u&&(s=-1*u.wheelDeltaX),"axis"in u&&u.axis===u.HORIZONTAL_AXIS&&(s=-1*o,o=0),l=0===o?s:o,"deltaY"in u&&(o=-1*u.deltaY,l=o),"deltaX"in u&&(s=u.deltaX,0===o&&(l=-1*s)),0!==o||0!==s){if(1===u.deltaMode){var v=n.data(this,"mousewheel-line-height");l*=v;o*=v;s*=v}else if(2===u.deltaMode){var y=n.data(this,"mousewheel-page-height");l*=y;o*=y;s*=y}if(a=Math.max(Math.abs(o),Math.abs(s)),(!t||t>a)&&(t=a,e(u,a)&&(t/=40)),e(u,a)&&(l/=40,s/=40,o/=40),l=Math[l>=1?"floor":"ceil"](l/t),s=Math[s>=1?"floor":"ceil"](s/t),o=Math[o>=1?"floor":"ceil"](o/t),r.settings.normalizeOffset&&this.getBoundingClientRect){var k=this.getBoundingClientRect();w=i.clientX-k.left;b=i.clientY-k.top}return i.deltaX=s,i.deltaY=o,i.deltaFactor=t,i.offsetX=w,i.offsetY=b,i.deltaMode=0,p.unshift(i,l,s,o),f&&clearTimeout(f),f=setTimeout(h,200),(n.event.dispatch||n.event.handle).apply(this,p)}}function h(){t=null}function e(n,t){return r.settings.adjustOldDeltas&&"mousewheel"===n.type&&t%120==0}var f,t,o=["wheel","mousewheel","DOMMouseScroll","MozMousePixelScroll"],i="onwheel"in document||document.documentMode>=9?["wheel"]:["mousewheel","DomMouseScroll","MozMousePixelScroll"],c=Array.prototype.slice;if(n.event.fixHooks)for(var s=o.length;s;)n.event.fixHooks[o[--s]]=n.event.mouseHooks;var r=n.event.special.mousewheel={version:"3.1.12",setup:function(){if(this.addEventListener)for(var t=i.length;t;)this.addEventListener(i[--t],u,!1);else this.onmousewheel=u;n.data(this,"mousewheel-line-height",r.getLineHeight(this));n.data(this,"mousewheel-page-height",r.getPageHeight(this))},teardown:function(){if(this.removeEventListener)for(var t=i.length;t;)this.removeEventListener(i[--t],u,!1);else this.onmousewheel=null;n.removeData(this,"mousewheel-line-height");n.removeData(this,"mousewheel-page-height")},getLineHeight:function(t){var r=n(t),i=r["offsetParent"in n.fn?"offsetParent":"parent"]();return i.length||(i=n("body")),parseInt(i.css("fontSize"),10)||parseInt(r.css("fontSize"),10)||16},getPageHeight:function(t){return n(t).height()},settings:{adjustOldDeltas:!0,normalizeOffset:!0}};n.fn.extend({mousewheel:function(n){return n?this.bind("mousewheel",n):this.trigger("mousewheel")},unmousewheel:function(n){return this.unbind("mousewheel",n)}})});!function(n){"function"==typeof define&&define.amd&&!1?define(["jquery"],n):"object"==typeof exports&&!1?module.exports=n:n(jQuery)}(function(n){function u(i){var u=i||window.event,p=c.call(arguments,1),l=0,s=0,o=0,a=0,w=0,b=0;if(i=n.event.fix(u),i.type="mousewheel","detail"in u&&(o=-1*u.detail),"wheelDelta"in u&&(o=u.wheelDelta),"wheelDeltaY"in u&&(o=u.wheelDeltaY),"wheelDeltaX"in u&&(s=-1*u.wheelDeltaX),"axis"in u&&u.axis===u.HORIZONTAL_AXIS&&(s=-1*o,o=0),l=0===o?s:o,"deltaY"in u&&(o=-1*u.deltaY,l=o),"deltaX"in u&&(s=u.deltaX,0===o&&(l=-1*s)),0!==o||0!==s){if(1===u.deltaMode){var v=n.data(this,"mousewheel-line-height");l*=v;o*=v;s*=v}else if(2===u.deltaMode){var y=n.data(this,"mousewheel-page-height");l*=y;o*=y;s*=y}if(a=Math.max(Math.abs(o),Math.abs(s)),(!t||t>a)&&(t=a,e(u,a)&&(t/=40)),e(u,a)&&(l/=40,s/=40,o/=40),l=Math[l>=1?"floor":"ceil"](l/t),s=Math[s>=1?"floor":"ceil"](s/t),o=Math[o>=1?"floor":"ceil"](o/t),r.settings.normalizeOffset&&this.getBoundingClientRect){var k=this.getBoundingClientRect();w=i.clientX-k.left;b=i.clientY-k.top}return i.deltaX=s,i.deltaY=o,i.deltaFactor=t,i.offsetX=w,i.offsetY=b,i.deltaMode=0,p.unshift(i,l,s,o),f&&clearTimeout(f),f=setTimeout(h,200),(n.event.dispatch||n.event.handle).apply(this,p)}}function h(){t=null}function e(n,t){return r.settings.adjustOldDeltas&&"mousewheel"===n.type&&t%120==0}var f,t,o=["wheel","mousewheel","DOMMouseScroll","MozMousePixelScroll"],i="onwheel"in document||document.documentMode>=9?["wheel"]:["mousewheel","DomMouseScroll","MozMousePixelScroll"],c=Array.prototype.slice;if(n.event.fixHooks)for(var s=o.length;s;)n.event.fixHooks[o[--s]]=n.event.mouseHooks;var r=n.event.special.mousewheel={version:"3.1.12",setup:function(){if(this.addEventListener)for(var t=i.length;t;)this.addEventListener(i[--t],u,!1);else this.onmousewheel=u;n.data(this,"mousewheel-line-height",r.getLineHeight(this));n.data(this,"mousewheel-page-height",r.getPageHeight(this))},teardown:function(){if(this.removeEventListener)for(var t=i.length;t;)this.removeEventListener(i[--t],u,!1);else this.onmousewheel=null;n.removeData(this,"mousewheel-line-height");n.removeData(this,"mousewheel-page-height")},getLineHeight:function(t){var r=n(t),i=r["offsetParent"in n.fn?"offsetParent":"parent"]();return i.length||(i=n("body")),parseInt(i.css("fontSize"),10)||parseInt(r.css("fontSize"),10)||16},getPageHeight:function(t){return n(t).height()},settings:{adjustOldDeltas:!0,normalizeOffset:!0}};n.fn.extend({mousewheel:function(n){return n?this.bind("mousewheel",n):this.trigger("mousewheel")},unmousewheel:function(n){return this.unbind("mousewheel",n)}})});typeof jQuery.fn.mCustScr=="undefined"?!function(n){"function"==typeof define&&define.amd&&!1?define(["jquery"],n):"undefined"!=typeof module&&!1&&module.exports?module.exports=n:n(jQuery,window,document)}(function(n){!function(t){var i="function"==typeof define&&define.amd&&!1,r="undefined"!=typeof module&&!1&&module.exports,u="https:"==document.location.protocol?"https:":"http:";i||(r?require("jquery-mousewheel")(n):n.event.special.mousewheel||n("head").append(decodeURI("%3Cscript src="+u+"//"+"cdnjs.cloudflare.com/ajax/libs/jquery-mousewheel/3.1.13/jquery.mousewheel.min.js"+"%3E%3C/script%3E")));t()}(function(){var h,c="mCustScr",t="mCSap",it=".mCustScr",ot={setTop:0,setLeft:0,axis:"y",scrollbarPosition:"inside",scrollInertia:950,autoDraggerLength:!0,alwaysShowScrollbar:0,snapOffset:0,mouseWheel:{enable:!0,scrollAmount:"auto",axis:"y",deltaFactor:"auto",disableOver:["select","option","keygen","datalist","textarea"]},scrollButtons:{scrollType:"stepless",scrollAmount:"auto"},keyboard:{enable:!0,scrollType:"stepless",scrollAmount:"auto"},contentTouchScroll:25,documentTouchScroll:!0,advanced:{autoScrollOnFocus:"input,textarea,select,button,datalist,keygen,a[tabindex],area,object,[contenteditable='true']",updateOnContentResize:!0,updateOnImageLoad:"auto",autoUpdateTimeout:60},theme:"light",callbacks:{onTotalScrollOffset:0,onTotalScrollBackOffset:0,alwaysTriggerOffsets:!0}},pt=0,b={},p=window.attachEvent&&!window.addEventListener?1:0,e=!1,i=["mCSBap_dragger_onDrag","mCSBap_scrollTools_onDrag","mCS_img_loaded","mCS_disabled","mCS_destroyed","mCS_no_scrollbar","mCS-autoHide","mCS-dir-rtl","mCS_no_scrollbar_y","mCS_no_scrollbar_x","mCS_y_hidden","mCS_x_hidden","mCSBap_draggerContainer","mCSBap_buttonUp","mCSBap_buttonDown","mCSBap_buttonLeft","mCSBap_buttonRight"],s={init:function(r){var r=n.extend(!0,{},ot,r),e=v.call(this);if(r.live){var u=r.liveSelector||this.selector||it,f=n(u);if("off"===r.live)return void k(u);b[u]=setTimeout(function(){f.mCustScr(r);"once"===r.live&&f.length&&k(u)},500)}else k(u);return r.setWidth=r.set_width?r.set_width:r.setWidth,r.setHeight=r.set_height?r.set_height:r.setHeight,r.axis=r.horizontalScroll?"x":wt(r.axis),r.scrollInertia=r.scrollInertia>0&&r.scrollInertia<17?17:r.scrollInertia,"object"!=typeof r.mouseWheel&&1==r.mouseWheel&&(r.mouseWheel={enable:!0,scrollAmount:"auto",axis:"y",preventDefault:!1,deltaFactor:"auto",normalizeDelta:!1,invert:!1}),r.mouseWheel.scrollAmount=r.mouseWheelPixels?r.mouseWheelPixels:r.mouseWheel.scrollAmount,r.mouseWheel.normalizeDelta=r.advanced.normalizeMouseWheelDelta?r.advanced.normalizeMouseWheelDelta:r.mouseWheel.normalizeDelta,r.scrollButtons.scrollType=bt(r.scrollButtons.scrollType),st(r),n(e).each(function(){var u=n(this);if(!u.data(t)){u.data(t,{idx:++pt,opt:r,scrollRatio:{y:null,x:null},overflowed:null,contentReset:{y:null,x:null},bindEvents:!1,tweenRunning:!1,sequential:{},langDir:u.css("direction"),cbOffsets:null,trigger:null,poll:{size:{o:0,n:0},img:{o:0,n:0},change:{o:0,n:0}}});var e=u.data(t),f=e.opt,o=u.data("mcs-axis"),h=u.data("mcs-scrollbar-position"),c=u.data("mcs-theme");o&&(f.axis=o);h&&(f.scrollbarPosition=h);c&&(f.theme=c,st(f));kt.call(this);e&&f.callbacks.onCreate&&"function"==typeof f.callbacks.onCreate&&f.callbacks.onCreate.call(this);n("#mCSBap_"+e.idx+"_container img:not(."+i[2]+")").addClass(i[2]);s.update.call(null,u)}})},update:function(r,f){var e=r||v.call(this);return n(e).each(function(){var s=n(this);if(s.data(t)){var e=s.data(t),r=e.opt,h=n("#mCSBap_"+e.idx+"_container"),a=n("#mCSBap_"+e.idx),c=[n("#mCSBap_"+e.idx+"_dragger_vertical"),n("#mCSBap_"+e.idx+"_dragger_horizontal")];if(!h.length)return;e.tweenRunning&&o(s);f&&e&&r.callbacks.onBeforeUpdate&&"function"==typeof r.callbacks.onBeforeUpdate&&r.callbacks.onBeforeUpdate.call(this);s.hasClass(i[3])&&s.removeClass(i[3]);s.hasClass(i[4])&&s.removeClass(i[4]);a.css("max-height","none");a.height()!==s.height()&&a.css("max-height",s.height());dt.call(this);"y"===r.axis||r.advanced.autoExpandHorizontalScroll||h.css("width",ht(h));e.overflowed=ii.call(this);ct.call(this);r.autoDraggerLength&&ni.call(this);ti.call(this);ri.call(this);var l=[Math.abs(h[0].offsetTop),Math.abs(h[0].offsetLeft)];"x"!==r.axis&&(e.overflowed[0]?c[0].height()>c[0].parent().height()?y.call(this):(u(s,l[0].toString(),{dir:"y",dur:0,overwrite:"none"}),e.contentReset.y=null):(y.call(this),"y"===r.axis?g.call(this):"yx"===r.axis&&e.overflowed[1]&&u(s,l[1].toString(),{dir:"x",dur:0,overwrite:"none"})));"y"!==r.axis&&(e.overflowed[1]?c[1].width()>c[1].parent().width()?y.call(this):(u(s,l[1].toString(),{dir:"x",dur:0,overwrite:"none"}),e.contentReset.x=null):(y.call(this),"x"===r.axis?g.call(this):"yx"===r.axis&&e.overflowed[0]&&u(s,l[0].toString(),{dir:"y",dur:0,overwrite:"none"})));f&&e&&(2===f&&r.callbacks.onImageLoad&&"function"==typeof r.callbacks.onImageLoad?r.callbacks.onImageLoad.call(this):3===f&&r.callbacks.onSelectorChange&&"function"==typeof r.callbacks.onSelectorChange?r.callbacks.onSelectorChange.call(this):r.callbacks.onUpdate&&"function"==typeof r.callbacks.onUpdate&&r.callbacks.onUpdate.call(this));et.call(this)}})},scrollTo:function(i,r){if("undefined"!=typeof i&&null!=i){var f=v.call(this);return n(f).each(function(){var s=n(this);if(s.data(t)){var o=s.data(t),h=o.opt,c={trigger:"external",scrollInertia:h.scrollInertia,scrollEasing:"mcsEaseInOut",moveDragger:!1,timeout:60,callbacks:!0,onStart:!0,onUpdate:!0,onComplete:!0},f=n.extend(!0,{},c,r),e=ft.call(this,i),l=f.scrollInertia>0&&f.scrollInertia<17?17:f.scrollInertia;e[0]=at.call(this,e[0],"y");e[1]=at.call(this,e[1],"x");f.moveDragger&&(e[0]*=o.scrollRatio.y,e[1]*=o.scrollRatio.x);f.dur=wi()?0:l;setTimeout(function(){null!==e[0]&&"undefined"!=typeof e[0]&&"x"!==h.axis&&o.overflowed[0]&&(f.dir="y",f.overwrite="all",u(s,e[0].toString(),f));null!==e[1]&&"undefined"!=typeof e[1]&&"y"!==h.axis&&o.overflowed[1]&&(f.dir="x",f.overwrite="none",u(s,e[1].toString(),f))},f.timeout)}})}},stop:function(){var i=v.call(this);return n(i).each(function(){var i=n(this);i.data(t)&&o(i)})},disable:function(r){var u=v.call(this);return n(u).each(function(){var u=n(this);u.data(t)&&(u.data(t),et.call(this,"remove"),g.call(this),r&&y.call(this),ct.call(this,!0),u.addClass(i[3]))})},destroy:function(){var r=v.call(this);return n(r).each(function(){var f=n(this);if(f.data(t)){var u=f.data(t),e=u.opt,s=n("#mCSBap_"+u.idx),o=n("#mCSBap_"+u.idx+"_container"),h=n(".mCSBap_"+u.idx+"_scrollbar");e.live&&k(e.liveSelector||n(r).selector);et.call(this,"remove");g.call(this);y.call(this);f.removeData(t);a(this,"mcs");h.remove();o.find("img."+i[2]).removeClass(i[2]);s.replaceWith(o.contents());f.removeClass(c+" _"+t+"_"+u.idx+" "+i[6]+" "+i[7]+" "+i[5]+" "+i[3]).addClass(i[4])}})}},v=function(){return"object"!=typeof n(this)||n(this).length<1?it:this},st=function(t){t.autoDraggerLength=n.inArray(t.theme,["rounded","rounded-dark","rounded-dots","rounded-dots-dark"])>-1?!1:t.autoDraggerLength;t.autoExpandScrollbar=n.inArray(t.theme,["rounded-dots","rounded-dots-dark","3d","3d-dark","3d-thick","3d-thick-dark","inset","inset-dark","inset-2","inset-2-dark","inset-3","inset-3-dark"])>-1?!1:t.autoExpandScrollbar;t.scrollButtons.enable=n.inArray(t.theme,["minimal","minimal-dark"])>-1?!1:t.scrollButtons.enable;t.autoHideScrollbar=n.inArray(t.theme,["minimal","minimal-dark"])>-1?!0:t.autoHideScrollbar;t.scrollbarPosition=n.inArray(t.theme,["minimal","minimal-dark"])>-1?"outside":t.scrollbarPosition},k=function(n){b[n]&&(clearTimeout(b[n]),a(b,n))},wt=function(n){return"yx"===n||"xy"===n||"auto"===n?"yx":"x"===n||"horizontal"===n?"x":"y"},bt=function(n){return"stepped"===n||"pixels"===n||"step"===n||"click"===n?"stepped":"stepless"},kt=function(){var f=n(this),u=f.data(t),r=u.opt,h=r.autoExpandScrollbar?" "+i[1]+"_expand":"",e=["<div id='mCSBap_"+u.idx+"_scrollbar_vertical' class='mCSBap_scrollTools mCSBap_"+u.idx+"_scrollbar mCS-"+r.theme+" mCSBap_scrollTools_vertical"+h+"'><div class='"+i[12]+"'><div id='mCSBap_"+u.idx+"_dragger_vertical' class='mCSBap_dragger' style='position:absolute;'><div class='mCSBap_dragger_bar' /><\/div><div class='mCSBap_draggerRail' /><\/div><\/div>","<div id='mCSBap_"+u.idx+"_scrollbar_horizontal' class='mCSBap_scrollTools mCSBap_"+u.idx+"_scrollbar mCS-"+r.theme+" mCSBap_scrollTools_horizontal"+h+"'><div class='"+i[12]+"'><div id='mCSBap_"+u.idx+"_dragger_horizontal' class='mCSBap_dragger' style='position:absolute;'><div class='mCSBap_dragger_bar' /><\/div><div class='mCSBap_draggerRail' /><\/div><\/div>"],v="yx"===r.axis?"mCSBap_vertical_horizontal":"x"===r.axis?"mCSBap_horizontal":"mCSBap_vertical",l="yx"===r.axis?e[0]+e[1]:"x"===r.axis?e[1]:e[0],y="yx"===r.axis?"<div id='mCSBap_"+u.idx+"_container_wrapper' class='mCSBap_container_wrapper' />":"",p=r.autoHideScrollbar?" "+i[6]:"",w="x"!==r.axis&&"rtl"===u.langDir?" "+i[7]:"";r.setWidth&&f.css("width",r.setWidth);r.setHeight&&f.css("height",r.setHeight);r.setLeft="y"!==r.axis&&"rtl"===u.langDir?"989999px":r.setLeft;f.addClass(c+" _"+t+"_"+u.idx+p+w).wrapInner("<div id='mCSBap_"+u.idx+"' class='mCustomScrollBox mCS-"+r.theme+" "+v+"'><div id='mCSBap_"+u.idx+"_container' class='mCSBap_container' style='position:relative; top:"+r.setTop+"; left:"+r.setLeft+";' dir='"+u.langDir+"' /><\/div>");var a=n("#mCSBap_"+u.idx),s=n("#mCSBap_"+u.idx+"_container");"y"===r.axis||r.advanced.autoExpandHorizontalScroll||s.css("width",ht(s));"outside"===r.scrollbarPosition?("static"===f.css("position")&&f.css("position","relative"),f.css("overflow","visible"),a.addClass("mCSBap_outside").after(l)):(a.addClass("mCSBap_inside").append(l),s.wrap(y));gt.call(this);var o=[n("#mCSBap_"+u.idx+"_dragger_vertical"),n("#mCSBap_"+u.idx+"_dragger_horizontal")];o[0].css("min-height",o[0].height());o[1].css("min-width",o[1].width())},ht=function(t){var i=[t[0].scrollWidth,Math.max.apply(Math,t.children().map(function(){return n(this).outerWidth(!0)}).get())],r=t.parent().width();return i[0]>r?i[0]:i[1]>r?i[1]:"100%"},dt=function(){var e=n(this),u=e.data(t),r=u.opt,i=n("#mCSBap_"+u.idx+"_container");if(r.advanced.autoExpandHorizontalScroll&&"y"!==r.axis){i.css({width:"auto","min-width":0,"overflow-x":"scroll"});var f=Math.ceil(i[0].scrollWidth);3===r.advanced.autoExpandHorizontalScroll||2!==r.advanced.autoExpandHorizontalScroll&&f>i.parent().width()?i.css({width:f,"min-width":"100%","overflow-x":"inherit"}):i.css({"overflow-x":"inherit",position:"absolute"}).wrap("<div class='mCSBap_h_wrapper' style='position:relative; left:0; width:999999px;' />").css({width:Math.ceil(i[0].getBoundingClientRect().right+.4)-Math.floor(i[0].getBoundingClientRect().left),"min-width":"100%",position:"relative"}).unwrap()}},gt=function(){var s=n(this),o=s.data(t),u=o.opt,h=n(".mCSBap_"+o.idx+"_scrollbar:first"),f=tt(u.scrollButtons.tabindex)?"tabindex='"+u.scrollButtons.tabindex+"'":"",r=["<a href='#' class='"+i[13]+"' "+f+" />","<a href='#' class='"+i[14]+"' "+f+" />","<a href='#' class='"+i[15]+"' "+f+" />","<a href='#' class='"+i[16]+"' "+f+" />"],e=["x"===u.axis?r[2]:r[0],"x"===u.axis?r[3]:r[1],r[2],r[3]];u.scrollButtons.enable&&h.prepend(e[0]).append(e[1]).next(".mCSBap_scrollTools").prepend(e[2]).append(e[3])},ni=function(){var s=n(this),u=s.data(t),f=n("#mCSBap_"+u.idx),e=n("#mCSBap_"+u.idx+"_container"),r=[n("#mCSBap_"+u.idx+"_dragger_vertical"),n("#mCSBap_"+u.idx+"_dragger_horizontal")],o=[f.height()/e.outerHeight(!1),f.width()/e.outerWidth(!1)],i=[parseInt(r[0].css("min-height")),Math.round(o[0]*r[0].parent().height()),parseInt(r[1].css("min-width")),Math.round(o[1]*r[1].parent().width())],h=p&&i[1]<i[0]?i[0]:i[1],c=p&&i[3]<i[2]?i[2]:i[3];r[0].css({height:h,"max-height":r[0].parent().height()-10}).find(".mCSBap_dragger_bar").css({"line-height":i[0]+"px"});r[1].css({width:c,"max-width":r[1].parent().width()-10})},ti=function(){var s=n(this),i=s.data(t),u=n("#mCSBap_"+i.idx),f=n("#mCSBap_"+i.idx+"_container"),r=[n("#mCSBap_"+i.idx+"_dragger_vertical"),n("#mCSBap_"+i.idx+"_dragger_horizontal")],e=[f.outerHeight(!1)-u.height(),f.outerWidth(!1)-u.width()],o=[e[0]/(r[0].parent().height()-r[0].height()),e[1]/(r[1].parent().width()-r[1].width())];i.scrollRatio={y:o[0],x:o[1]}},d=function(n,t,r){var f=r?i[0]+"_expanded":"",u=n.closest(".mCSBap_scrollTools");"active"===t?(n.toggleClass(i[0]+" "+f),u.toggleClass(i[1]),n[0]._draggable=n[0]._draggable?0:1):n[0]._draggable||("hide"===t?(n.removeClass(i[0]),u.removeClass(i[1])):(n.addClass(i[0]),u.addClass(i[1])))},ii=function(){var h=n(this),r=h.data(t),e=n("#mCSBap_"+r.idx),i=n("#mCSBap_"+r.idx+"_container"),u=null==r.overflowed?i.height():i.outerHeight(!1),f=null==r.overflowed?i.width():i.outerWidth(!1),o=i[0].scrollHeight,s=i[0].scrollWidth;return o>u&&(u=o),s>f&&(f=s),[u>e.height(),f>e.width()]},y=function(){var r=n(this),i=r.data(t),f=i.opt,c=n("#mCSBap_"+i.idx),e=n("#mCSBap_"+i.idx+"_container"),h=[n("#mCSBap_"+i.idx+"_dragger_vertical"),n("#mCSBap_"+i.idx+"_dragger_horizontal")];if(o(r),("x"!==f.axis&&!i.overflowed[0]||"y"===f.axis&&i.overflowed[0])&&(h[0].add(e).css("top",0),u(r,"_resetY")),"y"!==f.axis&&!i.overflowed[1]||"x"===f.axis&&i.overflowed[1]){var s=dx=0;"rtl"===i.langDir&&(s=c.width()-e.outerWidth(!1),dx=Math.abs(s/i.scrollRatio.x));e.css("left",s);h[1].css("left",dx);u(r,"_resetX")}},ri=function(){function u(){e=setTimeout(function(){n.event.special.mousewheel?(clearTimeout(e),oi.call(f[0])):u()},100)}var f=n(this),r=f.data(t),i=r.opt;if(!r.bindEvents){if(ui.call(this),i.contentTouchScroll&&fi.call(this),ei.call(this),i.mouseWheel.enable){var e;u()}hi.call(this);li.call(this);i.advanced.autoScrollOnFocus&&ci.call(this);i.scrollButtons.enable&&ai.call(this);i.keyboard.enable&&vi.call(this);r.bindEvents=!0}},g=function(){var f=n(this),r=f.data(t),u=r.opt,o=t+"_"+r.idx,s=".mCSBap_"+r.idx+"_scrollbar",e=n("#mCSBap_"+r.idx+",#mCSBap_"+r.idx+"_container,#mCSBap_"+r.idx+"_container_wrapper,"+s+" ."+i[12]+",#mCSBap_"+r.idx+"_dragger_vertical,#mCSBap_"+r.idx+"_dragger_horizontal,"+s+">a"),h=n("#mCSBap_"+r.idx+"_container");u.advanced.releaseDraggableSelectors&&e.add(n(u.advanced.releaseDraggableSelectors));u.advanced.extraDraggableSelectors&&e.add(n(u.advanced.extraDraggableSelectors));r.bindEvents&&(n(document).add(n(!l()||top.document)).unbind("."+o),e.each(function(){n(this).unbind("."+o)}),clearTimeout(f[0]._focusTimeout),a(f[0],"_focusTimeout"),clearTimeout(r.sequential.step),a(r.sequential,"step"),clearTimeout(h[0].onCompleteTimeout),a(h[0],"onCompleteTimeout"),r.bindEvents=!1)},ct=function(r){var h=n(this),u=h.data(t),o=u.opt,c=n("#mCSBap_"+u.idx+"_container_wrapper"),f=c.length?c:n("#mCSBap_"+u.idx+"_container"),e=[n("#mCSBap_"+u.idx+"_scrollbar_vertical"),n("#mCSBap_"+u.idx+"_scrollbar_horizontal")],s=[e[0].find(".mCSBap_dragger"),e[1].find(".mCSBap_dragger")];"x"!==o.axis&&(u.overflowed[0]&&!r?(e[0].add(s[0]).add(e[0].children("a")).css("display","block"),f.removeClass(i[8]+" "+i[10])):(o.alwaysShowScrollbar?(2!==o.alwaysShowScrollbar&&s[0].css("display","none"),f.removeClass(i[10])):(e[0].css("display","none"),f.addClass(i[10])),f.addClass(i[8])));"y"!==o.axis&&(u.overflowed[1]&&!r?(e[1].add(s[1]).add(e[1].children("a")).css("display","block"),f.removeClass(i[9]+" "+i[11])):(o.alwaysShowScrollbar?(2!==o.alwaysShowScrollbar&&s[1].css("display","none"),f.removeClass(i[11])):(e[1].css("display","none"),f.addClass(i[11])),f.addClass(i[9])));u.overflowed[0]||u.overflowed[1]?h.removeClass(i[5]):h.addClass(i[5])},r=function(t){var e=t.type,i=t.target.ownerDocument!==document&&null!==frameElement?[n(frameElement).offset().top,n(frameElement).offset().left]:null,r=l()&&t.target.ownerDocument!==top.document&&null!==frameElement?[n(t.view.frameElement).offset().top,n(t.view.frameElement).offset().left]:[0,0];switch(e){case"pointerdown":case"MSPointerDown":case"pointermove":case"MSPointerMove":case"pointerup":case"MSPointerUp":return i?[t.originalEvent.pageY-i[0]+r[0],t.originalEvent.pageX-i[1]+r[1],!1]:[t.originalEvent.pageY,t.originalEvent.pageX,!1];case"touchstart":case"touchmove":case"touchend":var u=t.originalEvent.touches[0]||t.originalEvent.changedTouches[0],f=t.originalEvent.touches.length||t.originalEvent.changedTouches.length;return t.target.ownerDocument!==document?[u.screenY,u.screenX,f>1]:[u.pageY,u.pageX,f>1];default:return i?[t.pageY-i[0]+r[0],t.pageX-i[1]+r[1],!1]:[t.pageY,t.pageX,!1]}},ui=function(){function k(n,t,r,f){if(w[0].idleTimer=h.scrollInertia<233?250:0,i.attr("id")===y[1])var e="x",o=(i[0].offsetLeft-t+f)*s.scrollRatio.x;else var e="y",o=(i[0].offsetTop-n+r)*s.scrollRatio.y;u(v,o.toString(),{dir:e,drag:!0})}var i,c,a,v=n(this),s=v.data(t),h=s.opt,f=t+"_"+s.idx,y=["mCSBap_"+s.idx+"_dragger_vertical","mCSBap_"+s.idx+"_dragger_horizontal"],w=n("#mCSBap_"+s.idx+"_container"),b=n("#"+y[0]+",#"+y[1]),g=h.advanced.releaseDraggableSelectors?b.add(n(h.advanced.releaseDraggableSelectors)):b,nt=h.advanced.extraDraggableSelectors?n(!l()||top.document).add(n(h.advanced.extraDraggableSelectors)):n(!l()||top.document);b.bind("contextmenu."+f,function(n){n.preventDefault()}).bind("mousedown."+f+" touchstart."+f+" pointerdown."+f+" MSPointerDown."+f,function(t){if(t.stopImmediatePropagation(),t.preventDefault(),yt(t)){e=!0;p&&(document.onselectstart=function(){return!1});lt.call(w,!1);o(v);i=n(this);var u=i.offset(),f=r(t)[0]-u.top,s=r(t)[1]-u.left,l=i.height()+u.top,y=i.width()+u.left;l>f&&f>0&&y>s&&s>0&&(c=f,a=s);d(i,"active",h.autoExpandScrollbar)}}).bind("touchmove."+f,function(n){n.stopImmediatePropagation();n.preventDefault();var t=i.offset(),u=r(n)[0]-t.top,f=r(n)[1]-t.left;k(c,a,u,f)});n(document).add(nt).bind("mousemove."+f+" pointermove."+f+" MSPointerMove."+f,function(n){if(i){var t=i.offset(),u=r(n)[0]-t.top,f=r(n)[1]-t.left;if(c===u&&a===f)return;k(c,a,u,f)}}).add(g).bind("mouseup."+f+" touchend."+f+" pointerup."+f+" MSPointerUp."+f,function(){i&&(d(i,"active",h.autoExpandScrollbar),i=null);e=!1;p&&(document.onselectstart=null);lt.call(w,!0)})},fi=function(){function at(n){if(!nt(n)||e||r(n)[2])return void(h=0);h=1;it=0;rt=0;st=1;g.removeClass("mCS_touch_action");var t=b.offset();k=r(n)[0]-t.top;d=r(n)[1]-t.left;v=[r(n)[0],r(n)[1]]}function vt(n){if(nt(n)&&!e&&!r(n)[2]&&(f.documentTouchScroll||n.preventDefault(),n.stopImmediatePropagation(),(!rt||it)&&st)){gt=w();var o=ut.offset(),t=r(n)[0]-o.top,u=r(n)[1]-o.left,h="mcsLinearOut";if(et.push(t),ot.push(u),v[2]=Math.abs(r(n)[0]-v[0]),v[3]=Math.abs(r(n)[1]-v[1]),i.overflowed[0])var c=ft[0].parent().height()-ft[0].height(),l=k-t>0&&t-k>-(c*i.scrollRatio.y)&&(2*v[3]<v[2]||"yx"===f.axis);if(i.overflowed[1])var a=ft[1].parent().width()-ft[1].width(),y=d-u>0&&u-d>-(a*i.scrollRatio.x)&&(2*v[2]<v[3]||"yx"===f.axis);l||y?(ii||n.preventDefault(),it=1):(rt=1,g.addClass("mCS_touch_action"));ii&&n.preventDefault();s="yx"===f.axis?[k-t,d-u]:"x"===f.axis?[null,d-u]:[k-t,null];b[0].idleTimer=250;i.overflowed[0]&&tt(s[0],ni,h,"y","all",!0);i.overflowed[1]&&tt(s[1],ni,h,"x",lt,!0)}}function yt(n){if(!nt(n)||e||r(n)[2])return void(h=0);h=1;n.stopImmediatePropagation();o(g);dt=w();var t=ut.offset();bt=r(n)[0]-t.top;kt=r(n)[1]-t.left;et=[];ot=[]}function pt(n){if(nt(n)&&!e&&!r(n)[2]){st=0;n.stopImmediatePropagation();it=0;rt=0;ht=w();var h=ut.offset(),l=r(n)[0]-h.top,a=r(n)[1]-h.left;if(!(ht-gt>30)){c=1e3/(ht-dt);var v="mcsEaseOut",o=2.5>c,p=o?[et[et.length-2],ot[ot.length-2]]:[0,0];y=o?[l-p[0],a-p[1]]:[l-bt,a-kt];var t=[Math.abs(y[0]),Math.abs(y[1])];c=o?[Math.abs(y[0]/4),Math.abs(y[1]/4)]:[c,c];var u=[Math.abs(b[0].offsetTop)-y[0]*wt(t[0]/c[0],c[0]),Math.abs(b[0].offsetLeft)-y[1]*wt(t[1]/c[1],c[1])];s="yx"===f.axis?[u[0],u[1]]:"x"===f.axis?[null,u[1]]:[u[0],null];ct=[4*t[0]+f.scrollInertia,4*t[1]+f.scrollInertia];var k=parseInt(f.contentTouchScroll)||0;s[0]=t[0]>k?s[0]:0;s[1]=t[1]>k?s[1]:0;i.overflowed[0]&&tt(s[0],ct[0],v,"y",lt,!1);i.overflowed[1]&&tt(s[1],ct[1],v,"x",lt,!1)}}}function wt(n,t){var i=[1.5*t,2*t,t/1.5,t/2];return n>90?t>4?i[0]:i[3]:n>60?t>3?i[3]:i[2]:n>30?t>8?i[1]:t>6?i[0]:t>4?t:i[2]:t>8?t:i[3]}function tt(n,t,i,r,f,e){n&&u(g,n.toString(),{dur:t,scrollEasing:i,dir:r,overwrite:f,drag:e})}var st,k,d,bt,kt,dt,gt,ht,y,c,s,ct,it,rt,g=n(this),i=g.data(t),f=i.opt,a=t+"_"+i.idx,ut=n("#mCSBap_"+i.idx),b=n("#mCSBap_"+i.idx+"_container"),ft=[n("#mCSBap_"+i.idx+"_dragger_vertical"),n("#mCSBap_"+i.idx+"_dragger_horizontal")],et=[],ot=[],ni=0,lt="yx"===f.axis?"none":"all",v=[],ti=b.find("iframe"),p=["touchstart."+a+" pointerdown."+a+" MSPointerDown."+a,"touchmove."+a+" pointermove."+a+" MSPointerMove."+a,"touchend."+a+" pointerup."+a+" MSPointerUp."+a],ii=void 0!==document.body.style.touchAction&&""!==document.body.style.touchAction;b.bind(p[0],function(n){at(n)}).bind(p[1],function(n){vt(n)});ut.bind(p[0],function(n){yt(n)}).bind(p[2],function(n){pt(n)});ti.length&&ti.each(function(){n(this).bind("load",function(){l(this)&&n(this.contentDocument||this.contentWindow.document).bind(p[0],function(n){at(n);yt(n)}).bind(p[1],function(n){vt(n)}).bind(p[2],function(n){pt(n)})})})},ei=function(){function y(){return window.getSelection?window.getSelection().toString():document.selection&&"Control"!=document.selection.type?document.selection.createRange().text:0}function i(n,t,i){l.type=i&&u?"stepped":"stepless";l.scrollAmount=10;ut(a,n,t,"mcsLinearOut",i?60:null)}var u,a=n(this),f=a.data(t),v=f.opt,l=f.sequential,s=t+"_"+f.idx,o=n("#mCSBap_"+f.idx+"_container"),c=o.parent();o.bind("mousedown."+s,function(){h||u||(u=1,e=!0)}).add(document).bind("mousemove."+s,function(n){if(!h&&u&&y()){var s=o.offset(),t=r(n)[0]-s.top+o[0].offsetTop,e=r(n)[1]-s.left+o[0].offsetLeft;t>0&&t<c.height()&&e>0&&e<c.width()?l.step&&i("off",null,"stepped"):("x"!==v.axis&&f.overflowed[0]&&(0>t?i("on",38):t>c.height()&&i("on",40)),"y"!==v.axis&&f.overflowed[1]&&(0>e?i("on",37):e>c.width()&&i("on",39)))}}).bind("mouseup."+s+" dragend."+s,function(){h||(u&&(u=0,i("off",null)),e=!1)})},oi=function(){function h(t,h){if(o(s),!si(s,t.target)){var v="auto"!==i.mouseWheel.deltaFactor?parseInt(i.mouseWheel.deltaFactor):p&&t.deltaFactor<100?100:t.deltaFactor||100,y=i.scrollInertia;if("x"===i.axis||"x"===i.mouseWheel.axis)var a="x",l=[Math.round(v*r.scrollRatio.x),parseInt(i.mouseWheel.scrollAmount)],w="auto"!==i.mouseWheel.scrollAmount?l[1]:l[0]>=e.width()?.9*e.width():l[0],k=Math.abs(n("#mCSBap_"+r.idx+"_container")[0].offsetLeft),b=f[1][0].offsetLeft,d=f[1].parent().width()-f[1].width(),c="y"===i.mouseWheel.axis?t.deltaY||h:t.deltaX;else var a="y",l=[Math.round(v*r.scrollRatio.y),parseInt(i.mouseWheel.scrollAmount)],w="auto"!==i.mouseWheel.scrollAmount?l[1]:l[0]>=e.height()?.9*e.height():l[0],k=Math.abs(n("#mCSBap_"+r.idx+"_container")[0].offsetTop),b=f[0][0].offsetTop,d=f[0].parent().height()-f[0].height(),c=t.deltaY||h;("y"!==a||r.overflowed[0])&&("x"!==a||r.overflowed[1])&&((i.mouseWheel.invert||t.webkitDirectionInvertedFromDevice)&&(c=-c),i.mouseWheel.normalizeDelta&&(c=0>c?-1:1),(c>0&&0!==b||0>c&&b!==d||i.mouseWheel.preventDefault)&&(t.stopImmediatePropagation(),t.preventDefault()),t.deltaFactor<5&&!i.mouseWheel.normalizeDelta&&(w=t.deltaFactor,y=17),u(s,(k-c*w).toString(),{dir:a,dur:y}))}}if(n(this).data(t)){var s=n(this),r=s.data(t),i=r.opt,c=t+"_"+r.idx,e=n("#mCSBap_"+r.idx),f=[n("#mCSBap_"+r.idx+"_dragger_vertical"),n("#mCSBap_"+r.idx+"_dragger_horizontal")],a=n("#mCSBap_"+r.idx+"_container").find("iframe");a.length&&a.each(function(){n(this).bind("load",function(){l(this)&&n(this.contentDocument||this.contentWindow.document).bind("mousewheel."+c,function(n,t){h(n,t)})})});e.bind("mousewheel."+c,function(n,t){h(n,t)})}},rt={},l=function(t){var r=!1,i=!1,u=null;if(void 0===t?i="#empty":void 0!==n(t).attr("id")&&(i=n(t).attr("id")),i!==!1&&void 0!==rt[i])return rt[i];if(t){try{var f=t.contentDocument||t.contentWindow.document;u=f.body.innerHTML}catch(e){}r=null!==u}else{try{var f=top.document;u=f.body.innerHTML}catch(e){}r=null!==u}return i!==!1&&(rt[i]=r),r},lt=function(n){var t=this.find("iframe");if(t.length){var i=n?"auto":"none";t.css("pointer-events",i)}},si=function(i,r){var u=r.nodeName.toLowerCase(),f=i.data(t).opt.mouseWheel.disableOver;return n.inArray(u,f)>-1&&!(n.inArray(u,["select","textarea"])>-1&&!n(r).is(":focus"))},hi=function(){var s,h=n(this),f=h.data(t),r=t+"_"+f.idx,c=n("#mCSBap_"+f.idx+"_container"),l=c.parent(),a=n(".mCSBap_"+f.idx+"_scrollbar ."+i[12]);a.bind("mousedown."+r+" touchstart."+r+" pointerdown."+r+" MSPointerDown."+r,function(t){e=!0;n(t.target).hasClass("mCSBap_dragger")||(s=1)}).bind("touchend."+r+" pointerup."+r+" MSPointerUp."+r,function(){e=!1}).bind("click."+r,function(t){if(s&&(s=0,n(t.target).hasClass(i[12])||n(t.target).hasClass("mCSBap_draggerRail"))){o(h);var r=n(this),e=r.find(".mCSBap_dragger");if(r.parent(".mCSBap_scrollTools_horizontal").length>0){if(!f.overflowed[1])return;var v="x",a=t.pageX>e.offset().left?-1:1,y=Math.abs(c[0].offsetLeft)-a*.9*l.width()}else{if(!f.overflowed[0])return;var v="y",a=t.pageY>e.offset().top?-1:1,y=Math.abs(c[0].offsetTop)-a*.9*l.height()}u(h,y.toString(),{dir:v,scrollEasing:"mcsEaseInOut"})}})},ci=function(){var i=n(this),s=i.data(t),e=s.opt,c=t+"_"+s.idx,r=n("#mCSBap_"+s.idx+"_container"),h=r.parent();r.bind("focusin."+c,function(){var t=n(document.activeElement),c=r.find(".mCustomScrollBox").length,s=0;t.is(e.advanced.autoScrollOnFocus)&&(o(i),clearTimeout(i[0]._focusTimeout),i[0]._focusTimer=c?(s+17)*c:0,i[0]._focusTimeout=setTimeout(function(){var n=[f(t)[0],f(t)[1]],o=[r[0].offsetTop,r[0].offsetLeft],c=[o[0]+n[0]>=0&&o[0]+n[0]<h.height()-t.outerHeight(!1),o[1]+n[1]>=0&&o[0]+n[1]<h.width()-t.outerWidth(!1)],l="yx"!==e.axis||c[0]||c[1]?"all":"none";"x"===e.axis||c[0]||u(i,n[0].toString(),{dir:"y",scrollEasing:"mcsEaseInOut",overwrite:l,dur:s});"y"===e.axis||c[1]||u(i,n[1].toString(),{dir:"x",scrollEasing:"mcsEaseInOut",overwrite:l,dur:s})},i[0]._focusTimer))})},li=function(){var u=n(this),i=u.data(t),f=t+"_"+i.idx,r=n("#mCSBap_"+i.idx+"_container").parent();r.bind("scroll."+f,function(){0===r.scrollTop()&&0===r.scrollLeft()||n(".mCSBap_"+i.idx+"_scrollbar").css("visibility","hidden")})},ai=function(){var f=n(this),r=f.data(t),o=r.opt,u=r.sequential,i=t+"_"+r.idx,s=".mCSBap_"+r.idx+"_scrollbar",h=n(s+">a");h.bind("contextmenu."+i,function(n){n.preventDefault()}).bind("mousedown."+i+" touchstart."+i+" pointerdown."+i+" MSPointerDown."+i+" mouseup."+i+" touchend."+i+" pointerup."+i+" MSPointerUp."+i+" mouseout."+i+" pointerout."+i+" MSPointerOut."+i+" click."+i,function(t){function i(n,t){u.scrollAmount=o.scrollButtons.scrollAmount;ut(f,n,t)}if(t.preventDefault(),yt(t)){var s=n(this).attr("class");switch(u.type=o.scrollButtons.scrollType,t.type){case"mousedown":case"touchstart":case"pointerdown":case"MSPointerDown":if("stepped"===u.type)return;e=!0;r.tweenRunning=!1;i("on",s);break;case"mouseup":case"touchend":case"pointerup":case"MSPointerUp":case"mouseout":case"pointerout":case"MSPointerOut":if("stepped"===u.type)return;e=!1;u.dir&&i("off",s);break;case"click":if("stepped"!==u.type||r.tweenRunning)return;i("on",s)}}})},vi=function(){function a(t){function l(n,t){s.type=r.keyboard.scrollType;s.scrollAmount=r.keyboard.scrollAmount;"stepped"===s.type&&i.tweenRunning||ut(e,n,t)}switch(t.type){case"blur":i.tweenRunning&&s.dir&&l("off",null);break;case"keydown":case"keyup":var c=t.keyCode?t.keyCode:t.which,a="on";if("x"!==r.axis&&(38===c||40===c)||"y"!==r.axis&&(37===c||39===c)){if((38===c||40===c)&&!i.overflowed[0]||(37===c||39===c)&&!i.overflowed[1])return;"keyup"===t.type&&(a="off");n(document.activeElement).is(v)||(t.preventDefault(),t.stopImmediatePropagation(),l(a,c))}else if(33===c||34===c){if((i.overflowed[0]||i.overflowed[1])&&(t.preventDefault(),t.stopImmediatePropagation()),"keyup"===t.type){o(e);var y=34===c?-1:1;if("x"===r.axis||"yx"===r.axis&&i.overflowed[1]&&!i.overflowed[0])var p="x",w=Math.abs(f[0].offsetLeft)-y*.9*h.width();else var p="y",w=Math.abs(f[0].offsetTop)-y*.9*h.height();u(e,w.toString(),{dir:p,scrollEasing:"mcsEaseInOut"})}}else if((35===c||36===c)&&!n(document.activeElement).is(v)&&((i.overflowed[0]||i.overflowed[1])&&(t.preventDefault(),t.stopImmediatePropagation()),"keyup"===t.type)){if("x"===r.axis||"yx"===r.axis&&i.overflowed[1]&&!i.overflowed[0])var p="x",w=35===c?Math.abs(h.width()-f.outerWidth(!1)):0;else var p="y",w=35===c?Math.abs(h.height()-f.outerHeight(!1)):0;u(e,w.toString(),{dir:p,scrollEasing:"mcsEaseInOut"})}}}var e=n(this),i=e.data(t),r=i.opt,s=i.sequential,c=t+"_"+i.idx,w=n("#mCSBap_"+i.idx),f=n("#mCSBap_"+i.idx+"_container"),h=f.parent(),v="input,textarea,select,datalist,keygen,[contenteditable='true']",y=f.find("iframe"),p=["blur."+c+" keydown."+c+" keyup."+c];y.length&&y.each(function(){n(this).bind("load",function(){l(this)&&n(this.contentDocument||this.contentWindow.document).bind(p[0],function(n){a(n)})})});w.attr("tabindex","0").bind(p[0],function(n){a(n)})},ut=function(r,f,e,s,h){function y(n){l.snapAmount&&(c.scrollAmount=l.snapAmount instanceof Array?"x"===c.dir[0]?l.snapAmount[1]:l.snapAmount[0]:l.snapAmount);var i="stepped"!==c.type,f=h?h:n?i?k/1.5:d:1e3/60,e=n?i?7.5:40:2.5,t=[Math.abs(p[0].offsetTop),Math.abs(p[0].offsetLeft)],o=[v.scrollRatio.y>10?10:v.scrollRatio.y,v.scrollRatio.x>10?10:v.scrollRatio.x],w="x"===c.dir[0]?t[1]+c.dir[1]*o[1]*e:t[0]+c.dir[1]*o[0]*e,b="x"===c.dir[0]?t[1]+c.dir[1]*parseInt(c.scrollAmount):t[0]+c.dir[1]*parseInt(c.scrollAmount),a="auto"!==c.scrollAmount?b:w,g=s?s:n?i?"mcsLinearOut":"mcsEaseInOut":"mcsLinear",nt=!!n;return n&&17>f&&(a="x"===c.dir[0]?t[1]:t[0]),u(r,a.toString(),{dir:c.dir[0],scrollEasing:g,dur:f,onComplete:nt}),n?void(c.dir=!1):(clearTimeout(c.step),void(c.step=setTimeout(function(){y()},f)))}function b(){clearTimeout(c.step);a(c,"step");o(r)}var v=r.data(t),l=v.opt,c=v.sequential,p=n("#mCSBap_"+v.idx+"_container"),w="stepped"===c.type,k=l.scrollInertia<26?26:l.scrollInertia,d=l.scrollInertia<1?17:l.scrollInertia;switch(f){case"on":if(c.dir=[e===i[16]||e===i[15]||39===e||37===e?"x":"y",e===i[13]||e===i[15]||38===e||37===e?-1:1],o(r),tt(e)&&"stepped"===c.type)return;y(w);break;case"off":b();(w||v.tweenRunning&&c.dir)&&y(!0)}},ft=function(i){var u=n(this).data(t).opt,r=[];return"function"==typeof i&&(i=i()),i instanceof Array?r=i.length>1?[i[0],i[1]]:"x"===u.axis?[null,i[0]]:[i[0],null]:(r[0]=i.y?i.y:i.x||"x"===u.axis?null:i,r[1]=i.x?i.x:i.y||"y"===u.axis?null:i),"function"==typeof r[0]&&(r[0]=r[0]()),"function"==typeof r[1]&&(r[1]=r[1]()),r},at=function(i,r){if(null!=i&&"undefined"!=typeof i){var h=n(this),c=h.data(t),v=c.opt,u=n("#mCSBap_"+c.idx+"_container"),o=u.parent(),y=typeof i;r||(r="x"===v.axis?"x":"y");var p="x"===r?u.outerWidth(!1)-o.width():u.outerHeight(!1)-o.height(),l="x"===r?u[0].offsetLeft:u[0].offsetTop,w="x"===r?"left":"top";switch(y){case"function":return i();case"object":var e=i.jquery?i:n(i);return e.length?"x"===r?f(e)[1]:f(e)[0]:void 0;case"string":case"number":if(tt(i))return Math.abs(i);if(-1!==i.indexOf("%"))return Math.abs(p*parseInt(i)/100);if(-1!==i.indexOf("-="))return Math.abs(l-parseInt(i.split("-=")[1]));if(-1!==i.indexOf("+=")){var a=l+parseInt(i.split("+=")[1]);return a>=0?0:Math.abs(a)}if(-1!==i.indexOf("px")&&tt(i.split("px")[0]))return Math.abs(i.split("px")[0]);if("top"===i||"left"===i)return 0;if("bottom"===i)return Math.abs(o.height()-u.outerHeight(!1));if("right"===i)return Math.abs(o.width()-u.outerWidth(!1));if("first"===i||"last"===i){var e=u.find(":"+i);return"x"===r?f(e)[1]:f(e)[0]}return n(i).length?"x"===r?f(n(i))[1]:f(n(i))[0]:(u.css(w,i),void s.update.call(null,h[0]))}}},et=function(r){function c(){return clearTimeout(e[0].autoUpdate),0===o.parents("html").length?void(o=null):void(e[0].autoUpdate=setTimeout(function(){return f.advanced.updateOnSelectorChange&&(u.poll.change.n=v(),u.poll.change.n!==u.poll.change.o)?(u.poll.change.o=u.poll.change.n,void h(3)):f.advanced.updateOnContentResize&&(u.poll.size.n=o[0].scrollHeight+o[0].scrollWidth+e[0].offsetHeight+o[0].offsetHeight+o[0].offsetWidth,u.poll.size.n!==u.poll.size.o)?(u.poll.size.o=u.poll.size.n,void h(1)):!f.advanced.updateOnImageLoad||"auto"===f.advanced.updateOnImageLoad&&"y"===f.axis||(u.poll.img.n=e.find("img").length,u.poll.img.n===u.poll.img.o)?void((f.advanced.updateOnSelectorChange||f.advanced.updateOnContentResize||f.advanced.updateOnImageLoad)&&c()):(u.poll.img.o=u.poll.img.n,void e.find("img").each(function(){l(this)}))},f.advanced.autoUpdateTimeout))}function l(t){function u(n,t){return function(){return t.apply(n,arguments)}}function f(){this.onload=null;n(t).addClass(i[2]);h(2)}if(n(t).hasClass(i[2]))return void h();var r=new Image;r.onload=u(r,f);r.src=t.src}function v(){f.advanced.updateOnSelectorChange===!0&&(f.advanced.updateOnSelectorChange="*");var n=0,t=e.find(f.advanced.updateOnSelectorChange);return f.advanced.updateOnSelectorChange&&t.length>0&&t.each(function(){n+=this.offsetHeight+this.offsetWidth}),n}function h(n){clearTimeout(e[0].autoUpdate);s.update.call(null,o[0],n)}var o=n(this),u=o.data(t),f=u.opt,e=n("#mCSBap_"+u.idx+"_container");return r?(clearTimeout(e[0].autoUpdate),void a(e[0],"autoUpdate")):void c()},yi=function(n,t,i){return Math.round(n/t)*t-i},o=function(i){var r=i.data(t),u=n("#mCSBap_"+r.idx+"_container,#mCSBap_"+r.idx+"_container_wrapper,#mCSBap_"+r.idx+"_dragger_vertical,#mCSBap_"+r.idx+"_dragger_horizontal");u.each(function(){pi.call(this)})},u=function(i,r,u){function h(n){return f&&e.callbacks[n]&&"function"==typeof e.callbacks[n]}function it(){return[e.callbacks.alwaysTriggerOffsets||w>=l[0]+v,e.callbacks.alwaysTriggerOffsets||-y>=w]}function a(){var n=[o[0].offsetTop,o[0].offsetLeft],t=[c[0].offsetTop,c[0].offsetLeft],r=[o.outerHeight(!1),o.outerWidth(!1)],f=[p.height(),p.width()];i[0].mcs={content:o,top:n[0],left:n[1],draggerTop:t[0],draggerLeft:t[1],topPct:Math.round(100*Math.abs(n[0])/(Math.abs(r[0])-f[0])),leftPct:Math.round(100*Math.abs(n[1])/(Math.abs(r[1])-f[1])),direction:u.dir}}var f=i.data(t),e=f.opt,rt={trigger:"internal",dir:"y",scrollEasing:"mcsEaseOut",drag:!1,dur:e.scrollInertia,overwrite:"all",callbacks:!0,onStart:!0,onUpdate:!0,onComplete:!0},u=n.extend(rt,u),k=[u.dur,u.drag?0:u.dur],p=n("#mCSBap_"+f.idx),o=n("#mCSBap_"+f.idx+"_container"),b=o.parent(),g=e.callbacks.onTotalScrollOffset?ft.call(i,e.callbacks.onTotalScrollOffset):[0,0],nt=e.callbacks.onTotalScrollBackOffset?ft.call(i,e.callbacks.onTotalScrollBackOffset):[0,0];if(f.trigger=u.trigger,0===b.scrollTop()&&0===b.scrollLeft()||(n(".mCSBap_"+f.idx+"_scrollbar").css("visibility","visible"),b.scrollTop(0).scrollLeft(0)),"_resetY"!==r||f.contentReset.y||(h("onOverflowYNone")&&e.callbacks.onOverflowYNone.call(i[0]),f.contentReset.y=1),"_resetX"!==r||f.contentReset.x||(h("onOverflowXNone")&&e.callbacks.onOverflowXNone.call(i[0]),f.contentReset.x=1),"_resetY"!==r&&"_resetX"!==r){if(!f.contentReset.y&&i[0].mcs||!f.overflowed[0]||(h("onOverflowY")&&e.callbacks.onOverflowY.call(i[0]),f.contentReset.x=null),!f.contentReset.x&&i[0].mcs||!f.overflowed[1]||(h("onOverflowX")&&e.callbacks.onOverflowX.call(i[0]),f.contentReset.x=null),e.snapAmount){var ut=e.snapAmount instanceof Array?"x"===u.dir?e.snapAmount[1]:e.snapAmount[0]:e.snapAmount;r=yi(r,ut,e.snapOffset)}switch(u.dir){case"x":var c=n("#mCSBap_"+f.idx+"_dragger_horizontal"),tt="left",w=o[0].offsetLeft,l=[p.width()-o.outerWidth(!1),c.parent().width()-c.width()],s=[r,0===r?0:r/f.scrollRatio.x],v=g[1],y=nt[1],et=v>0?v/f.scrollRatio.x:0,ot=y>0?y/f.scrollRatio.x:0;break;case"y":var c=n("#mCSBap_"+f.idx+"_dragger_vertical"),tt="top",w=o[0].offsetTop,l=[p.height()-o.outerHeight(!1),c.parent().height()-c.height()],s=[r,0===r?0:r/f.scrollRatio.y],v=g[0],y=nt[0],et=v>0?v/f.scrollRatio.y:0,ot=y>0?y/f.scrollRatio.y:0}s[1]<0||0===s[0]&&0===s[1]?s=[0,0]:s[1]>=l[1]?s=[l[0],l[1]]:s[0]=-s[0];i[0].mcs||(a(),h("onInit")&&e.callbacks.onInit.call(i[0]));clearTimeout(o[0].onCompleteTimeout);vt(c[0],tt,Math.round(s[1]),k[1],u.scrollEasing);!f.tweenRunning&&(0===w&&s[0]>=0||w===l[0]&&s[0]<=l[0])||vt(o[0],tt,Math.round(s[0]),k[0],u.scrollEasing,u.overwrite,{onStart:function(){u.callbacks&&u.onStart&&!f.tweenRunning&&(h("onScrollStart")&&(a(),e.callbacks.onScrollStart.call(i[0])),f.tweenRunning=!0,d(c),f.cbOffsets=it())},onUpdate:function(){u.callbacks&&u.onUpdate&&h("whileScrolling")&&(a(),e.callbacks.whileScrolling.call(i[0]))},onComplete:function(){if(u.callbacks&&u.onComplete){"yx"===e.axis&&clearTimeout(o[0].onCompleteTimeout);var n=o[0].idleTimer||0;o[0].onCompleteTimeout=setTimeout(function(){h("onScroll")&&(a(),e.callbacks.onScroll.call(i[0]));h("onTotalScroll")&&s[1]>=l[1]-et&&f.cbOffsets[0]&&(a(),e.callbacks.onTotalScroll.call(i[0]));h("onTotalScrollBack")&&s[1]<=ot&&f.cbOffsets[1]&&(a(),e.callbacks.onTotalScrollBack.call(i[0]));f.tweenRunning=!1;o[0].idleTimer=0;d(c,"hide")},n)}}})}},vt=function(n,t,i,r,u,f,e){function a(){o.stop||(s||d.call(),s=w()-tt,v(),s>=o.time&&(o.time=s>o.time?s+h-(s-o.time):s+h-1,o.time<s+1&&(o.time=s+1)),o.time<r?o.id=c(a):nt.call())}function v(){r>0?(o.currVal=k(o.time,l,it,r,u),y[t]=Math.round(o.currVal)+"px"):y[t]=i+"px";g.call()}function p(){h=1e3/60;o.time=s+h;c=window.requestAnimationFrame?window.requestAnimationFrame:function(n){return v(),setTimeout(n,.01)};o.id=c(a)}function b(){null!=o.id&&(window.requestAnimationFrame?window.cancelAnimationFrame(o.id):clearTimeout(o.id),o.id=null)}function k(n,t,i,r,u){switch(u){case"linear":case"mcsLinear":return i*n/r+t;case"mcsLinearOut":return n/=r,n--,i*Math.sqrt(1-n*n)+t;case"easeInOutSmooth":return n/=r/2,1>n?i/2*n*n+t:(n--,-i/2*(n*(n-2)-1)+t);case"easeInOutStrong":return n/=r/2,1>n?i/2*Math.pow(2,10*(n-1))+t:(n--,i/2*(-Math.pow(2,-10*n)+2)+t);case"easeInOut":case"mcsEaseInOut":return n/=r/2,1>n?i/2*n*n*n+t:(n-=2,i/2*(n*n*n+2)+t);case"easeOutSmooth":return n/=r,n--,-i*(n*n*n*n-1)+t;case"easeOutStrong":return i*(-Math.pow(2,-10*n/r)+1)+t;case"easeOut":case"mcsEaseOut":default:var f=(n/=r)*n,e=f*n;return t+i*(.499999999999997*e*f+-2.5*f*f+5.5*e+-6.5*f+4*n)}}n._mTween||(n._mTween={top:{},left:{}});var h,c,e=e||{},d=e.onStart||function(){},g=e.onUpdate||function(){},nt=e.onComplete||function(){},tt=w(),s=0,l=n.offsetTop,y=n.style,o=n._mTween[t];"left"===t&&(l=n.offsetLeft);var it=i-l;o.stop=0;"none"!==f&&b();p()},w=function(){return window.performance&&window.performance.now?window.performance.now():window.performance&&window.performance.webkitNow?window.performance.webkitNow():Date.now?Date.now():(new Date).getTime()},pi=function(){var n=this;n._mTween||(n._mTween={top:{},left:{}});for(var r=["top","left"],i=0;i<r.length;i++){var t=r[i];n._mTween[t].id&&(window.requestAnimationFrame?window.cancelAnimationFrame(n._mTween[t].id):clearTimeout(n._mTween[t].id),n._mTween[t].id=null,n._mTween[t].stop=1)}},a=function(n,t){try{delete n[t]}catch(i){n[t]=null}},yt=function(n){return!(n.which&&1!==n.which)},nt=function(n){var t=n.originalEvent.pointerType;return!(t&&"touch"!==t&&2!==t)},tt=function(n){return!isNaN(parseFloat(n))&&isFinite(n)},f=function(n){var t=n.parents(".mCSBap_container");return[n.offset().top-t.offset().top,n.offset().left-t.offset().left]},wi=function(){function t(){var t=["webkit","moz","ms","o"];if("hidden"in document)return"hidden";for(var n=0;n<t.length;n++)if(t[n]+"Hidden"in document)return t[n]+"Hidden";return null}var n=t();return n?document[n]:!1};n.fn[c]=function(t){return s[t]?s[t].apply(this,Array.prototype.slice.call(arguments,1)):"object"!=typeof t&&t?void n.error("Method "+t+" does not exist"):s.init.apply(this,arguments)};n[c]=function(t){return s[t]?s[t].apply(this,Array.prototype.slice.call(arguments,1)):"object"!=typeof t&&t?void n.error("Method "+t+" does not exist"):s.init.apply(this,arguments)};n[c].defaults=ot;window[c]=!0;n(window).bind("load",function(){n(it)[c]();n.extend(n.expr[":"],{mcsInView:n.expr[":"].mcsInView||function(t){var e,r,i=n(t),u=i.parents(".mCSBap_container");if(u.length)return e=u.parent(),r=[u[0].offsetTop,u[0].offsetLeft],r[0]+f(i)[0]>=0&&r[0]+f(i)[0]<e.height()-i.outerHeight(!1)&&r[1]+f(i)[1]>=0&&r[1]+f(i)[1]<e.width()-i.outerWidth(!1)},mcsInSight:n.expr[":"].mcsInSight||function(t,i,r){var e,u,o,s,h=n(t),c=h.parents(".mCSBap_container"),l="exact"===r[3]?[[1,0],[1,0]]:[[.9,.1],[.6,.4]];if(c.length)return e=[h.outerHeight(!1),h.outerWidth(!1)],o=[c[0].offsetTop+f(h)[0],c[0].offsetLeft+f(h)[1]],u=[c.parent()[0].offsetHeight,c.parent()[0].offsetWidth],s=[e[0]<u[0]?l[0]:l[1],e[1]<u[1]?l[0]:l[1]],o[0]-u[0]*s[0][0]<0&&o[0]+e[0]-u[0]*s[0][1]>=0&&o[1]-u[1]*s[1][0]<0&&o[1]+e[1]-u[1]*s[1][1]>=0},mcsOverflow:n.expr[":"].mcsOverflow||function(i){var r=n(i).data(t);if(r)return r.overflowed[0]||r.overflowed[1]}})})})}):console.log("ASP: scrollbar detected, skipping loading");jQuery.extend({highlight:function(n,t,i,r){if(n.nodeType===3){var u=n.data.match(t);if(u){var o=document.createElement(i||"span");if(o.className=r||"highlight",/\.|,|\s/.test(u[0].charAt(0)))var s=u.index+1;else var s=u.index;var f=n.splitText(s);f.splitText(u[1].length);var h=f.cloneNode(!0);return o.appendChild(h),f.parentNode.replaceChild(o,f),1}}else if(n.nodeType===1&&n.childNodes&&!/(script|style)/i.test(n.tagName)&&!(n.tagName===i.toUpperCase()&&n.className===r))for(var e=0;e<n.childNodes.length;e++)e+=jQuery.highlight(n.childNodes[e],t,i,r);return 0}});jQuery.fn.unhighlight=function(n){var t={className:"highlight",element:"span"};return jQuery.extend(t,n),this.find(t.element+"."+t.className).each(function(){var n=this.parentNode;n.replaceChild(this.firstChild,this);n.normalize()}).end()};jQuery.fn.highlight=function(n,t){var i={className:"highlight",element:"span",caseSensitive:!1,wordsOnly:!1};if(jQuery.extend(i,t),n.constructor===String&&(n=[n]),n=jQuery.grep(n,function(n){return n!=""}),n=jQuery.map(n,function(n){return n.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}),n.length==0)return this;var u=i.caseSensitive?"":"i",r="("+n.join("|")+")";i.wordsOnly&&(r="(?:,|^|\\s)"+r+"(?:,|$|\\s)");var f=new RegExp(r,u);return this.each(function(){jQuery.highlight(this,f,i.element,i.className)})};
/**
 * @author  Mudit Ameta
 * @license https://github.com/zeusdeux/isInViewport/blob/master/license.md MIT
 */
(function(n){"use strict";var t=n.jQuery;t.extend(t.expr.pseudos||t.expr[":"],{"in-viewport":t.expr.createPseudo?t.expr.createPseudo(function(n){return function(t){return i(t,r(n))}}):function(n,t,u){return i(n,r(u[3]))}});t.fn.isInViewport=function(n){return this.filter(function(t,r){return i(r,n)})};t.fn.run=u;function u(n){var i=this;if(arguments.length===1&&typeof n=="function"&&(n=[n]),!(n instanceof Array))throw new SyntaxError("isInViewport: Argument(s) passed to .do/.run should be a function or an array of functions");return n.forEach(function(n){typeof n!="function"?(console.warn("isInViewport: Argument(s) passed to .do/.run should be a function or an array of functions"),console.warn("isInViewport: Ignoring non-function values in array and moving on")):[].slice.call(i).forEach(function(i){return n.call(t(i))})}),this}function f(n){var i=t("<div><\/div>").css({width:"100%"});n.append(i);var r=n.width()-i.width();return i.remove(),r}function i(r,u){var s=r.getBoundingClientRect(),h=s.top,c=s.bottom,a=s.left,v=s.right,e=t.extend({tolerance:0,viewport:n},u),o=e.viewport.jquery?e.viewport:t(e.viewport);o.length||(console.warn("isInViewport: The viewport selector you have provided matches no element on page."),console.warn("isInViewport: Defaulting to viewport as window"),o=t(n));var y=o.height(),p=o.width(),w=o[0].toString();if(o[0]!==n&&w!=="[object Window]"&&w!=="[object DOMWindow]"){var l=o[0].getBoundingClientRect();h=h-l.top;c=c-l.top;a=a-l.left;v=v-l.left;i.scrollBarWidth=i.scrollBarWidth||f(o);p-=i.scrollBarWidth}return(e.tolerance=~~Math.round(parseFloat(e.tolerance)),e.tolerance<0&&(e.tolerance=y+e.tolerance),v<=0||a>=p)?!1:e.tolerance?h<=e.tolerance&&c>=e.tolerance:c>0&&h<=y}function r(n){if(n){var i=n.split(",");return i.length===1&&isNaN(i[0])&&(i[1]=i[0],i[0]=void 0),{tolerance:i[0]?i[0].trim():void 0,viewport:i[1]?t(i[1].trim()):void 0}}return{}}})(window);
/*!
 * Isotope PACKAGED v3.0.4
 *
 * Licensed GPLv3 for open source use
 * or Isotope Commercial License for commercial use
 *
 * http://isotope.metafizzy.co
 * Copyright 2017 Metafizzy
 */
!function(n,t){"function"==typeof define&&define.amd?define("jquery-bridget/jquery-bridget",["jquery"],function(i){return t(n,i)}):"object"==typeof module&&module.exports?module.exports=t(n,require("jquery")):n.jQueryBridget=t(n,n.jQuery)}(window,function(n,t){"use strict";function i(i,u,o){function s(n,t,r){var u,e="$()."+i+'("'+t+'")';return n.each(function(n,s){var h=o.data(s,i);if(!h)return void f(i+" not initialized. Cannot call methods, i.e. "+e);var c=h[t];if(!c||"_"==t.charAt(0))return void f(e+" is not a valid method");var l=c.apply(h,r);u=void 0===u?l:u}),void 0!==u?u:n}function h(n,t){n.each(function(n,r){var f=o.data(r,i);f?(f.option(t),f._init()):(f=new u(r,t),o.data(r,i,f))})}o=o||t||n.jQuery;o&&(u.prototype.option||(u.prototype.option=function(n){o.isPlainObject(n)&&(this.options=o.extend(!0,this.options,n))}),o.fn[i]=function(n){if("string"==typeof n){var t=e.call(arguments,1);return s(this,n,t)}return h(this,n),this},r(o))}function r(n){!n||n&&n.bridget||(n.bridget=i)}var e=Array.prototype.slice,u=n.console,f="undefined"==typeof u?function(){}:function(n){u.error(n)};return r(t||n.jQuery),i}),function(n,t){"function"==typeof define&&define.amd?define("ev-emitter/ev-emitter",t):"object"==typeof module&&module.exports?module.exports=t():n.EvEmitter=t()}("undefined"!=typeof window?window:this,function(){function t(){}var n=t.prototype;return n.on=function(n,t){if(n&&t){var i=this._events=this._events||{},r=i[n]=i[n]||[];return r.indexOf(t)==-1&&r.push(t),this}},n.once=function(n,t){if(n&&t){this.on(n,t);var i=this._onceEvents=this._onceEvents||{},r=i[n]=i[n]||{};return r[t]=!0,this}},n.off=function(n,t){var i=this._events&&this._events[n];if(i&&i.length){var r=i.indexOf(t);return r!=-1&&i.splice(r,1),this}},n.emitEvent=function(n,t){var r=this._events&&this._events[n];if(r&&r.length){var u=0,i=r[u];t=t||[];for(var f=this._onceEvents&&this._onceEvents[n];i;){var e=f&&f[i];e&&(this.off(n,i),delete f[i]);i.apply(this,t);u+=e?0:1;i=r[u]}return this}},t}),function(n,t){"use strict";"function"==typeof define&&define.amd?define("get-size/get-size",[],function(){return t()}):"object"==typeof module&&module.exports?module.exports=t():n.getSize=t()}(window,function(){"use strict";function n(n){var t=parseFloat(n),i=n.indexOf("%")==-1&&!isNaN(t);return i&&t}function o(){}function s(){for(var i={width:0,height:0,innerWidth:0,innerHeight:0,outerWidth:0,outerHeight:0},n=0;n<f;n++){var r=t[n];i[r]=0}return i}function i(n){var t=getComputedStyle(n);return t||c("Style returned "+t+". Are you running this code in a hidden iframe on Firefox? See http://bit.ly/getsizebug1"),t}function h(){if(!e){e=!0;var t=document.createElement("div");t.style.width="200px";t.style.padding="1px 2px 3px 4px";t.style.borderStyle="solid";t.style.borderWidth="1px 2px 3px 4px";t.style.boxSizing="border-box";var f=document.body||document.documentElement;f.appendChild(t);var o=i(t);r.isBoxSizeOuter=u=200==n(o.width);f.removeChild(t)}}function r(r){if(h(),"string"==typeof r&&(r=document.querySelector(r)),r&&"object"==typeof r&&r.nodeType){var o=i(r);if("none"==o.display)return s();var e={};e.width=r.offsetWidth;e.height=r.offsetHeight;for(var g=e.isBorderBox="border-box"==o.boxSizing,c=0;c<f;c++){var l=t[c],nt=o[l],a=parseFloat(nt);e[l]=isNaN(a)?0:a}var v=e.paddingLeft+e.paddingRight,y=e.paddingTop+e.paddingBottom,tt=e.marginLeft+e.marginRight,it=e.marginTop+e.marginBottom,p=e.borderLeftWidth+e.borderRightWidth,w=e.borderTopWidth+e.borderBottomWidth,b=g&&u,k=n(o.width);k!==!1&&(e.width=k+(b?0:v+p));var d=n(o.height);return d!==!1&&(e.height=d+(b?0:y+w)),e.innerWidth=e.width-(v+p),e.innerHeight=e.height-(y+w),e.outerWidth=e.width+tt,e.outerHeight=e.height+it,e}}var u,c="undefined"==typeof console?o:function(n){console.error(n)},t=["paddingLeft","paddingRight","paddingTop","paddingBottom","marginLeft","marginRight","marginTop","marginBottom","borderLeftWidth","borderRightWidth","borderTopWidth","borderBottomWidth"],f=t.length,e=!1;return r}),function(n,t){"use strict";"function"==typeof define&&define.amd?define("desandro-matches-selector/matches-selector",t):"object"==typeof module&&module.exports?module.exports=t():n.matchesSelector=t()}(window,function(){"use strict";var n=function(){var n=window.Element.prototype;if(n.matches)return"matches";if(n.matchesSelector)return"matchesSelector";for(var i=["webkit","moz","ms","o"],t=0;t<i.length;t++){var u=i[t],r=u+"MatchesSelector";if(n[r])return r}}();return function(t,i){return t[n](i)}}),function(n,t){"function"==typeof define&&define.amd?define("fizzy-ui-utils/utils",["desandro-matches-selector/matches-selector"],function(i){return t(n,i)}):"object"==typeof module&&module.exports?module.exports=t(n,require("desandro-matches-selector")):n.fizzyUIUtils=t(n,n.matchesSelector)}(window,function(n,t){var i={};i.extend=function(n,t){for(var i in t)n[i]=t[i];return n};i.modulo=function(n,t){return(n%t+t)%t};i.makeArray=function(n){var t=[];if(Array.isArray(n))t=n;else if(n&&"object"==typeof n&&"number"==typeof n.length)for(var i=0;i<n.length;i++)t.push(n[i]);else t.push(n);return t};i.removeFrom=function(n,t){var i=n.indexOf(t);i!=-1&&n.splice(i,1)};i.getParent=function(n,i){for(;n.parentNode&&n!=document.body;)if(n=n.parentNode,t(n,i))return n};i.getQueryElement=function(n){return"string"==typeof n?document.querySelector(n):n};i.handleEvent=function(n){var t="on"+n.type;this[t]&&this[t](n)};i.filterFindElements=function(n,r){n=i.makeArray(n);var u=[];return n.forEach(function(n){if(n instanceof HTMLElement){if(!r)return void u.push(n);t(n,r)&&u.push(n);for(var f=n.querySelectorAll(r),i=0;i<f.length;i++)u.push(f[i])}}),u};i.debounceMethod=function(n,t,i){var u=n.prototype[t],r=t+"Timeout";n.prototype[t]=function(){var n=this[r];n&&clearTimeout(n);var f=arguments,t=this;this[r]=setTimeout(function(){u.apply(t,f);delete t[r]},i||100)}};i.docReady=function(n){var t=document.readyState;"complete"==t||"interactive"==t?setTimeout(n):document.addEventListener("DOMContentLoaded",n)};i.toDashed=function(n){return n.replace(/(.)([A-Z])/g,function(n,t,i){return t+"-"+i}).toLowerCase()};var r=n.console;return i.htmlInit=function(t,u){i.docReady(function(){var e=i.toDashed(u),f="data-"+e,s=document.querySelectorAll("["+f+"]"),h=document.querySelectorAll(".js-"+e),c=i.makeArray(s).concat(i.makeArray(h)),l=f+"-options",o=n.jQuery;c.forEach(function(n){var i,e=n.getAttribute(f)||n.getAttribute(l);try{i=e&&JSON.parse(e)}catch(s){return void(r&&r.error("Error parsing "+f+" on "+n.className+": "+s))}var h=new t(n,i);o&&o.data(n,u,h)})})},i}),function(n,t){"function"==typeof define&&define.amd?define("outlayer/item",["ev-emitter/ev-emitter","get-size/get-size"],t):"object"==typeof module&&module.exports?module.exports=t(require("ev-emitter"),require("get-size")):(n.Outlayer={},n.Outlayer.Item=t(n.EvEmitter,n.getSize))}(window,function(n,t){"use strict";function s(n){for(var t in n)return!1;return t=null,!0}function u(n,t){n&&(this.element=n,this.layout=t,this.position={x:0,y:0},this._create())}function h(n){return n.replace(/([A-Z])/g,function(n){return"-"+n.toLowerCase()})}var f=document.documentElement.style,r="string"==typeof f.transition?"transition":"WebkitTransition",e="string"==typeof f.transform?"transform":"WebkitTransform",o={WebkitTransition:"webkitTransitionEnd",transition:"transitionend"}[r],c={transform:e,transition:r,transitionDuration:r+"Duration",transitionProperty:r+"Property",transitionDelay:r+"Delay"},i=u.prototype=Object.create(n.prototype);i.constructor=u;i._create=function(){this._transn={ingProperties:{},clean:{},onEnd:{}};this.css({position:"absolute"})};i.handleEvent=function(n){var t="on"+n.type;this[t]&&this[t](n)};i.getSize=function(){this.size=t(this.element)};i.css=function(n){var i=this.element.style;for(var t in n){var r=c[t]||t;i[r]=n[t]}};i.getPosition=function(){var f=getComputedStyle(this.element),e=this.layout._getOption("originLeft"),o=this.layout._getOption("originTop"),r=f[e?"left":"right"],u=f[o?"top":"bottom"],n=this.layout.size,t=r.indexOf("%")!=-1?parseFloat(r)/100*n.width:parseInt(r,10),i=u.indexOf("%")!=-1?parseFloat(u)/100*n.height:parseInt(u,10);t=isNaN(t)?0:t;i=isNaN(i)?0:i;t-=e?n.paddingLeft:n.paddingRight;i-=o?n.paddingTop:n.paddingBottom;this.position.x=t;this.position.y=i};i.layoutPosition=function(){var r=this.layout.size,n={},t=this.layout._getOption("originLeft"),i=this.layout._getOption("originTop"),u=t?"paddingLeft":"paddingRight",f=t?"left":"right",e=t?"right":"left",o=this.position.x+r[u];n[f]=this.getXValue(o);n[e]="";var s=i?"paddingTop":"paddingBottom",h=i?"top":"bottom",c=i?"bottom":"top",l=this.position.y+r[s];n[h]=this.getYValue(l);n[c]="";this.css(n);this.emitEvent("layout",[this])};i.getXValue=function(n){var t=this.layout._getOption("horizontal");return this.layout.options.percentPosition&&!t?n/this.layout.size.width*100+"%":n+"px"};i.getYValue=function(n){var t=this.layout._getOption("horizontal");return this.layout.options.percentPosition&&t?n/this.layout.size.height*100+"%":n+"px"};i._transitionTo=function(n,t){this.getPosition();var r=this.position.x,u=this.position.y,f=parseInt(n,10),e=parseInt(t,10),o=f===this.position.x&&e===this.position.y;if(this.setPosition(n,t),o&&!this.isTransitioning)return void this.layoutPosition();var s=n-r,h=t-u,i={};i.transform=this.getTranslate(s,h);this.transition({to:i,onTransitionEnd:{transform:this.layoutPosition},isCleaning:!0})};i.getTranslate=function(n,t){var i=this.layout._getOption("originLeft"),r=this.layout._getOption("originTop");return n=i?n:-n,t=r?t:-t,"translate3d("+n+"px, "+t+"px, 0)"};i.goTo=function(n,t){this.setPosition(n,t);this.layoutPosition()};i.moveTo=i._transitionTo;i.setPosition=function(n,t){this.position.x=parseInt(n,10);this.position.y=parseInt(t,10)};i._nonTransition=function(n){this.css(n.to);n.isCleaning&&this._removeStyles(n.to);for(var t in n.onTransitionEnd)n.onTransitionEnd[t].call(this)};i.transition=function(n){if(!parseFloat(this.layout.options.transitionDuration))return void this._nonTransition(n);var i=this._transn;for(var t in n.onTransitionEnd)i.onEnd[t]=n.onTransitionEnd[t];for(t in n.to)i.ingProperties[t]=!0,n.isCleaning&&(i.clean[t]=!0);if(n.from){this.css(n.from);var r=this.element.offsetHeight;r=null}this.enableTransition(n.to);this.css(n.to);this.isTransitioning=!0};var l="opacity,"+h(e);i.enableTransition=function(){if(!this.isTransitioning){var n=this.layout.options.transitionDuration;n="number"==typeof n?n+"ms":n;this.css({transitionProperty:l,transitionDuration:n,transitionDelay:this.staggerDelay||0});this.element.addEventListener(o,this,!1)}};i.onwebkitTransitionEnd=function(n){this.ontransitionend(n)};i.onotransitionend=function(n){this.ontransitionend(n)};var a={"-webkit-transform":"transform"};i.ontransitionend=function(n){if(n.target===this.element){var t=this._transn,i=a[n.propertyName]||n.propertyName;if(delete t.ingProperties[i],s(t.ingProperties)&&this.disableTransition(),i in t.clean&&(this.element.style[n.propertyName]="",delete t.clean[i]),i in t.onEnd){var r=t.onEnd[i];r.call(this);delete t.onEnd[i]}this.emitEvent("transitionEnd",[this])}};i.disableTransition=function(){this.removeTransitionStyles();this.element.removeEventListener(o,this,!1);this.isTransitioning=!1};i._removeStyles=function(n){var t={};for(var i in n)t[i]="";this.css(t)};var v={transitionProperty:"",transitionDuration:"",transitionDelay:""};return i.removeTransitionStyles=function(){this.css(v)},i.stagger=function(n){n=isNaN(n)?0:n;this.staggerDelay=n+"ms"},i.removeElem=function(){this.element.parentNode.removeChild(this.element);this.css({display:""});this.emitEvent("remove",[this])},i.remove=function(){return r&&parseFloat(this.layout.options.transitionDuration)?(this.once("transitionEnd",function(){this.removeElem()}),void this.hide()):void this.removeElem()},i.reveal=function(){delete this.isHidden;this.css({display:""});var n=this.layout.options,t={},i=this.getHideRevealTransitionEndProperty("visibleStyle");t[i]=this.onRevealTransitionEnd;this.transition({from:n.hiddenStyle,to:n.visibleStyle,isCleaning:!0,onTransitionEnd:t})},i.onRevealTransitionEnd=function(){this.isHidden||this.emitEvent("reveal")},i.getHideRevealTransitionEndProperty=function(n){var t=this.layout.options[n];if(t.opacity)return"opacity";for(var i in t)return i},i.hide=function(){this.isHidden=!0;this.css({display:""});var n=this.layout.options,t={},i=this.getHideRevealTransitionEndProperty("hiddenStyle");t[i]=this.onHideTransitionEnd;this.transition({from:n.visibleStyle,to:n.hiddenStyle,isCleaning:!0,onTransitionEnd:t})},i.onHideTransitionEnd=function(){this.isHidden&&(this.css({display:"none"}),this.emitEvent("hide"))},i.destroy=function(){this.css({position:"",left:"",right:"",top:"",bottom:"",transition:"",transform:""})},u}),function(n,t){"use strict";"function"==typeof define&&define.amd?define("outlayer/outlayer",["ev-emitter/ev-emitter","get-size/get-size","fizzy-ui-utils/utils","./item"],function(i,r,u,f){return t(n,i,r,u,f)}):"object"==typeof module&&module.exports?module.exports=t(n,require("ev-emitter"),require("get-size"),require("fizzy-ui-utils"),require("./item")):n.Outlayer=t(n,n.EvEmitter,n.getSize,n.fizzyUIUtils,n.Outlayer.Item)}(window,function(n,t,i,r,u){"use strict";function e(n,t){var i=r.getQueryElement(n);if(!i)return void(c&&c.error("Bad element for "+this.constructor.namespace+": "+(i||n)));this.element=i;o&&(this.$element=o(this.element));this.options=r.extend({},this.constructor.defaults);this.option(t);var u=++v;this.element.outlayerGUID=u;s[u]=this;this._create();var f=this._getOption("initLayout");f&&this.layout()}function h(n){function t(){n.apply(this,arguments)}return t.prototype=Object.create(n.prototype),t.prototype.constructor=t,t}function a(n){if("number"==typeof n)return n;var t=n.match(/(^\d*\.?\d*)(\w*)/),i=t&&t[1],r=t&&t[2];if(!i.length)return 0;i=parseFloat(i);var u=y[r]||1;return i*u}var c=n.console,o=n.jQuery,l=function(){},v=0,s={};e.namespace="outlayer";e.Item=u;e.defaults={containerStyle:{position:"relative"},initLayout:!0,originLeft:!0,originTop:!0,resize:!0,resizeContainer:!0,transitionDuration:"0.4s",hiddenStyle:{opacity:0,transform:"scale(0.001)"},visibleStyle:{opacity:1,transform:"scale(1)"}};var f=e.prototype;r.extend(f,t.prototype);f.option=function(n){r.extend(this.options,n)};f._getOption=function(n){var t=this.constructor.compatOptions[n];return t&&void 0!==this.options[t]?this.options[t]:this.options[n]};e.compatOptions={initLayout:"isInitLayout",horizontal:"isHorizontal",layoutInstant:"isLayoutInstant",originLeft:"isOriginLeft",originTop:"isOriginTop",resize:"isResizeBound",resizeContainer:"isResizingContainer"};f._create=function(){this.reloadItems();this.stamps=[];this.stamp(this.options.stamp);r.extend(this.element.style,this.options.containerStyle);var n=this._getOption("resize");n&&this.bindResize()};f.reloadItems=function(){this.items=this._itemize(this.element.children)};f._itemize=function(n){for(var i=this._filterFindItemElements(n),u=this.constructor.Item,r=[],t=0;t<i.length;t++){var f=i[t],e=new u(f,this);r.push(e)}return r};f._filterFindItemElements=function(n){return r.filterFindElements(n,this.options.itemSelector)};f.getItemElements=function(){return this.items.map(function(n){return n.element})};f.layout=function(){this._resetLayout();this._manageStamps();var n=this._getOption("layoutInstant"),t=void 0!==n?n:!this._isLayoutInited;this.layoutItems(this.items,t);this._isLayoutInited=!0};f._init=f.layout;f._resetLayout=function(){this.getSize()};f.getSize=function(){this.size=i(this.element)};f._getMeasurement=function(n,t){var u,r=this.options[n];r?("string"==typeof r?u=this.element.querySelector(r):r instanceof HTMLElement&&(u=r),this[n]=u?i(u)[t]:r):this[n]=0};f.layoutItems=function(n,t){n=this._getItemsForLayout(n);this._layoutItems(n,t);this._postLayout()};f._getItemsForLayout=function(n){return n.filter(function(n){return!n.isIgnored})};f._layoutItems=function(n,t){if(this._emitCompleteOnItems("layout",n),n&&n.length){var i=[];n.forEach(function(n){var r=this._getItemLayoutPosition(n);r.item=n;r.isInstant=t||n.isLayoutInstant;i.push(r)},this);this._processLayoutQueue(i)}};f._getItemLayoutPosition=function(){return{x:0,y:0}};f._processLayoutQueue=function(n){this.updateStagger();n.forEach(function(n,t){this._positionItem(n.item,n.x,n.y,n.isInstant,t)},this)};f.updateStagger=function(){var n=this.options.stagger;return null===n||void 0===n?void(this.stagger=0):(this.stagger=a(n),this.stagger)};f._positionItem=function(n,t,i,r,u){r?n.goTo(t,i):(n.stagger(u*this.stagger),n.moveTo(t,i))};f._postLayout=function(){this.resizeContainer()};f.resizeContainer=function(){var t=this._getOption("resizeContainer");if(t){var n=this._getContainerSize();n&&(this._setContainerMeasure(n.width,!0),this._setContainerMeasure(n.height,!1))}};f._getContainerSize=l;f._setContainerMeasure=function(n,t){if(void 0!==n){var i=this.size;i.isBorderBox&&(n+=t?i.paddingLeft+i.paddingRight+i.borderLeftWidth+i.borderRightWidth:i.paddingBottom+i.paddingTop+i.borderTopWidth+i.borderBottomWidth);n=Math.max(n,0);this.element.style[t?"width":"height"]=n+"px"}};f._emitCompleteOnItems=function(n,t){function i(){e.dispatchEvent(n+"Complete",null,[t])}function f(){u++;u==r&&i()}var e=this,r=t.length;if(!t||!r)return void i();var u=0;t.forEach(function(t){t.once(n,f)})};f.dispatchEvent=function(n,t,i){var u=t?[t].concat(i):i;if(this.emitEvent(n,u),o)if(this.$element=this.$element||o(this.element),t){var r=o.Event(t);r.type=n;this.$element.trigger(r,i)}else this.$element.trigger(n,i)};f.ignore=function(n){var t=this.getItem(n);t&&(t.isIgnored=!0)};f.unignore=function(n){var t=this.getItem(n);t&&delete t.isIgnored};f.stamp=function(n){n=this._find(n);n&&(this.stamps=this.stamps.concat(n),n.forEach(this.ignore,this))};f.unstamp=function(n){n=this._find(n);n&&n.forEach(function(n){r.removeFrom(this.stamps,n);this.unignore(n)},this)};f._find=function(n){if(n)return"string"==typeof n&&(n=this.element.querySelectorAll(n)),n=r.makeArray(n)};f._manageStamps=function(){this.stamps&&this.stamps.length&&(this._getBoundingRect(),this.stamps.forEach(this._manageStamp,this))};f._getBoundingRect=function(){var t=this.element.getBoundingClientRect(),n=this.size;this._boundingRect={left:t.left+n.paddingLeft+n.borderLeftWidth,top:t.top+n.paddingTop+n.borderTopWidth,right:t.right-(n.paddingRight+n.borderRightWidth),bottom:t.bottom-(n.paddingBottom+n.borderBottomWidth)}};f._manageStamp=l;f._getElementOffset=function(n){var t=n.getBoundingClientRect(),r=this._boundingRect,u=i(n);return{left:t.left-r.left-u.marginLeft,top:t.top-r.top-u.marginTop,right:r.right-t.right-u.marginRight,bottom:r.bottom-t.bottom-u.marginBottom}};f.handleEvent=r.handleEvent;f.bindResize=function(){n.addEventListener("resize",this);this.isResizeBound=!0};f.unbindResize=function(){n.removeEventListener("resize",this);this.isResizeBound=!1};f.onresize=function(){this.resize()};r.debounceMethod(e,"onresize",100);f.resize=function(){this.isResizeBound&&this.needsResizeLayout()&&this.layout()};f.needsResizeLayout=function(){var n=i(this.element),t=this.size&&n;return t&&n.innerWidth!==this.size.innerWidth};f.addItems=function(n){var t=this._itemize(n);return t.length&&(this.items=this.items.concat(t)),t};f.appended=function(n){var t=this.addItems(n);t.length&&(this.layoutItems(t,!0),this.reveal(t))};f.prepended=function(n){var t=this._itemize(n);if(t.length){var i=this.items.slice(0);this.items=t.concat(i);this._resetLayout();this._manageStamps();this.layoutItems(t,!0);this.reveal(t);this.layoutItems(i)}};f.reveal=function(n){if(this._emitCompleteOnItems("reveal",n),n&&n.length){var t=this.updateStagger();n.forEach(function(n,i){n.stagger(i*t);n.reveal()})}};f.hide=function(n){if(this._emitCompleteOnItems("hide",n),n&&n.length){var t=this.updateStagger();n.forEach(function(n,i){n.stagger(i*t);n.hide()})}};f.revealItemElements=function(n){var t=this.getItems(n);this.reveal(t)};f.hideItemElements=function(n){var t=this.getItems(n);this.hide(t)};f.getItem=function(n){for(var t=0;t<this.items.length;t++){var i=this.items[t];if(i.element==n)return i}};f.getItems=function(n){n=r.makeArray(n);var t=[];return n.forEach(function(n){var i=this.getItem(n);i&&t.push(i)},this),t};f.remove=function(n){var t=this.getItems(n);this._emitCompleteOnItems("remove",t);t&&t.length&&t.forEach(function(n){n.remove();r.removeFrom(this.items,n)},this)};f.destroy=function(){var n=this.element.style;n.height="";n.position="";n.width="";this.items.forEach(function(n){n.destroy()});this.unbindResize();var t=this.element.outlayerGUID;delete s[t];delete this.element.outlayerGUID;o&&o.removeData(this.element,this.constructor.namespace)};e.data=function(n){n=r.getQueryElement(n);var t=n&&n.outlayerGUID;return t&&s[t]};e.create=function(n,t){var i=h(e);return i.defaults=r.extend({},e.defaults),r.extend(i.defaults,t),i.compatOptions=r.extend({},e.compatOptions),i.namespace=n,i.data=e.data,i.Item=h(u),r.htmlInit(i,n),o&&o.bridget&&o.bridget(n,i),i};var y={ms:1,s:1e3};return e.Item=u,e}),function(n,t){"function"==typeof define&&define.amd?define("isotope/js/item",["outlayer/outlayer"],t):"object"==typeof module&&module.exports?module.exports=t(require("outlayer")):(n.rpp_isotope=n.rpp_isotope||{},n.rpp_isotope.Item=t(n.Outlayer))}(window,function(n){"use strict";function i(){n.Item.apply(this,arguments)}var t=i.prototype=Object.create(n.Item.prototype),r=t._create;t._create=function(){this.id=this.layout.itemGUID++;r.call(this);this.sortData={}};t.updateSortData=function(){if(!this.isIgnored){this.sortData.id=this.id;this.sortData["original-order"]=this.id;this.sortData.random=Math.random();var t=this.layout.options.getSortData,i=this.layout._sorters;for(var n in t){var r=i[n];this.sortData[n]=r(this.element,this)}}};var u=t.destroy;return t.destroy=function(){u.apply(this,arguments);this.css({display:""})},i}),function(n,t){"function"==typeof define&&define.amd?define("isotope/js/layout-mode",["get-size/get-size","outlayer/outlayer"],t):"object"==typeof module&&module.exports?module.exports=t(require("get-size"),require("outlayer")):(n.rpp_isotope=n.rpp_isotope||{},n.rpp_isotope.LayoutMode=t(n.getSize,n.Outlayer))}(window,function(n,t){"use strict";function r(n){this.isotope=n;n&&(this.options=n.options[this.namespace],this.element=n.element,this.items=n.filteredItems,this.size=n.size)}var i=r.prototype;return["_resetLayout","_getItemLayoutPosition","_manageStamp","_getContainerSize","_getElementOffset","needsResizeLayout","_getOption"].forEach(function(n){i[n]=function(){return t.prototype[n].apply(this.isotope,arguments)}}),i.needsVerticalResizeLayout=function(){var t=n(this.isotope.element),i=this.isotope.size&&t;return i&&t.innerHeight!=this.isotope.size.innerHeight},i._getMeasurement=function(){this.isotope._getMeasurement.apply(this,arguments)},i.getColumnWidth=function(){this.getSegmentSize("column","Width")},i.getRowHeight=function(){this.getSegmentSize("row","Height")},i.getSegmentSize=function(n,t){var i=n+t,r="outer"+t;if(this._getMeasurement(i,r),!this[i]){var u=this.getFirstItemSize();this[i]=u&&u[r]||this.isotope.size["inner"+t]}},i.getFirstItemSize=function(){var t=this.isotope.filteredItems[0];return t&&t.element&&n(t.element)},i.layout=function(){this.isotope.layout.apply(this.isotope,arguments)},i.getSize=function(){this.isotope.getSize();this.size=this.isotope.size},r.modes={},r.create=function(n,t){function u(){r.apply(this,arguments)}return u.prototype=Object.create(i),u.prototype.constructor=u,t&&(u.options=t),u.prototype.namespace=n,r.modes[n]=u,u},r}),function(n,t){"function"==typeof define&&define.amd?define("masonry/masonry",["outlayer/outlayer","get-size/get-size"],t):"object"==typeof module&&module.exports?module.exports=t(require("outlayer"),require("get-size")):n.Masonry=t(n.Outlayer,n.getSize)}(window,function(n,t){var r=n.create("masonry");r.compatOptions.fitWidth="isFitWidth";var i=r.prototype;return i._resetLayout=function(){this.getSize();this._getMeasurement("columnWidth","outerWidth");this._getMeasurement("gutter","outerWidth");this.measureColumns();this.colYs=[];for(var n=0;n<this.cols;n++)this.colYs.push(0);this.maxY=0;this.horizontalColIndex=0},i.measureColumns=function(){if(this.getContainerWidth(),!this.columnWidth){var r=this.items[0],u=r&&r.element;this.columnWidth=u&&t(u).outerWidth||this.containerWidth}var n=this.columnWidth+=this.gutter,f=this.containerWidth+this.gutter,i=f/n,e=n-f%n,o=e&&e<1?"round":"floor";i=Math[o](i);this.cols=Math.max(i,1)},i.getContainerWidth=function(){var i=this._getOption("fitWidth"),r=i?this.element.parentNode:this.element,n=t(r);this.containerWidth=n&&n.innerWidth},i._getItemLayoutPosition=function(n){n.getSize();var u=n.size.outerWidth%this.columnWidth,f=u&&u<1?"round":"ceil",i=Math[f](n.size.outerWidth/this.columnWidth);i=Math.min(i,this.cols);for(var e=this.options.horizontalOrder?"_getHorizontalColPosition":"_getTopColPosition",t=this[e](i,n),o={x:this.columnWidth*t.col,y:t.y},s=t.y+n.size.outerHeight,h=i+t.col,r=t.col;r<h;r++)this.colYs[r]=s;return o},i._getTopColPosition=function(n){var t=this._getTopColGroup(n),i=Math.min.apply(Math,t);return{col:t.indexOf(i),y:i}},i._getTopColGroup=function(n){if(n<2)return this.colYs;for(var i=[],r=this.cols+1-n,t=0;t<r;t++)i[t]=this._getColGroupY(t,n);return i},i._getColGroupY=function(n,t){if(t<2)return this.colYs[n];var i=this.colYs.slice(n,n+t);return Math.max.apply(Math,i)},i._getHorizontalColPosition=function(n,t){var i=this.horizontalColIndex%this.cols,r=n>1&&i+n>this.cols;i=r?0:i;var u=t.size.outerWidth&&t.size.outerHeight;return this.horizontalColIndex=u?i+n:this.horizontalColIndex,{col:i,y:this._getColGroupY(i,n)}},i._manageStamp=function(n){var e=t(n),i=this._getElementOffset(n),h=this._getOption("originLeft"),o=h?i.left:i.right,s=o+e.outerWidth,f=Math.floor(o/this.columnWidth);f=Math.max(0,f);var r=Math.floor(s/this.columnWidth);r-=s%this.columnWidth?0:1;r=Math.min(this.cols-1,r);for(var c=this._getOption("originTop"),l=(c?i.top:i.bottom)+e.outerHeight,u=f;u<=r;u++)this.colYs[u]=Math.max(l,this.colYs[u])},i._getContainerSize=function(){this.maxY=Math.max.apply(Math,this.colYs);var n={height:this.maxY};return this._getOption("fitWidth")&&(n.width=this._getContainerFitWidth()),n},i._getContainerFitWidth=function(){for(var n=0,t=this.cols;--t&&0===this.colYs[t];)n++;return(this.cols-n)*this.columnWidth-this.gutter},i.needsResizeLayout=function(){var n=this.containerWidth;return this.getContainerWidth(),n!=this.containerWidth},r}),function(n,t){"function"==typeof define&&define.amd?define("isotope/js/layout-modes/masonry",["../layout-mode","masonry/masonry"],t):"object"==typeof module&&module.exports?module.exports=t(require("../layout-mode"),require("masonry-layout")):t(n.rpp_isotope.LayoutMode,n.Masonry)}(window,function(n,t){"use strict";var u=n.create("masonry"),i=u.prototype,f={_getElementOffset:!0,layout:!0,_getMeasurement:!0};for(var r in t.prototype)f[r]||(i[r]=t.prototype[r]);var e=i.measureColumns;i.measureColumns=function(){this.items=this.isotope.filteredItems;e.call(this)};var o=i._getOption;return i._getOption=function(n){return"fitWidth"==n?void 0!==this.options.isFitWidth?this.options.isFitWidth:this.options.fitWidth:o.apply(this.isotope,arguments)},u}),function(n,t){"function"==typeof define&&define.amd?define("isotope/js/layout-modes/fit-rows",["../layout-mode"],t):"object"==typeof exports?module.exports=t(require("../layout-mode")):t(n.rpp_isotope.LayoutMode)}(window,function(n){"use strict";var i=n.create("fitRows"),t=i.prototype;return t._resetLayout=function(){this.x=0;this.y=0;this.maxY=0;this._getMeasurement("gutter","outerWidth")},t._getItemLayoutPosition=function(n){n.getSize();var t=n.size.outerWidth+this.gutter,i=this.isotope.size.innerWidth+this.gutter;0!==this.x&&t+this.x>i&&(this.x=0,this.y=this.maxY);var r={x:this.x,y:this.y};return this.maxY=Math.max(this.maxY,this.y+n.size.outerHeight),this.x+=t,r},t._getContainerSize=function(){return{height:this.maxY}},i}),function(n,t){"function"==typeof define&&define.amd?define("isotope/js/layout-modes/vertical",["../layout-mode"],t):"object"==typeof module&&module.exports?module.exports=t(require("../layout-mode")):t(n.rpp_isotope.LayoutMode)}(window,function(n){"use strict";var i=n.create("vertical",{horizontalAlignment:0}),t=i.prototype;return t._resetLayout=function(){this.y=0},t._getItemLayoutPosition=function(n){n.getSize();var t=(this.isotope.size.innerWidth-n.size.outerWidth)*this.options.horizontalAlignment,i=this.y;return this.y+=n.size.outerHeight,{x:t,y:i}},t._getContainerSize=function(){return{height:this.y}},i}),function(n,t){"function"==typeof define&&define.amd?define(["outlayer/outlayer","get-size/get-size","desandro-matches-selector/matches-selector","fizzy-ui-utils/utils","isotope/js/item","isotope/js/layout-mode","isotope/js/layout-modes/masonry","isotope/js/layout-modes/fit-rows","isotope/js/layout-modes/vertical"],function(i,r,u,f,e,o){return t(n,i,r,u,f,e,o)}):"object"==typeof module&&module.exports?module.exports=t(n,require("outlayer"),require("get-size"),require("desandro-matches-selector"),require("fizzy-ui-utils"),require("isotope/js/item"),require("isotope/js/layout-mode"),require("isotope/js/layout-modes/masonry"),require("isotope/js/layout-modes/fit-rows"),require("isotope/js/layout-modes/vertical")):n.rpp_isotope=t(n,n.Outlayer,n.getSize,n.matchesSelector,n.fizzyUIUtils,n.rpp_isotope.Item,n.rpp_isotope.LayoutMode)}(window,function(n,t,i,r,u,f,e){function c(n,t){return function(i,r){for(var f=0;f<n.length;f++){var u=n[f],e=i.sortData[u],o=r.sortData[u];if(e>o||e<o){var s=void 0!==t[u]?t[u]:t,h=s?1:-1;return(e>o?1:-1)*h}}return 0}}var h=n.jQuery,l=String.prototype.trim?function(n){return n.trim()}:function(n){return n.replace(/^\s+|\s+$/g,"")},s=t.create("rpp_isotope",{layoutMode:"masonry",isJQueryFiltering:!0,sortAscending:!0});s.Item=f;s.LayoutMode=e;var o=s.prototype;o._create=function(){this.itemGUID=0;this._sorters={};this._getSorters();t.prototype._create.call(this);this.modes={};this.filteredItems=this.items;this.sortHistory=["original-order"];for(var n in e.modes)this._initLayoutMode(n)};o.reloadItems=function(){this.itemGUID=0;t.prototype.reloadItems.call(this)};o._itemize=function(){for(var n=t.prototype._itemize.apply(this,arguments),i=0;i<n.length;i++){var r=n[i];r.id=this.itemGUID++}return this._updateItemsSortData(n),n};o._initLayoutMode=function(n){var t=e.modes[n],i=this.options[n]||{};this.options[n]=t.options?u.extend(t.options,i):i;this.modes[n]=new t(this)};o.layout=function(){return!this._isLayoutInited&&this._getOption("initLayout")?void this.arrange():void this._layout()};o._layout=function(){var n=this._getIsInstant();this._resetLayout();this._manageStamps();this.layoutItems(this.filteredItems,n);this._isLayoutInited=!0};o.arrange=function(n){this.option(n);this._getIsInstant();var t=this._filter(this.items);this.filteredItems=t.matches;this._bindArrangeComplete();this._isInstant?this._noTransition(this._hideReveal,[t]):this._hideReveal(t);this._sort();this._layout()};o._init=o.arrange;o._hideReveal=function(n){this.reveal(n.needReveal);this.hide(n.needHide)};o._getIsInstant=function(){var n=this._getOption("layoutInstant"),t=void 0!==n?n:!this._isLayoutInited;return this._isInstant=t,t};o._bindArrangeComplete=function(){function n(){t&&i&&r&&u.dispatchEvent("arrangeComplete",null,[u.filteredItems])}var t,i,r,u=this;this.once("layoutComplete",function(){t=!0;n()});this.once("hideComplete",function(){i=!0;n()});this.once("revealComplete",function(){r=!0;n()})};o._filter=function(n){var i=this.options.filter;i=i||"*";for(var f=[],e=[],o=[],s=this._getFilterTest(i),r=0;r<n.length;r++){var t=n[r];if(!t.isIgnored){var u=s(t);u&&f.push(t);u&&t.isHidden?e.push(t):u||t.isHidden||o.push(t)}}return{matches:f,needReveal:e,needHide:o}};o._getFilterTest=function(n){return h&&this.options.isJQueryFiltering?function(t){return h(t.element).is(n)}:"function"==typeof n?function(t){return n(t.element)}:function(t){return r(t.element,n)}};o.updateSortData=function(n){var t;n?(n=u.makeArray(n),t=this.getItems(n)):t=this.items;this._getSorters();this._updateItemsSortData(t)};o._getSorters=function(){var n=this.options.getSortData;for(var t in n){var i=n[t];this._sorters[t]=a(i)}};o._updateItemsSortData=function(n){for(var i=n&&n.length,t=0;i&&t<i;t++){var r=n[t];r.updateSortData()}};var a=function(){function n(n){if("string"!=typeof n)return n;var i=l(n).split(" "),r=i[0],u=r.match(/^\[(.+)\]$/),o=u&&u[1],f=t(o,r),e=s.sortDataParsers[i[1]];return e?function(n){return n&&e(f(n))}:function(n){return n&&f(n)}}function t(n,t){return n?function(t){return t.getAttribute(n)}:function(n){var i=n.querySelector(t);return i&&i.textContent}}return n}();s.sortDataParsers={parseInt:function(n){return parseInt(n,10)},parseFloat:function(n){return parseFloat(n)}};o._sort=function(){if(this.options.sortBy){var n=u.makeArray(this.options.sortBy);this._getIsSameSortBy(n)||(this.sortHistory=n.concat(this.sortHistory));var t=c(this.sortHistory,this.options.sortAscending);this.filteredItems.sort(t)}};o._getIsSameSortBy=function(n){for(var t=0;t<n.length;t++)if(n[t]!=this.sortHistory[t])return!1;return!0};o._mode=function(){var n=this.options.layoutMode,t=this.modes[n];if(!t)throw new Error("No layout mode: "+n);return t.options=this.options[n],t};o._resetLayout=function(){t.prototype._resetLayout.call(this);this._mode()._resetLayout()};o._getItemLayoutPosition=function(n){return this._mode()._getItemLayoutPosition(n)};o._manageStamp=function(n){this._mode()._manageStamp(n)};o._getContainerSize=function(){return this._mode()._getContainerSize()};o.needsResizeLayout=function(){return this._mode().needsResizeLayout()};o.appended=function(n){var t=this.addItems(n);if(t.length){var i=this._filterRevealAdded(t);this.filteredItems=this.filteredItems.concat(i)}};o.prepended=function(n){var t=this._itemize(n);if(t.length){this._resetLayout();this._manageStamps();var i=this._filterRevealAdded(t);this.layoutItems(this.filteredItems);this.filteredItems=i.concat(this.filteredItems);this.items=t.concat(this.items)}};o._filterRevealAdded=function(n){var t=this._filter(n);return this.hide(t.needHide),this.reveal(t.matches),this.layoutItems(t.matches,!0),t.matches};o.insert=function(n){var i=this.addItems(n);if(i.length){for(var u,r=i.length,t=0;t<r;t++)u=i[t],this.element.appendChild(u.element);var f=this._filter(i).matches;for(t=0;t<r;t++)i[t].isLayoutInstant=!0;for(this.arrange(),t=0;t<r;t++)delete i[t].isLayoutInstant;this.reveal(f)}};var v=o.remove;return o.remove=function(n){n=u.makeArray(n);var t=this.getItems(n);v.call(this,n);for(var r=t&&t.length,i=0;r&&i<r;i++){var f=t[i];u.removeFrom(this.filteredItems,f)}},o.shuffle=function(){for(var n=0;n<this.items.length;n++){var t=this.items[n];t.sortData.random=Math.random()}this.options.sortBy="random";this._sort();this._layout()},o._noTransition=function(n,t){var i=this.options.transitionDuration;this.options.transitionDuration=0;var r=n.apply(this,t);return this.options.transitionDuration=i,r},o.getFilteredItemElements=function(){return this.filteredItems.map(function(n){return n.element})},s});
/*! Ajax Search pro 4.11.10 js */
(function(n){var i=[],r,a=!0,v={errors:{noui:{msg:"Warning: Seems like you are using sliders in search settings,\n"+"but NoUI Slider script is not loaded!\n\n"+"Go to Ajax Search Pro -> Compatibility settings submenu to enable it!",raised:!1,repeat:!1},isotope:{msg:"Warning: Seems like you are using isotopic layout,\n"+"but the Isotope JS script is not enabled!\n\n"+"Go to Ajax Search Pro -> Compatibility settings submenu to enable it!",raised:!1,repeat:!1},polaroid:{msg:"Warning: Seems like you are using polaroid layout,\n"+"but the Ploaroid gallery JS script is not enabled!\n\n"+"Go to Ajax Search Pro -> Compatibility settings submenu to enable it!",raised:!1,repeat:!1},datepicker:{msg:"Warning: Seems like you are using datepicker in search settings,\n"+"but the UI DatePicker script is not loaded!\n\n"+"Go to Ajax Search Pro -> Compatibility settings submenu to enable it!",raised:!1,repeat:!1},chosen:{msg:"Warning: Seems like you are using the Search feature (Chosen script) in search settings,\n"+"but the Chosen jQuery script is not loaded!\n\n"+"Go to Ajax Search Pro -> Compatibility settings submenu to enable it!",raised:!1,repeat:!1},missing_response:{msg:"Warning: The response data is missing from the ajax request!\n"+"This could mean a server related issue.\n\n"+"Check your .htaccess configuration and try disabling all other plugins to see if the problem persists.",raised:!1,repeat:!0}},raiseError:function(n){var t=this;(!t.errors[n].raised||t.errors[n].repeat)&&(alert(t.errors[n].msg),console.log(t.errors[n].msg),t.errors[n].raised=!0)},init:function(r,u){var o=this;this.elem=u;this.$elem=n(u);o.searching=!1;o.o=n.extend({},r);o.n={};o.n.container=n(this.elem);o.n.c=o.n.container;var s=o.n.container.attr("id").match(/^ajaxsearchpro(.*)_(.*)/);return o.o.rid=s[1]+"_"+s[2],o.o.iid=s[2],o.o.id=s[1],i[o.o.rid]=this,o.n.probox=n(".probox",o.n.container),o.n.proinput=n(".proinput",o.n.container),o.n.text=n(".proinput input.orig",o.n.container),o.n.textAutocomplete=n(".proinput input.autocomplete",o.n.container),o.n.loading=n(".proinput .loading",o.n.container),o.n.proloading=n(".proloading",o.n.container),o.n.proclose=n(".proclose",o.n.container),o.n.promagnifier=n(".promagnifier",o.n.container),o.n.prosettings=n(".prosettings",o.n.container),o.n.searchsettings=n("#ajaxsearchprosettings"+o.o.rid),o.n.trythis=n("#asp-try-"+o.o.rid),o.o.blocking=!1,o.resultsOpened=!1,o.n.searchsettings.length<=0&&(o.n.searchsettings=n("#ajaxsearchprobsettings"+o.o.rid),o.o.blocking=!0),o.n.resultsDiv=n("#ajaxsearchprores"+o.o.rid),o.n.hiddenContainer=n("#asp_hidden_data"),o.n.hiddenContainer2=n("#asp_hidden_data_"+o.o.rid),o.n.aspItemOverlay=n(".asp_item_overlay",o.n.hiddenContainer2),o.resizeTimeout=null,o.triggerPrevState=!1,o.isAutoP=!1,o.settingsChanged=!1,typeof n.browser!="undefined"&&typeof n.browser.mozilla!="undefined"&&typeof n.browser.version!="undefined"&&parseInt(n.browser.version)>13&&o.n.searchsettings.addClass("asp_firefox"),o.n.showmore=n(".showmore",o.n.resultsDiv),o.n.items=n(".item",o.n.resultsDiv).length>0?n(".item",o.n.resultsDiv):n(".photostack-flip",o.n.resultsDiv),o.n.results=n(".results",o.n.resultsDiv),o.n.resdrg=n(".resdrg",o.n.resultsDiv),t()&&(o.o.triggerontype=o.o.mobile.trigger_on_type,o.o.redirectClickTo=o.o.mobile.click_action,o.o.redirectClickLoc=o.o.mobile.click_action_location,o.o.redirectEnterTo=o.o.mobile.return_action,o.o.redirectEnterLoc=o.o.mobile.return_action_location,o.o.redirect_url=o.o.mobile.redirect_url,o.o.redirectonclick=o.o.redirectClickTo=="ajax_search"?0:1,o.o.redirect_on_enter=o.o.redirectEnterTo=="ajax_search"?0:1),f()&&t()&&y()?(o.clickTouchend="touchend",o.mouseupTouchend="touchend"):(o.clickTouchend="click touchend",o.mouseupTouchend="mouseup touchend"),o.o.resPage.useAjax=o.o.compact.enabled?0:o.o.resPage.useAjax,o.n.trythis.detach().insertAfter(o.n.container),o.il={columns:3,rows:o.o.isotopic.pagination?o.o.isotopic.rows:1e4,itemsPerPage:6,lastVisibleItem:-1},o.noUiSliders=[],o.timeouts={compactBeforeOpen:null,compactAfterOpen:null,searchWithCheck:null},o.firstClick=!0,o.post=null,o.postAuto=null,o.cleanUp(),o.n.textAutocomplete.val(""),o.o.resultitemheight=parseInt(o.o.resultitemheight),o.scroll={},o.savedScrollTop=0,o.savedContainerTop=0,o.is_scroll=typeof n.fn.mCustScr!="undefined",typeof ASP.scrollbar!="undefined"&&ASP.scrollbar==0&&(o.is_scroll=!1),o.settScroll=null,o.n.resultsAppend=n("#wpdreams_asp_results_"+o.o.id),o.n.settingsAppend=n("#wpdreams_asp_settings_"+o.o.id),o.currentPage=1,o.isotopic=null,o.sIsotope=null,o.lastSuccesfulSearch="",o.lastSearchData={},o.supportTransform=k(),o._no_animations=!1,o.resInfoBoxTxt=o.n.resultsDiv.find(".asp_results_top p.asp_rt_phrase").length>0?o.n.resultsDiv.find(".asp_results_top p.asp_rt_phrase").html():"",o.resInfoBoxTxtNoPhrase=o.n.resultsDiv.find(".asp_results_top p.asp_rt_nophrase").length>0?o.n.resultsDiv.find(".asp_results_top p.asp_rt_nophrase").html():"",o.call_num=0,o.results_num=0,o.animOptions=t()?o.o.animations.mob:o.o.animations.pc,o.asp_lazy=!1,o.o.redirect_url=p(o.o.redirect_url),o.animationOpacity=o.animOptions.items.indexOf("In")<0?"opacityOne":"opacityZero",o.filterFns={number:function(){for(var t=n(this).parent();!t.hasClass("isotopic");)t=t.parent();var i=n(this).attr("data-itemnum"),r=o.currentPage,u=o.il.itemsPerPage;return i%(o.il.columns*o.il.rows)<o.il.columns*(o.il.rows-1)?n(this).addClass("asp_gutter_bottom"):n(this).removeClass("asp_gutter_bottom"),parseInt(i,10)<u*r&&parseInt(i,10)>=u*(r-1)}},o.o.compact.overlay==1&&n("#asp_absolute_overlay").length<=0&&n("<div id='asp_absolute_overlay'><\/div>").appendTo("body"),o.disableMobileScroll=!1,o.originalFormData=e(n("form",o.n.searchsettings)),ASP.js_retain_popstate==1&&o.initPrevState(),o.initCompact(),o.initSettingsBox(),o.initResultsBox(),o.monitorTouchMove(),b()&&o.n.container.addClass("asp_msie"),o.initSettingsAnimations(),o.initResultsAnimations(),o.initEvents(),o.initAutop(),o.initEtc(),o.initInfiniteScroll(),o.fixAccessibility(),a=!1,o.n.c.trigger("asp_init_search_bar",[o.o.id,o.o.iid]),this},initPrevState:function(){var t=this;a&&r==null&&(r=localStorage.getItem("asp-"+u.encode(location.href)),r!=null&&(r=JSON.parse(r),r.settings=u.decode(r.settings)));r!=null&&typeof r.id!="undefined"&&r.id==t.o.id&&r.instance==t.o.iid&&(r.phrase!=""&&(t.triggerPrevState=!0,t.n.text.val(r.phrase)),e(n("form",t.n.searchsettings))!=r.settings&&(t.triggerPrevState=!0,e(n("form",t.n.searchsettings),r.settings)));localStorage.removeItem("asp-"+u.encode(location.href));t.n.resultsDiv.on("click",".results .item",function(){var i=t.n.text.val();if(i!=""||t.settingsChanged){var r={id:t.o.id,instance:t.o.iid,phrase:i,settings:u.encode(e(n("form",t.n.searchsettings)))};localStorage.setItem("asp-"+u.encode(location.href),JSON.stringify(r))}})},initCompact:function(){var t=this;if(t.o.compact.enabled==1&&t.o.compact.position!="fixed"&&(t.o.compact.overlay=0),t.o.compact.enabled==1&&t.n.trythis.css({display:"none"}),t.o.compact.enabled==1&&t.o.compact.position=="fixed")var i=setInterval(function(){t.n.container.css("position")=="fixed"&&(t.n.container.detach().appendTo("body"),t.n.trythis.detach().appendTo("body"),t.n.container.css({top:t.n.container.offset().top-n(document).scrollTop()}),clearInterval(i))},200)},initSettingsBox:function(){var n=this;if(t()&&n.o.mobile.force_sett_hover==1)return n.n.searchsettings.attr("id",n.n.searchsettings.attr("id").replace("probsettings","prosettings")),n.n.searchsettings.detach().appendTo("body"),n.o.blocking=!1,!0;n.n.settingsAppend.length>0?(n.o.blocking==!1&&(n.n.searchsettings.attr("id",n.n.searchsettings.attr("id").replace("prosettings","probsettings")),n.o.blocking=!0),n.n.searchsettings.detach().appendTo(n.n.settingsAppend)):n.o.blocking==!1&&n.n.searchsettings.detach().appendTo("body")},initResultsBox:function(){var n=this;t()&&n.o.mobile.force_res_hover==1?(n.o.resultsposition="hover",n.n.resultsDiv.detach().appendTo("body")):n.o.resultsposition=="hover"&&n.n.resultsAppend.length<=0?n.n.resultsDiv.detach().appendTo("body"):n.n.resultsAppend.length>0?(n.o.resultsposition="block",n.n.resultsDiv.css({position:"static"}),n.n.resultsDiv.detach().appendTo(n.n.resultsAppend)):(n.o.resultsposition="block",n.n.resultsDiv.css({position:"static"}),n.n.resultsDiv.detach().insertAfter(n.n.container));n.o.resultstype=="horizontal"?n.createHorizontalScroll():n.o.resultstype=="vertical"&&n.createVerticalScroll();n.o.resultstype=="polaroid"&&n.n.results.addClass("photostack")},initInfiniteScroll:function(){var t=this;if(t.o.resultstype=="polaroid")return!1;if(t.o.show_more.infinite){var i;n(window).add(t.n.results).on("scroll",function(){clearTimeout(i);i=setTimeout(function(){var i=n(".item",t.n.resultsDiv);if(t.n.showmore.length==0||t.n.showmore.css("display")=="none"||t.o.resultstype=="isotopic"&&n("nav.asp_navigation",t.n.resultsDiv).css("display")!="none"||t.o.resultstype=="vertical"&&n(".mCS_y_hidden",t.n.resultsDiv).length<1||t.o.resultstype=="horizontal"&&n(".mCS_x_hidden",t.n.resultsDiv).length<1)return!1;var r=i.last().is(":in-viewport(0, .asp_r_"+t.o.rid+")"),u=i.last().is(":in-viewport(0)");!t.searching&&i.length>0&&r&&u&&t.n.showmore.find("a.asp_showmore").trigger("click")},80)});var r;t.n.resultsDiv.on("nav_switch",function(){clearTimeout(r);r=setTimeout(function(){if(t.n.showmore.length==0||t.n.showmore.css("display")=="none")return!1;var i=n(".item",t.n.resultsDiv);!t.searching&&i.length>0&&t.n.resultsDiv.find("nav.asp_navigation ul li").last().hasClass("asp_active")&&t.n.showmore.find("a.asp_showmore").trigger("click")},800)})}},monitorTouchMove:function(){var t=this;t.dragging=!1;n("body").on("touchmove",function(){t.dragging=!0});n("body").on("touchstart",function(){t.dragging=!1})},duplicateCheck:function(){var i=this,t={};n("div[id*=ajaxsearchpro]").each(function(){t.hasOwnProperty(this.id)?n(this).remove():t[this.id]="true"})},analytics:function(n){var t=this,i=typeof __gaTracker=="function"?__gaTracker:typeof ga=="function"?ga:null;window.location.origin||(window.location.origin=window.location.protocol+"//"+window.location.hostname+(window.location.port?":"+window.location.port:""));var r=t.o.homeurl.replace(window.location.origin,"");i!=null&&t.o.analytics&&t.o.analyticsString!=""&&i("send","pageview",{page:r+t.o.analyticsString.replace("{asp_term}",n),title:"Ajax Search"})},createVerticalScroll:function(){var n=this;if(n.is_scroll)n.scroll=n.n.results.mCustScr({contentTouchScroll:25,scrollButtons:{enable:!0},mouseWheel:{preventDefault:!!n.o.compact.enabled},documentTouchScroll:!(n.o.compact.enabled||t()),scrollInertia:400,alwaysTriggerOffsets:!1,callbacks:{whileScrolling:function(){Math.abs(this.mcs.top%20)==0&&typeof n.asp_lazy.update!="undefined"&&n.asp_lazy.update()},onScroll:function(){},onTotalScrollOffset:200,onTotalScroll:function(){n.o.show_more.infinite&&n.n.showmore.length>0&&n.n.showmore.css("display")!="none"&&n.n.showmore.find("a.asp_showmore").trigger("click")}}});else n.n.results.on("scroll",function(){typeof n.asp_lazy.update!="undefined"&&n.asp_lazy.update()})},createHorizontalScroll:function(){var i=this;if(i.is_scroll)i.scroll=i.n.results.mCustScr({axis:"x",mouseWheel:{preventDefault:!!i.o.compact.enabled},documentTouchScroll:!(i.o.compact.enabled||t()),scrollButtons:{enable:!0},scrollInertia:400,alwaysTriggerOffsets:!1,callbacks:{whileScrolling:function(){Math.abs(this.mcs.left%20)==0&&typeof n.fn.asp_lazy!="undefined"&&n(window).trigger("scroll")},onTotalScrollOffset:200,onTotalScroll:function(){i.o.show_more.infinite&&i.n.showmore.length>0&&i.n.showmore.css("display")!="none"&&i.n.showmore.find("a.asp_showmore").trigger("click")}}});else i.n.results.on("scroll",function(){typeof i.asp_lazy.update!="undefined"&&i.asp_lazy.update()})},initAutop:function(){var n=this;if(r!=null&&!n.o.compact.enabled&&n.triggerPrevState)return n.search(),r=null,!1;if(n.o.autop.state=="disabled")return!1;var t=n.o.show_more.enabled&&n.o.show_more.action=="ajax"?!1:n.o.autop.count,i=0,u=setInterval(function(){ASP.css_loaded==!0&&(n.isAutoP=!0,n.o.autop.state=="phrase"?(n.n.text.val(n.o.autop.phrase),n.search(t)):n.o.autop.state=="latest"?n.search(t,1):n.search(t,2),clearInterval(u));i++;i>6&&clearInterval(u)},500)},initEtc:function(){var t=this,i=null;t.n.trythis.css({visibility:"visible"});n("div.asp_option",t.n.searchsettings).on(t.mouseupTouchend,function(r){if(r.preventDefault(),r.stopImmediatePropagation(),t.dragging)return!1;n('input[type="checkbox"]',this).prop("checked",!n('input[type="checkbox"]',this).prop("checked"));clearTimeout(i);var u=this;i=setTimeout(function(){n('input[type="checkbox"]',u).trigger("asp_chbx_change")},50)});n("div.asp_option label",t.n.searchsettings).click(function(n){n.preventDefault()});n("fieldset.asp_checkboxes_filter_box",t.n.searchsettings).each(function(){var t=!0;n('.asp_option:not(.asp_option_selectall) input[type="checkbox"]',this).each(function(){if(n(this).prop("checked")==!0)return t=!1,!1});t&&n('.asp_option_selectall input[type="checkbox"]',this).prop("checked",!1)});n("fieldset",t.n.searchsettings).each(function(){n(".asp_option:not(.hiddend)",this).last().addClass("asp-o-last")});n('.asp_option_cat input[type="checkbox"], .asp_option_cff input[type="checkbox"]',t.n.searchsettings).on("asp_chbx_change",function(){var i=n(this).data("targetclass");typeof i=="string"&&i!=""&&n("input."+i,t.n.searchsettings).prop("checked",n(this).prop("checked"))});n('.asp_option_cat input[type="checkbox"]',t.n.searchsettings).on("asp_chbx_change",function(){for(var r=n(this),t=n(this).parent(),i=0;!t.hasClass("asp_option_cat");)if(t=t.parent(),i++,i>5)break;var u=parseInt(t.data("lvl"))+1;for(i=0;!0;){if(t=t.next(),t.length>0&&typeof t.data("lvl")!="undefined"&&parseInt(t.data("lvl"))>=u)n('input[type="checkbox"]',t).prop("checked",r.prop("checked"));else break;if(i++,i>400)break}})},initEvents:function(){var i=this;i.n.searchsettings.on("click",function(){i.settingsChanged=!0});if(t()&&f())i.n.text.on("touchstart",function(){i.savedScrollTop=n(window).scrollTop();i.savedContainerTop=i.n.container.offset().top});i.n.text.click(function(){n(this).focus()});i.n.text.on("focus input",function(){i.searching||(n(this).val()!=""?i.n.proclose.css("display","block"):i.n.proclose.css({display:"none"}))});n(i.n.text.closest("form")).submit(function(n,r){if(n.preventDefault(),t())if(i.o.redirect_on_enter){var u=jQuery.Event("keyup");u.keyCode=u.which=13;i.n.text.trigger(u)}else i.search(),document.activeElement.blur();else typeof r!="undefined"&&r=="ajax"&&i.search()});i.n.resultsDiv.css({opacity:0});n(document).on(i.clickTouchend,function(t){for(var r=n(t.target).parent(),u=5,e=t.keyCode||t.which,f=t.type;!r.hasClass("ui-datepicker")&&u>0;)r=r.parent(),u--;if(i.o.blocking==!1&&u<=0&&i.hideSettings(),i.hideOnInvisibleBox(),f!="click"||f!="touchend"||e!=3){if(i.o.compact.enabled){var o=i.n.container.attr("asp-compact")||"closed";i.o.compact.closeOnDocument!=1||o!="open"||i.resultsOpened||(i.closeCompact(),i.post!=null&&i.post.abort(),i.hideLoader())}else if(i.resultsOpened==!1||i.o.closeOnDocClick!=1)return;i.dragging||i.hideResults()}});i.n.proclose.bind(i.clickTouchend,function(n){n.preventDefault();n.stopImmediatePropagation();i.n.text.val("");i.n.textAutocomplete.val("");i.hideResults();i.n.text.focus();i.n.proloading.css("display","none");i.hideLoader();i.post!=null&&i.post.abort()});n(i.elem).bind(i.clickTouchend,function(n){n.stopImmediatePropagation()});i.o.resultstype=="isotopic"&&typeof i.n.resultsDiv.swipe!="undefined"?(i.n.resultsDiv.swipe({excludedElements:"button, input, select, textarea, .noSwipe",preventDefaultEvents:!f()&&!w(),swipeLeft:function(){i.visiblePagination()&&n("a.asp_next",i.n.resultsDiv).click()},swipeRight:function(){i.visiblePagination()&&n("a.asp_prev",i.n.resultsDiv).click()}}),i.n.resultsDiv.bind("click",function(n){n.stopImmediatePropagation()})):i.n.resultsDiv.bind(i.clickTouchend,function(n){n.stopImmediatePropagation()});i.n.searchsettings.bind(i.clickTouchend,function(t){typeof t.target=="undefined"||n(t.target).hasClass("noUi-handle")?t.type=="click"&&t.stopImmediatePropagation():t.stopImmediatePropagation()});i.n.prosettings.on("click",function(){i.n.prosettings.data("opened")==0?i.showSettings():i.hideSettings()});t()&&i.o.mobile.force_sett_hover==1?i.o.mobile.force_sett_state=="open"&&i.n.prosettings.click():i.o.settingsVisible==1&&i.n.prosettings.click();var e=i.n.container.parents().filter(function(){return n(this).css("position")=="fixed"});if((e.length>0||i.n.container.css("position")=="fixed")&&(i.n.resultsDiv.css("position")=="absolute"&&i.n.resultsDiv.css("position","fixed"),i.o.blocking||i.n.searchsettings.css("position","fixed")),t())n(window).on("orientationchange",function(){i.orientationChange();setTimeout(function(){i.orientationChange()},600)});else{var r;n(window).on("resize",function(){clearTimeout(r);r=setTimeout(function(){i.resize()},100)})}var u;n(window).on("scroll",function(){clearTimeout(u);u=setTimeout(function(){i.scrolling(!1)},400)});f()&&t()&&y()&&parseInt(i.n.text.css("font-size"))<16&&(i.n.text.data("fontSize",i.n.text.css("font-size")).css("font-size","16px"),i.n.textAutocomplete.css("font-size","16px"),n("<style>#ajaxsearchpro"+i.o.rid+" input.orig::-webkit-input-placeholder{font-size: 16px !important;}<\/style>").appendTo("head"));i.initNavigationEvent();i.initMagnifierEvent();i.initAutocompleteEvent();i.initPagerEvent();i.initOverlayEvent();i.initNoUIEvents();i.initDatePicker();i.initCFDatePicker();i.initChosen();i.initFacetEvents()},initNavigationEvent:function(){var t=this;n(t.n.resultsDiv).on("mouseenter",".item",function(){n(".item",t.n.resultsDiv).removeClass("hovered");n(this).addClass("hovered")});n(t.n.resultsDiv).on("mouseleave",".item",function(){n(".item",t.n.resultsDiv).removeClass("hovered")});n(document).keydown(function(i){var r=i.keyCode||i.which;n(".item",t.n.resultsDiv).length>0&&t.n.resultsDiv.css("display")!="none"&&t.o.resultstype=="vertical"&&t.is_scroll&&t.n.results.find(".mCS_no_scrollbar_y").length==0&&(r==40&&(t.n.text.blur(),t.post!=null&&t.post.abort(),n(".item.hovered",t.n.resultsDiv).length==0?n(".item",t.n.resultsDiv).first().addClass("hovered"):n(".item.hovered",t.n.resultsDiv).removeClass("hovered").next().next(".item").addClass("hovered"),i.stopPropagation(),i.preventDefault(),t.scroll.mCustScr("scrollTo",".resdrg .item.hovered",{scrollInertia:200,callbacks:!1})),r==38&&(t.n.text.blur(),t.post!=null&&t.post.abort(),n(".item.hovered",t.n.resultsDiv).length==0?n(".item",t.n.resultsDiv).last().addClass("hovered"):(n(".item.hovered",t.n.resultsDiv).removeClass("hovered").prev().prev(".item").addClass("hovered"),i.stopPropagation(),i.preventDefault(),t.scroll.mCustScr("scrollTo",".resdrg .item.hovered",{scrollInertia:200,callbacks:!1}))),r==13&&n(".item.hovered",t.n.resultsDiv).length>0&&(i.stopPropagation(),i.preventDefault(),n(".item.hovered a.asp_res_url",t.n.resultsDiv).get(0).click()))})},initMagnifierEvent:function(){var t=this;t.o.compact.enabled==1&&t.initCompactEvents();var i,u,r=!1;t.n.searchsettings.find("button.asp_s_btn").on("click",function(r){t.ktype="button";r.preventDefault();t.n.text.val().length>=t.o.charcount&&(t.o.sb.redirect_action!="ajax_search"?t.o.sb.redirect_action!="first_result"?t.doRedirectToResults("button"):t.search():n("form",t.n.searchsettings).serialize()+t.n.text.val().trim()==t.lastSuccesfulSearch&&t.resultsOpened||t.search(),clearTimeout(i))});t.n.searchsettings.find("button.asp_r_btn").on("click",function(n){n.preventDefault();t.resetSearchFilters()});t.n.text.on("keyup",function(f){if(t.keycode=f.keyCode||f.which,t.ktype=f.type,t.keycode==13){if(clearTimeout(u),u=setTimeout(function(){r=!1},300),r)return!1;r=!0}var e=n(this).hasClass("orig");t.n.text.val().length>=t.o.charcount&&e&&t.ktype=="keyup"&&t.keycode==13&&(t.o.redirect_on_enter==1?t.o.redirectEnterTo!="first_result"?t.doRedirectToResults(t.ktype):t.search():n("form",t.n.searchsettings).serialize()+t.n.text.val().trim()==t.lastSuccesfulSearch&&t.resultsOpened||t.search(),clearTimeout(i))});t.n.promagnifier.add(t.n.text).on("click input",function(r){t.keycode=r.keyCode||r.which;t.ktype=r.type;var u=n(this).hasClass("orig");if(u&&t.ktype=="click"&&n("form",t.n.searchsettings).serialize()+t.n.text.val().trim()==t.lastSuccesfulSearch){t.resultsOpened||t.o.resPage.useAjax!=0||(t._no_animations=!0,t.showResults(),t._no_animations=!1);return}if((!u||t.ktype!="click")&&(t.ktype=="click"||t.ktype=="input")&&(t.o.compact.enabled!=1||t.ktype!="click"&&t.ktype!="touchend"||t.o.compact.closeOnMagnifier!=1)){var f=t.n.container.attr("asp-compact")||"closed";if(t.o.compact.enabled!=1||t.ktype!="click"&&t.ktype!="touchend"||f!="closed"){if(t.n.text.val().length>=t.o.charcount&&!u&&t.o.redirectonclick==1&&t.ktype=="click"&&t.o.redirectClickTo!="first_result"){t.doRedirectToResults(t.ktype);clearTimeout(i);return}if((t.ktype!="input"||t.o.triggerontype!=0)&&(t.ktype!="click"||t.o.trigger_on_click)){if(t.n.text.val().length<t.o.charcount){t.n.proloading.css("display","none");t.o.blocking==!1&&t.hideSettings();t.hideResults(!1);t.post!=null&&t.post.abort();clearTimeout(i);return}t.post!=null&&t.post.abort();clearTimeout(i);t.n.proloading.css("display","none");i=setTimeout(function(){n("form",t.n.searchsettings).serialize()+t.n.text.val().trim()==t.lastSuccesfulSearch&&(t.resultsOpened||t.o.resPage.useAjax)?t.isRedirectToFirstResult()?t.doRedirectToFirstResult():t.n.proclose.css("display","block"):t.search()},t.o.trigger.delay)}}}})},isRedirectToFirstResult:function(){var t=this;return n(".asp_res_url",t.n.resultsDiv).length>0&&(t.o.redirectonclick==1&&t.ktype=="click"&&t.o.redirectClickTo=="first_result"||t.o.redirect_on_enter==1&&(t.ktype=="input"||t.ktype=="keyup")&&t.keycode==13&&t.o.redirectEnterTo=="first_result"||t.ktype=="button"&&t.o.sb.redirect_action=="first_result")?!0:!1},doRedirectToFirstResult:function(){var t=this,i;return i=t.ktype=="click"?t.o.redirectClickLoc:t.ktype=="button"?t.o.sb.redirect_location:t.o.redirectEnterLoc,i=="same"?location.href=n(n(".asp_res_url",t.n.resultsDiv).get(0)).attr("href"):l(n(n(".asp_res_url",t.n.resultsDiv).get(0)).attr("href")),t.hideLoader(),t.hideResults(),!1},doRedirectToResults:function(t){var i=this,u=t=="click"?i.o.redirectClickLoc:t=="button"?i.o.sb.redirect_location:i.o.redirectEnterLoc;var r=i.getRedirectURL(t);if(i.o.overridewpdefault){if(i.o.resPage.useAjax==1)return i.hideResults(),i.liveLoad(r,i.o.resPage.selector),i.showLoader(),i.o.blocking==!1&&i.hideSettings(),!1;i.o.override_method=="post"?o(r,"post",{asp_active:1,p_asid:i.o.id,p_asp_data:n("form",i.n.searchsettings).serialize()},u):u=="same"?location.href=r:l(r)}else o(r,"post",{np_asid:i.o.id,np_asp_data:n("form",i.n.searchsettings).serialize()},u);i.n.proloading.css("display","none");i.hideLoader();i.o.blocking==!1&&i.hideSettings();i.hideResults();i.post!=null&&i.post.abort()},initCompactEvents:function(){var t=this,i=0;t.n.promagnifier.click(function(){var r=t.n.container.attr("asp-compact")||"closed";if(i=n(window).scrollTop(),t.hideSettings(),t.hideResults(),r=="closed")t.openCompact(),t.n.text.focus();else{if(t.o.compact.closeOnMagnifier!=1)return;t.closeCompact();t.post!=null&&t.post.abort();t.n.proloading.css("display","none")}})},openCompact:function(){var t=this;t.n.container.is("[asp-compact-w]")||(t.n.probox.attr("asp-compact-w",t.n.probox.width()),t.n.container.attr("asp-compact-w",t.n.container.width()));t.o.compact.enabled==1&&t.o.compact.position!="static"&&t.n.trythis.css({top:t.n.container.position().top+t.n.container.outerHeight(!0),left:t.n.container.offset().left});t.n.container.css({width:t.n.container.width()});t.n.probox.css({width:"auto"});setTimeout(function(){n(">:not(.promagnifier)",t.n.probox).removeClass("hiddend")},80);clearTimeout(t.timeouts.compactBeforeOpen);t.timeouts.compactBeforeOpen=setTimeout(function(){var i;i=h()=="phone"?t.o.compact.width_phone:h()=="tablet"?t.o.compact.width_tablet:t.o.compact.width;t.n.container.css({"max-width":i,width:i});t.o.compact.overlay==1&&(t.n.container.css("z-index",999999),t.n.searchsettings.css("z-index",999999),t.n.resultsDiv.css("z-index",999999),t.n.trythis.css("z-index",999998),n("#asp_absolute_overlay").css({opacity:1,width:"100%",height:"100%","z-index":999990}))},50);clearTimeout(t.timeouts.compactAfterOpen);t.timeouts.compactAfterOpen=setTimeout(function(){t.resize();t.n.trythis.css({display:"block"});t.n.text.focus();t.scrolling()},500);t.n.container.attr("asp-compact","open")},closeCompact:function(){var t=this;clearTimeout(t.timeouts.compactBeforeOpen);clearTimeout(t.timeouts.compactAfterOpen);n(">:not(.promagnifier)",t.n.probox).addClass("hiddend");t.n.container.css({width:"auto"});t.n.probox.css({width:t.n.probox.attr("asp-compact-w")});t.n.trythis.css({left:t.n.container.position().left,display:"none"});t.o.compact.overlay==1&&(t.n.container.css("z-index",""),t.n.searchsettings.css("z-index",""),t.n.resultsDiv.css("z-index",""),t.n.trythis.css("z-index",""),n("#asp_absolute_overlay").css({opacity:0,width:0,height:0,"z-index":0}));t.n.container.attr("asp-compact","closed")},initAutocompleteEvent:function(){var i=this,r;(i.o.autocomplete.enabled==1&&!t()||i.o.autocomplete.mobile==1&&t())&&i.n.text.keyup(function(t){i.keycode=t.keyCode||t.which;i.ktype=t.type;var u=39;n("body").hasClass("rtl")&&(u=37);i.keycode==u&&i.n.textAutocomplete.val()!=""?(t.preventDefault(),i.n.text.val(i.n.textAutocomplete.val()),i.o.triggerontype!=0&&(i.post!=null&&i.post.abort(),i.search())):(clearTimeout(r),i.postAuto!=null&&i.postAuto.abort(),i.o.autocomplete.googleOnly==1?i.autocompleteGoogleOnly():r=setTimeout(function(){i.autocomplete();r=null},i.o.trigger.autocomplete_delay))})},initPagerEvent:function(){var i=this;i.n.resultsDiv.on(i.clickTouchend+" click_trigger","nav>a",function(r){r.preventDefault();r.stopImmediatePropagation();var u=this,e=r.type,f=1;i.n.text.is(":focus")&&t()&&(i.n.text.blur(),f=300);setTimeout(function(){i.currentPage=parseInt(n(u).closest("nav").find("li.asp_active span").html(),10);i.currentPage=n(u).hasClass("asp_prev")&&!n("body").hasClass("rtl")?i.currentPage==1?Math.ceil(i.n.items.length/i.il.itemsPerPage):--i.currentPage:i.currentPage==Math.ceil(i.n.items.length/i.il.itemsPerPage)?1:++i.currentPage;n("nav>ul li",i.n.resultsDiv).removeClass("asp_active");n("nav",i.n.resultsDiv).each(function(){n(n("ul li",this).get(i.currentPage-1)).addClass("asp_active")});e==="click_trigger"?i.isotopic.arrange({transitionDuration:0,filter:i.filterFns.number}):i.isotopic.arrange({transitionDuration:400,filter:i.filterFns.number});i.isotopicPagerScroll();i.removeAnimation();typeof n.fn.asp_lazy!="undefined"&&n(window).trigger("scroll");i.n.resultsDiv.trigger("nav_switch")},f)});i.n.resultsDiv.on(i.clickTouchend+" click_trigger","nav>ul li",function(r){r.preventDefault();r.stopImmediatePropagation();var f=r.type,e=this,u=1;i.n.text.is(":focus")&&t()&&(i.n.text.blur(),u=300);setTimeout(function(){i.currentPage=parseInt(n("span",e).html(),10);n("nav>ul li",i.n.resultsDiv).removeClass("asp_active");n("nav",i.n.resultsDiv).each(function(){n(n("ul li",this).get(i.currentPage-1)).addClass("asp_active")});f==="click_trigger"?i.isotopic.arrange({transitionDuration:0,filter:i.filterFns.number}):i.isotopic.arrange({transitionDuration:400,filter:i.filterFns.number});i.isotopicPagerScroll();i.removeAnimation();typeof n.fn.asp_lazy!="undefined"&&n(window).trigger("scroll");i.n.resultsDiv.trigger("nav_switch")},u)})},isotopicPagerScroll:function(){var t=this;if(n("nav>ul li.asp_active",t.n.resultsDiv).length<=0)return!1;var r=n("nav>ul li.asp_active",t.n.resultsDiv).offset().left,i=n("nav>ul li.asp_active",t.n.resultsDiv).outerWidth(!0),u=n("nav>a.asp_next",t.n.resultsDiv).offset().left,o=n("nav>a.asp_prev",t.n.resultsDiv).offset().left;if(!(i<=0)){var f=Math.ceil((o-r+2*i)/i);if(f>0){if(n("nav>ul li.asp_active",t.n.resultsDiv).prev().length==0){n("nav>ul",t.n.resultsDiv).css({left:i+"px"});return}n("nav>ul",t.n.resultsDiv).css({left:"+="+i*f+"px"})}else{if(n("nav>ul li.asp_active",t.n.resultsDiv).next().length==0)var e=Math.ceil((r-u+i)/i);else var e=Math.ceil((r-u+2*i)/i);e>0&&n("nav>ul",t.n.resultsDiv).css({left:"-="+i*e+"px"})}}},initOverlayEvent:function(){var t=this;if(t.o.resultstype=="isotopic"&&t.o.isotopic.showOverlay){if(!f()){t.n.resultsDiv.on("mouseenter","div.item",function(){n(".asp_item_overlay",this).fadeIn();n(".asp_item_img",this).length>0&&(t.o.isotopic.blurOverlay&&n(".asp_item_overlay_img",this).fadeIn(),t.o.isotopic.hideContent&&n(".asp_content",this).slideUp(100))});t.n.resultsDiv.on("mouseleave","div.item",function(){n(".asp_item_overlay",this).fadeOut();n(".asp_item_img",this).length>0&&(t.o.isotopic.blurOverlay&&n(".asp_item_overlay_img",this).fadeOut(),t.o.isotopic.hideContent&&n(".asp_item_img",this).length>0&&n(".asp_content",this).slideDown(100))});t.n.resultsDiv.on("mouseenter","div.asp_item_inner",function(){n(this).addClass("animated pulse")});t.n.resultsDiv.on("mouseleave","div.asp_item_inner",function(){n(this).removeClass("animated pulse")})}t.n.resultsDiv.on("mouseup",".asp_isotopic_item",function(t){var i=n(".asp_content h3 a",this).get(0);typeof i!="undefined"&&(t.which==2&&n(i).attr("target","_blank"),i.click())})}},initNoUIEvents:function(){var t=this;n(".noui-slider-json"+t.o.rid).each(function(i){var o=n(this).attr("id").match(/^noui-slider-json(.*)/)[1],f=n(this).data("aspnoui");if(typeof f=="undefined"||(f=u.decode(f),typeof f=="undefined"||f==""))return!1;var r=JSON.parse(f);if(n(r.node).length>0)var e=n(r.node).get(0);if(typeof noUiSlider!="undefined")noUiSlider.create(e,r.main);else return t.raiseError("noui"),!1;t.noUiSliders[i]=e;e.noUiSlider.on("update",function(t,i){var u=t[i];i?r.links.forEach(function(t){var i=wNumb(t.wNumb);t.handle=="upper"&&(n(t.target).is("input")?n(t.target).val(u):n(t.target).html(i.to(parseFloat(u))));n(r.node).on("slide",function(n){n.preventDefault()})}):r.links.forEach(function(t){var i=wNumb(t.wNumb);t.handle=="lower"&&(n(t.target).is("input")?n(t.target).val(u):n(t.target).html(i.to(parseFloat(u))));n(r.node).on("slide",function(n){n.preventDefault()})})})})},initDatePicker:function(){var i=this,t=window.jQuery;if(t(".asp_datepicker",i.n.searchsettings).length>0&&typeof t.fn.datepicker=="undefined")return i.raiseError("datepicker"),!1;function r(i,r,u,f){if(u!=null)var e=t(u);else var e=t("#"+r.id);var h=t(".asp_datepicker_hidden",t(e).parent()).val(),o="";if(e.datepicker("getDate")==null)t(".asp_datepicker_hidden",t(e).parent()).val("");else{var c=String(e.datepicker("getDate")),s=new Date(c.match(/(.*?)00\:/)[1].trim()+" GMT+0000"),l=String(s.getFullYear()),a=("0"+(s.getMonth()+1)).slice(-2),v=("0"+String(s.getDate())).slice(-2);o=l+"-"+a+"-"+v;t(".asp_datepicker_hidden",t(e).parent()).val(o)}(typeof nochage=="undefined"||f==null)&&o!=h&&n(e).change()}t(".asp_datepicker",i.n.searchsettings).each(function(){var f=t(".asp_datepicker_format",t(this).parent()).val(),i=this,u=t(this).val();t(this).datepicker({changeMonth:!0,changeYear:!0,dateFormat:"yy-mm-dd",onSelect:r,beforeShow:function(){t("#ui-datepicker-div").addClass("asp-ui")}});u==""?t(this).datepicker("setDate",""):t(this).datepicker("setDate",u);t(this).datepicker("option","dateFormat",f);r(null,null,i,!0);n(this).on("keyup",function(){n(i).datepicker("getDate")==null&&t(".asp_datepicker_hidden",n(i).parent()).val("");n(i).datepicker("hide")})})},initChosen:function(){var t=this;if(n("select.asp_gochosen",t.n.searchsettings).length>0){if(typeof n.fn.asp_chosen=="undefined")return t.raiseError("chosen"),!1;n("select.asp_gochosen",t.n.searchsettings).each(function(){n(this).asp_chosen({no_results_text:t.o.chosen.nores,search_contains:!0,width:"100%"})});setTimeout(function(){n(".chosen-container",t.n.searchsettings).each(function(t){n(this).css("zIndex",1040-t)})},1e3)}},initCFDatePicker:function(){var i=this,t=window.jQuery;if(t(".asp_datepicker_field",i.n.searchsettings).length>0&&typeof t.fn.datepicker=="undefined")return i.raiseError("datepicker"),!1;function r(i,r,u,f){if(u!=null)var e=t(u);else var e=t("#"+r.id);var h=t(".asp_datepicker_hidden",t(e).parent()).val(),o="";if(e.datepicker("getDate")==null)t(".asp_datepicker_hidden",t(e).parent()).val("");else{var c=String(e.datepicker("getDate")),s=new Date(c.match(/(.*?)00\:/)[1].trim()+" GMT+0000"),l=String(s.getFullYear()),a=("0"+(s.getMonth()+1)).slice(-2),v=("0"+String(s.getDate())).slice(-2);o=l+a+v;t(".asp_datepicker_hidden",t(e).parent()).val(o)}(typeof nochage=="undefined"||f==null)&&o!=h&&n(e).change()}t(".asp_datepicker_field",i.n.searchsettings).each(function(){var f=t(".asp_datepicker_format",t(this).parent()).val(),i=this,u=t(this).val();t(this).datepicker({changeMonth:!0,changeYear:!0,dateFormat:"dd/mm/yy",onSelect:r,beforeShow:function(){t("#ui-datepicker-div").addClass("asp-ui")}});u==""?t(this).datepicker("setDate",""):t(this).datepicker("setDate",u);t(this).datepicker("option","dateFormat",f);r(null,null,i,!0);n(this).on("keyup",function(){n(i).datepicker("getDate")==null&&t(".asp_datepicker_hidden",n(i).parent()).val("");n(i).datepicker("hide")})})},initFacetEvents:function(){var t=this;n(".asp_custom_f input[type=text]:not(.chosen-search-input):not(.asp_datepicker_field):not(.asp_datepicker)",t.n.searchsettings).on("keydown",function(n){var i=n.keyCode||n.which,r=this;i==13&&(n.preventDefault(),n.stopImmediatePropagation());t.n.searchsettings.find("input[name=filters_changed]").val(1);t.setFilterStateInput(65);t.o.triggerOnFacetChange!=0&&t.searchWithCheck(240)});if(t.o.triggerOnFacetChange!=0){n("input[type!=checkbox][type!=text], select",t.n.searchsettings).on("change slidechange",function(){t.n.searchsettings.find("input[name=filters_changed]").val(1);t.setFilterStateInput(65);t.searchWithCheck(80)});n("input[type=checkbox]",t.n.searchsettings).on("asp_chbx_change",function(){t.n.searchsettings.find("input[name=filters_changed]").val(1);t.setFilterStateInput(65);t.searchWithCheck(80)});n("input.asp_datepicker, input.asp_datepicker_field",t.n.searchsettings).on("change",function(){t.n.searchsettings.find("input[name=filters_changed]").val(1);t.setFilterStateInput(65);t.searchWithCheck(80)});n('div[id*="-handles"]',t.n.searchsettings).each(function(){if(typeof this.noUiSlider!="undefined")this.noUiSlider.on("change",function(){t.n.searchsettings.find("input[name=filters_changed]").val(1);t.setFilterStateInput(65);t.searchWithCheck(80)})})}},destroy:function(){return this.each(function(){var t=n.extend({},this,v);n(window).unbind(t)})},autocomplete:function(){var t=this,i=t.n.text.val();if(t.n.text.val()==""){t.n.textAutocomplete.val("");return}var r=t.n.textAutocomplete.val();if(r==""||r.indexOf(i)!=0){t.n.textAutocomplete.val("");var u={action:"ajaxsearchpro_autocomplete",asid:t.o.id,sauto:t.n.text.val(),asp_inst_id:t.o.rid,options:n("form",t.n.searchsettings).serialize()};t.postAuto=n.post(ASP.ajaxurl,u,function(r){if(r.length>0){r=n("<textarea />").html(r).text();var u=i,f=r.substr(i.length);r=u+f}t.n.textAutocomplete.val(r)})}},autocompleteGoogleOnly:function(){var t=this,i=t.n.text.val();if(t.n.text.val()==""){t.n.textAutocomplete.val("");return}var r=t.n.textAutocomplete.val();if(r==""||r.indexOf(i)!=0){t.n.textAutocomplete.val("");var u=t.o.autocomplete.lang;n.each(["wpml_lang","polylang_lang","qtranslate_lang"],function(i,r){if(n('input[name="'+r+'"]',t.n.searchsettings).length>0&&n('input[name="'+r+'"]',t.n.searchsettings).val().length>1)return u=n('input[name="'+r+'"]',t.n.searchsettings).val(),!1});n.ajax({url:"https://clients1.google.com/complete/search",dataType:"jsonp",data:{q:i,hl:u,nolabels:"t",client:"hp",ds:""},success:function(r){r[1].length>0&&(response=r[1][0][0].replace(/(<([^>]+)>)/ig,""),response=n("<textarea />").html(response).text(),response=response.substr(i.length),t.n.textAutocomplete.val(i+response))}})}},searchWithCheck:function(n){var t=this;(typeof n=="undefined"&&(n=50),t.n.text.val().length<t.o.charcount)||(t.post!=null&&t.post.abort(),clearTimeout(t.timeouts.searchWithCheck),t.timeouts.searchWithCheck=setTimeout(function(){t.search()},n))},search:function(t,i,r,f){var e=this;typeof r=="undefined"&&(r=!1);typeof f=="undefined"&&(f=!1);var s={action:"ajaxsearchpro_search",aspp:e.n.text.val(),asid:e.o.id,asp_inst_id:e.o.rid,options:n("form",e.n.searchsettings).serialize()};if(e.isAutoP&&(s.autop=1,e.isAutoP=!1),!r&&!f&&JSON.stringify(s)===JSON.stringify(e.lastSearchData))return(e.o.resPage.useAjax||e.resultsOpened||e.showResults(),e.isRedirectToFirstResult())?(e.doRedirectToFirstResult(),!1):(e.hideLoader(),!1);e.n.c.trigger("asp_search_start",[e.o.id,e.o.iid,e.n.text.val()]);e.searching=!0;e.n.proclose.css({display:"none"});e.showLoader(r);e.o.blocking==!1&&e.o.triggerOnFacetChange==0&&e.hideSettings();r?(e.call_num++,s.asp_call_num=e.call_num):e.call_num=0;var h="";n("#asp_preview_options").length>0&&(h=n("#asp_preview_options").html(),h!=""&&(s.asp_preview_options=h));typeof t!="undefined"&&t!==!1&&(s.options+="&force_count="+parseInt(t));typeof i!="undefined"&&i!==!1&&(s.options+="&force_order="+parseInt(i));e.analytics(e.n.text.val());e.o.resPage.useAjax?e.liveLoad(e.o.resPage.selector,e.getRedirectURL()):e.post=n.post(ASP.ajaxurl,s,function(t){t=t.replace(/^\s*[\r\n]/gm,"");var f=t.match(/!!ASPSTART_HTML!!(.*[\s\S]*)!!ASPEND_HTML!!/),i=t.match(/!!ASPSTART_DATA!!(.*[\s\S]*)!!ASPEND_DATA!!/);if(f==null||typeof f!="object"||typeof f[1]=="undefined")return e.hideLoader(),e.raiseError("missing_response"),!1;f=f[1];i=JSON.parse(i[1]);e.n.c.trigger("asp_search_end",[e.o.id,e.o.iid,e.n.text.val(),i]);r?(e.updateResults(f),e.results_num+=i.results_count):(e.n.resdrg.html(""),e.n.resdrg.html(f),e.results_num=i.results_count,e.o.statistics&&e.stat_addKeyword(e.o.id,e.n.text.val()));n(".asp_keyword",e.n.resdrg).on("click",function(){e.n.text.val(p(n(this).text()));e.n.textAutocomplete.val("");(e.o.redirectonclick==0||e.o.redirect_on_enter==0||e.o.triggerontype==1)&&e.search()});if(e.n.items=n(".item",e.n.resultsDiv).length>0?n(".item",e.n.resultsDiv):n(".photostack-flip",e.n.resultsDiv),e.isRedirectToFirstResult())return e.doRedirectToFirstResult(),!1;if(e.hideLoader(),e.showResults(),e.scrollToResults(),e.lastSuccesfulSearch=n("form",e.n.searchsettings).serialize()+e.n.text.val().trim(),e.lastSearchData=s,e.updateInfoHeader(i.full_results_count),e.n.showmore.length>0)if(n("span",e.n.showmore).length>0&&i.results_count>0&&i.full_results_count-e.results_num>0){e.n.showmore.css("display","block");n("span",e.n.showmore).html("("+(i.full_results_count-e.results_num)+")");n("a",e.n.showmore).attr("href","");n("a",e.n.showmore).off();n("a",e.n.showmore).on(e.clickTouchend,function(t){if(t.preventDefault(),t.stopImmediatePropagation(),e.o.show_more.action=="ajax")e.showMoreResLoader(),e.search(!1,!1,!0);else{if(e.o.show_more.action=="results_page")var i="?s="+c(e.n.text.val());else if(e.o.show_more.action=="woo_results_page")var i="?post_type=product&s="+c(e.n.text.val());else{var i=e.parseCustomRedirectURL(e.o.show_more.url,e.n.text.val());i=n("<textarea />").html(i).text()}e.o.homeurl.indexOf("?")>1&&i.indexOf("?")==0&&(i=i.replace("?","&"));e.o.overridewpdefault?e.o.override_method=="post"?o(e.o.homeurl+i,"post",{asp_active:1,p_asid:e.o.id,p_asp_data:n("form",e.n.searchsettings).serialize()},e.o.show_more.location):e.o.show_more.location=="same"?location.href=e.o.homeurl+i+"&asp_active=1&p_asid="+e.o.id+"&p_asp_data="+u.encode(n("form",e.n.searchsettings).serialize()):l(e.o.homeurl+i+"&asp_active=1&p_asid="+e.o.id+"&p_asp_data="+u.encode(n("form",e.n.searchsettings).serialize())):o(e.o.homeurl+i,"post",{np_asid:e.o.id,np_asp_data:n("form",e.n.searchsettings).serialize()},e.o.show_more.location)}})}else e.n.showmore.css("display","none"),n("span",e.n.showmore).html("")},"text").fail(function(t,i){t.aborted||i=="abort"||(e.n.resdrg.html(""),e.n.resdrg.html('<div class="asp_nores">The request failed. Please check your connection! Status: '+t.status+"<\/div>"),e.n.items=n(".item",e.n.resultsDiv).length>0?n(".item",e.n.resultsDiv):n(".photostack-flip",e.n.resultsDiv),e.results_num=0,e.hideLoader(),e.showResults(),e.scrollToResults())})},updateResults:function(t){var i=this;if(t.replace(/^\s*[\r\n]/gm,"")===""||n(t).hasClass("asp_nores")||n(t).find(".asp_nores").length>0)i.n.showmore.css("display","none"),n("span",i.n.showmore).html("");else if(i.o.resultstype=="isotopic"&&i.call_num>0&&i.isotopic!=null&&typeof i.isotopic.appended!="undefined"&&i.n.items.length>0){var r=n(t),u=i.n.items.last(),f=parseInt(i.n.items.last().attr("data-itemnum"));n.each(r,function(t){n(r[t]).attr("data-itemnum",++f);n(r[t]).css({width:u.css("width"),height:u.css("height")})});i.n.resdrg.append(r);i.isotopic.appended(r);i.n.items=n(".item",i.n.resultsDiv).length>0?n(".item",i.n.resultsDiv):n(".photostack-flip",i.n.resultsDiv)}else i.n.resdrg.html(i.n.resdrg.html()+t)},showResults:function(){var i=this;switch(i.o.resultstype){case"horizontal":i.showHorizontalResults();break;case"vertical":i.showVerticalResults();break;case"polaroid":i.showPolaroidResults();break;case"isotopic":i.showIsotopicResults();break;default:i.showHorizontalResults()}i.hideLoader();i.n.proclose.css({display:"block"});t()&&i.o.mobile.hide_keyboard&&!i.resultsOpened&&document.activeElement.blur();i.o.settingsHideOnRes&&i.o.blocking==!1&&i.hideSettings();typeof n.fn.asp_lazy!="undefined"&&setTimeout(function(){i.asp_lazy=i.n.resultsDiv.find(".asp_lazy").asp_lazy({chainable:!1,visibleOnly:i.o.resultstype=="isotopic"})},100);i.fixAccessibility();i.resultsOpened=!0},updateInfoHeader:function(n){var i=this,t,r=i.n.resultsDiv.find(".asp_results_top"),u=i.n.text.val().trim();r.length>0&&(i.n.items.length<=0?r.css("display","none"):(u!==""&&i.resInfoBoxTxt!==""?t=i.resInfoBoxTxt:u===""&&i.resInfoBoxTxtNoPhrase!==""&&(t=i.resInfoBoxTxtNoPhrase),t!==""?(t=t.replace("{phrase}",i.n.text.val()),t=t.replace("{results_count}",i.n.items.length),t=t.replace("{results_count_total}",n),r.html(t),r.css("display","block")):r.css("display","none")))},hideResults:function(n){var i=this;if(n=typeof n=="undefined"?!0:n,!i.resultsOpened)return!1;i.n.resultsDiv.removeClass(i.resAnim.showClass).addClass(i.resAnim.hideClass);setTimeout(function(){i.n.resultsDiv.css(i.resAnim.hideCSS)},i.resAnim.duration);i.n.proclose.css({display:"none"});t()&&n&&document.activeElement.blur();i.resultsOpened=!1;typeof i.ptstack!="undefined"&&delete i.ptstack;i.n.c.trigger("asp_results_hide",[i.o.id,i.o.iid])},showMoreResLoader:function(){var n=this;n.n.resultsDiv.addClass("asp_more_res_loading")},showLoader:function(t){var i=this;if(t=typeof t!="undefined"?t:!1,i.o.loaderLocation!="none"){if(i.n.container.hasClass("hiddend")||i.o.loaderLocation=="results"||i.n.proloading.css({display:"block"}),t!==!1)return!1;(i.n.container.hasClass("hiddend")&&i.o.loaderLocation!="search"||!i.n.container.hasClass("hiddend")&&(i.o.loaderLocation=="both"||i.o.loaderLocation=="results"))&&(i.n.resultsDiv.find(".asp_results_top").length>0&&i.n.resultsDiv.find(".asp_results_top").css("display","none"),i.showResultsBox(),n(".asp_res_loader",i.n.resultsDiv).removeClass("hiddend"),i.n.results.css("display","none"),i.n.showmore.css("display","none"),i.hidePagination())}},hideLoader:function(){var t=this;t.n.proloading.css({display:"none"});n(".asp_res_loader",t.n.resultsDiv).addClass("hiddend");t.n.results.css("display","");t.n.resultsDiv.removeClass("asp_more_res_loading")},scrollToResults:function(){var i=this;if(this.o.scrollToResults==1&&!this.$elem.parent().hasClass("asp_preview_data")&&this.o.compact.enabled!=1){if(i.o.resultsposition=="hover")var t=i.n.probox.offset().top-20;else var t=i.n.resultsDiv.offset().top-20;n("#wpadminbar").length>0&&(t-=n("#wpadminbar").height());t=t<0?0:t;n("body, html").animate({scrollTop:t},{duration:500})}},showVerticalResults:function(){var t=this;if(t.showResultsBox(),t.n.items.length>0){var f=t.n.items.length<t.o.itemscount?t.n.items.length:t.o.itemscount,o=n(".asp_group_header",t.n.resultsDiv),h=n(".asp_spacer",t.n.resultsDiv);if(t.n.items.length<=t.o.itemscount)t.n.results.css({height:"auto"});else if(t.call_num<1&&t.n.results.css({height:30}),t.call_num<1&&t.is_scroll&&t.scroll.mCustScr("update"),t.resize(),t.call_num<1){var i=0,r=0,u=0,e=0;t.n.items.each(function(){r+=n(this).outerHeight(!0);n(this).outerHeight(!0)>e&&(e=n(this).outerHeight(!0));i++});u=e*f;u>r&&(u=r);i=i<1?1:i;r=r/i*f;o.length>0&&o.each(function(t){var i=n(this).index()-t-Math.floor(n(this).index()/3);i<f&&(u+=n(this).outerHeight(!0))});t.n.results.css({height:u})}if(window.sscroll=t.scroll,t.is_scroll&&(t.call_num<1&&t.scroll.mCustScr("disable",!0),t.call_num<1&&t.scroll.mCustScr("update")),t.resize(),t.call_num<1&&(t.is_scroll?t.scroll.mCustScr("scrollTo",0):t.n.results.scrollTop(0)),t.o.highlight==1){var s=t.o.highlightwholewords==1?!0:!1;n("div.item",t.n.resultsDiv).highlight(t.n.text.val().split(" "),{element:"span",className:"highlighted",wordsOnly:s})}}t.resize();t.n.items.length==0&&(t.is_scroll?(t.n.results.css({height:11110}),t.scroll.mCustScr("update"),t.n.results.css({height:"auto"})):t.n.results.css({height:"auto"}));t.is_scroll||t.n.results.css({overflowY:"auto"});t.addAnimation();t.fixResultsPosition(!0);t.searching=!1},showHorizontalResults:function(){var t=this;if(t.n.resultsDiv.css("display","block"),t.fixResultsPosition(!0),t.n.items.css("opacity",t.animationOpacity),n(".asp_nores",t.n.results).size()>0?n(".mCSBap_container",t.n.resultsDiv).css({width:"auto",left:0}):t.call_num<1?n(".mCSBap_container",t.n.resultsDiv).css({width:t.n.resdrg.children().size()*n(t.n.resdrg.children()[0]).outerWidth(!0),left:0}):n(".mCSBap_container",t.n.resultsDiv).css({width:t.n.resdrg.children().size()*n(t.n.resdrg.children()[0]).outerWidth(!0)}),t.o.resultsposition=="hover"&&t.n.resultsDiv.css("width",t.n.container.width()-(t.n.resultsDiv.outerWidth(!0)-t.n.resultsDiv.innerWidth())),(t.call_num<1&&t.is_scroll||t.call_num>0)&&(t.scroll.data({scrollButtons_scrollAmount:parseInt(t.n.items.outerWidth(!0)),mouseWheelPixels:parseInt(t.n.items.outerWidth(!0))}).mCustScr("update"),t.call_num<1&&(n("body").hasClass("rtl")?t.scroll.mCustScr("scrollTo",1e5,{scrollInertia:200,callbacks:!1}):t.scroll.mCustScr("scrollTo",.1,{scrollInertia:200,callbacks:!1}))),!t.is_scroll)if(t.n.items.length>0){var i=parseInt(t.n.items.css("marginLeft")),r=t.n.items.outerWidth()+i*2;t.n.results.css("overflowX","auto");t.n.resdrg.css("width",t.n.items.length*r+i*2+"px")}else t.n.results.css("overflowX","hidden"),t.n.resdrg.css("width","auto");if(t.o.highlight==1){var u=t.o.highlightwholewords==1?!0:!1;n("div.item",t.n.resultsDiv).highlight(t.n.text.val().split(" "),{element:"span",className:"highlighted",wordsOnly:u})}t.showResultsBox();t.addAnimation()},showIsotopicResults:function(){var t=this;if(t._no_animations==!0)return t.showResultsBox(),t.addAnimation(),t.searching=!1,!0;if(t.preProcessIsotopicResults(),t.showResultsBox(),t.n.items.length>0&&(t.n.results.css({height:"auto"}),t.o.highlight==1)){var i=t.o.highlightwholewords==1?!0:!1;n("div.item",t.n.resultsDiv).highlight(t.n.text.val().split(" "),{element:"span",className:"highlighted",wordsOnly:i})}if(t.call_num==0&&t.calculateIsotopeRows(),t.showPagination(),t.isotopicPagerScroll(),t.n.items.length==0){var r=n(".nores",t.n.results).outerHeight(!0)>t.o.resultitemheight?t.o.resultitemheight:n(".nores",t.n.results).outerHeight(!0);t.n.results.css({height:11110});t.n.results.css({height:"auto"});t.n.resdrg.css({height:"auto"})}else if(typeof rpp_isotope!="undefined")t.isotopic!=null&&typeof t.isotopic.destroy!="undefined"&&t.call_num==0&&t.isotopic.destroy(),(t.call_num==0||t.isotopic==null)&&(t.isotopic=new rpp_isotope("#ajaxsearchprores"+t.o.rid+" .resdrg",{isOriginLeft:!n("body").hasClass("rtl"),itemSelector:"div.item",layoutMode:"masonry",filter:t.filterFns.number,masonry:{gutter:t.o.isotopic.gutter}}));else return t.raiseError("isotope"),!1;t.addAnimation();t.searching=!1},preProcessIsotopicResults:function(){var i=this,r=0,u="";i.o.isotopic.showOverlay&&i.n.aspItemOverlay.length>0&&(u=i.n.aspItemOverlay[0].outerHTML);n.grep(i.n.items,function(f){var s="",e="",c=n(".asp_item_img",f).length>0?!0:!1,l=n(".asp_item_img",f);if(c){var h=l.attr("imgsrc"),o=i.o.isotopic.blurOverlay&&!t()?"aspblur":"no_aspblur";e=n("<div data-src='"+h+"' ><\/div>");typeof n.fn.asp_lazy=="undefined"&&e.css({"background-image":"url("+h+")"});e.css({filter:"url(#"+o+")","-webkit-filter":"url(#"+o+")","-moz-filter":"url(#"+o+")","-o-filter":"url(#"+o+")","-ms-filter":"url(#"+o+")"}).addClass("asp_item_overlay_img asp_lazy");e=e.get(0).outerHTML}else switch(i.o.isotopic.ifNoImage){case"removeres":return!1;case"defaultimage":if(i.o.defaultImage!=""){s="<div class='asp_item_img' style='background-image:url("+i.o.defaultImage+");'>";var o=i.o.isotopic.blurOverlay&&!t()?"aspblur":"no_aspblur";e=n("<div data-src='"+i.o.defaultImage+"' ><\/div>");typeof n.fn.asp_lazy=="undefined"&&e.css({"background-image":"url("+i.o.defaultImage+")"});e.css({filter:"url(#"+o+")","-webkit-filter":"url(#"+o+")","-moz-filter":"url(#"+o+")","-o-filter":"url(#"+o+")","-ms-filter":"url(#"+o+")"}).addClass("asp_item_overlay_img asp_lazy");e=e.get(0).outerHTML}}n(e+u+s).prependTo(f);n(f).attr("data-itemnum",r);r++})},showPagination:function(t){var i=this;if(t=typeof t!="undefined"?t:!1,!i.o.isotopic.pagination)return i.isotopic!=null&&t&&i.isotopic.arrange({transitionDuration:0,filter:i.filterFns.number}),!1;if((i.call_num<1||t)&&n("nav.asp_navigation ul li",i.n.resultsDiv).remove(),n("nav.asp_navigation",i.n.resultsDiv).css("display","none"),i.n.items.length>0){var f=1;i.call_num>0&&!t&&(f=n("li",n("nav.asp_navigation ul",i.n.resultsDiv).get(0)).length+1);var e=Math.ceil(i.n.items.length/i.il.itemsPerPage);if(e>1){var u=t&&i.il.lastVisibleItem>0?Math.ceil(i.il.lastVisibleItem/i.il.itemsPerPage):1;u=u<=0?1:u;for(var r=f;r<=e;r++)r==u?n("nav.asp_navigation ul",i.n.resultsDiv).append("<li class='asp_active'><span>"+r+"<\/span><\/li>"):n("nav.asp_navigation ul",i.n.resultsDiv).append("<li><span>"+r+"<\/span><\/li>");n("nav.asp_navigation",i.n.resultsDiv).css("display","block");t?n("nav.asp_navigation ul li.asp_active",i.n.resultsDiv).trigger("click_trigger"):n("nav.asp_navigation ul li.asp_active",i.n.resultsDiv).click()}else i.isotopic!=null&&t&&i.isotopic.arrange({transitionDuration:0,filter:i.filterFns.number})}},hidePagination:function(){var t=this;n("nav.asp_navigation",t.n.resultsDiv).css("display","none")},visiblePagination:function(){var t=this;return n("nav.asp_navigation",t.n.resultsDiv).css("display")!="none"},calculateIsotopeRows:function(){var n=this,r,u,t=parseFloat(n.n.results.innerWidth());h()==="desktop"?(r=s(n.o.isotopic.itemWidth,t),u=s(n.o.isotopic.itemHeight,t)):h()==="tablet"?(r=s(n.o.isotopic.itemWidthTablet,t),u=s(n.o.isotopic.itemHeightTablet,t)):(r=s(n.o.isotopic.itemWidthPhone,t),u=s(n.o.isotopic.itemHeightPhone,t));var e=t/r,o=n.o.isotopic.gutter,i=Math.floor(e);i<=0&&(i=1);Math.abs(t/i-r)>Math.abs(t/(i+1)-r)&&i++;var f=t/i-(i-1)*o/i,c=f/r*u;n.il.columns=i;n.il.itemsPerPage=i*n.il.rows;n.il.lastVisibleItem=n.n.results.find(".asp_isotopic_item:visible").first().index()+1;n.n.resultsDiv.data({colums:n.il.columns,itemsperpage:n.il.itemsPerPage});n.currentPage=1;n.n.items.css({width:Math.floor(f),height:Math.floor(c)})},showPolaroidResults:function(){var t=this;n(".photostack>nav",t.n.resultsDiv).remove();var i=n("figure",t.n.resultsDiv);if(t.n.resultsDiv.css({display:"block",height:"auto"}),t.showResultsBox(),i.length>0){if(t.n.results.css({height:t.o.prescontainerheight}),t.o.highlight==1){var r=t.o.highlightwholewords==1?!0:!1;n("figcaption",t.n.resultsDiv).highlight(t.n.text.val().split(" "),{element:"span",className:"highlighted",wordsOnly:r})}if(typeof Photostack!="undefined")t.ptstack=new Photostack(t.n.results.get(0),{callback:function(){}});else return t.raiseError("polaroid"),!1}if(i.length==0){var u=n(".nores",t.n.results).outerHeight(!0)>t.o.resultitemheight?t.o.resultitemheight:n(".nores",t.n.results).outerHeight(!0);t.n.results.css({height:11110});t.n.results.css({height:"auto"})}t.addAnimation();t.fixResultsPosition(!0);t.searching=!1;t.initPolaroidEvents(i)},initPolaroidEvents:function(t){var i=this,r=1;t.each(function(){r>1&&n(this).removeClass("photostack-current");n(this).attr("idx",r);r++});t.click(function(t){if(!n(this).hasClass("photostack-current")){t.preventDefault();var r=n(this).attr("idx");n(".photostack>nav span:nth-child("+r+")",i.n.resultsDiv).click()}});t.bind("mousewheel",function(t,r){t.preventDefault();r>=1?n(".photostack>nav span.current",i.n.resultsDiv).next().length>0?n(".photostack>nav span.current",i.n.resultsDiv).next().click():n(".photostack>nav span:nth-child(1)",i.n.resultsDiv).click():n(".photostack>nav span.current",i.n.resultsDiv).prev().length>0?n(".photostack>nav span.current",i.n.resultsDiv).prev().click():n(".photostack>nav span:nth-last-child(1)",i.n.resultsDiv).click()});typeof t.swipe!="undefined"&&i.n.resultsDiv.swipe({excludedElements:"button, input, select, textarea, .noSwipe",preventDefaultEvents:!f(),swipeLeft:function(){n(".photostack>nav span.current",i.n.resultsDiv).next().length>0?n(".photostack>nav span.current",i.n.resultsDiv).next().click():n(".photostack>nav span:nth-child(1)",i.n.resultsDiv).click()},swipeRight:function(){n(".photostack>nav span.current",i.n.resultsDiv).prev().length>0?n(".photostack>nav span.current",i.n.resultsDiv).prev().click():n(".photostack>nav span:nth-last-child(1)",i.n.resultsDiv).click()}})},addAnimation:function(){var t=this,i=0,r=1;if(t.call_num>0||t._no_animations)return t.n.items.removeClass("opacityZero").removeClass("asp_an_"+t.animOptions.items),!1;t.n.items.each(function(){var u=this;if(t.o.resultstype=="isotopic"&&r>t.il.itemsPerPage){n(u).removeClass("opacityZero");return}setTimeout(function(){n(u).addClass("asp_an_"+t.animOptions.items);n(u).removeClass("opacityZero")},i);i=i+80;r++})},removeAnimation:function(){var t=this;t.n.items.each(function(){var i=this;n(i).removeClass("asp_an_"+t.animOptions.items)})},initSettingsAnimations:function(){var n=this;n.settAnim={showClass:"",showCSS:{visibility:"visible",display:"block",opacity:1,"animation-duration":n.animOptions.settings.dur},hideClass:"",hideCSS:{visibility:"hidden",opacity:0,display:"none"},duration:n.animOptions.settings.dur};n.animOptions.settings.anim=="fade"&&(n.settAnim.showClass="asp_an_fadeIn",n.settAnim.hideClass="asp_an_fadeOut");n.animOptions.settings.anim!="fadedrop"||n.o.blocking||n.supportTransform===!1?n.animOptions.settings.anim=="fadedrop"&&(n.settAnim.showClass="asp_an_fadeIn",n.settAnim.hideClass="asp_an_fadeOut"):(n.settAnim.showClass="asp_an_fadeInDrop",n.settAnim.hideClass="asp_an_fadeOutDrop");n.n.searchsettings.css({"-webkit-animation-duration":n.settAnim.duration+"ms","animation-duration":n.settAnim.duration+"ms"})},initResultsAnimations:function(){var n=this;n.resAnim={showClass:"",showCSS:{visibility:"visible",display:"block",opacity:1,"animation-duration":n.animOptions.results.dur},hideClass:"",hideCSS:{visibility:"hidden",opacity:0,display:"none"},duration:n.animOptions.results.dur};var t=n.n.resultsDiv.css("position"),i=t!="fixed"&&t!="absolute";n.animOptions.results.anim=="fade"&&(n.resAnim.showClass="asp_an_fadeIn",n.resAnim.hideClass="asp_an_fadeOut");n.animOptions.results.anim!="fadedrop"||i||n.supportTransform===!1?n.animOptions.results.anim=="fadedrop"&&(n.resAnim.showClass="asp_an_fadeIn",n.resAnim.hideClass="asp_an_fadeOut"):(n.resAnim.showClass="asp_an_fadeInDrop",n.resAnim.hideClass="asp_an_fadeOutDrop");n.n.resultsDiv.css({"-webkit-animation-duration":n.settAnim.duration+"ms","animation-duration":n.settAnim.duration+"ms"})},showSettings:function(){var t=this;if(t.n.c.trigger("asp_settings_show",[t.o.id,t.o.iid]),t.n.searchsettings.css(t.settAnim.showCSS),t.n.searchsettings.removeClass(t.settAnim.hideClass).addClass(t.settAnim.showClass),t.settScroll==null&&t.is_scroll)t.settScroll=n(".asp_sett_scroll",t.n.searchsettings).mCustScr({contentTouchScroll:!1});if(t.o.fss_layout=="masonry"&&t.sIsotope==null)if(typeof rpp_isotope!="undefined")setTimeout(function(){var i=t.n.searchsettings.attr("id");t.n.searchsettings.css("width","100%");t.sIsotope=new rpp_isotope("#"+i+" form",{isOriginLeft:!n("body").hasClass("rtl"),itemSelector:"fieldset",layoutMode:"masonry",transitionDuration:0})},t.settAnim.duration);else return t.raiseError("isotope"),!1;t.n.prosettings.data("opened",1);t.fixSettingsPosition(!0);t.fixAccessibility()},showResultsBox:function(){var n=this;n.n.c.trigger("asp_results_show",[n.o.id,n.o.iid]);n.n.resultsDiv.css({display:"block",height:"auto"});n.n.items.addClass(n.animationOpacity);n.fixResultsPosition(!0);n.n.resultsDiv.css(n.resAnim.showCSS);n.n.resultsDiv.removeClass(n.resAnim.hideClass).addClass(n.resAnim.showClass)},hideSettings:function(){var n=this;n.n.c.trigger("asp_settings_hide",[n.o.id,n.o.iid]);n.n.searchsettings.removeClass(n.settAnim.showClass).addClass(n.settAnim.hideClass);setTimeout(function(){n.n.searchsettings.css(n.settAnim.hideCSS)},n.settAnim.duration);n.n.prosettings.data("opened",0);n.sIsotope!=null&&setTimeout(function(){n.sIsotope.destroy();n.sIsotope=null},n.settAnim.duration)},cleanUp:function(){var t=this;n(".searchsettings",t.n.container).length>0&&(n("body>#ajaxsearchprosettings"+t.o.rid).remove(),n("body>#ajaxsearchprores"+t.o.rid).remove())},orientationChange:function(){var n=this;n.fixSettingsPosition();n.fixResultsPosition();n.fixTryThisPosition();n.o.resultstype=="isotopic"&&n.n.resultsDiv.css("visibility")=="visible"&&(n.calculateIsotopeRows(),n.showPagination(!0),n.removeAnimation())},resize:function(){var n=this;n.fixSettingsPosition();n.fixResultsPosition();n.fixTryThisPosition();n.o.resultstype=="isotopic"&&n.n.resultsDiv.css("visibility")=="visible"&&(n.calculateIsotopeRows(),n.showPagination(!0),n.removeAnimation())},scrolling:function(n){var t=this;t.hideOnInvisibleBox();t.fixSettingsPosition(n);t.fixResultsPosition(n)},fixAccessibility:function(){var n=this;n.n.resultsDiv.find("a.mCSBap_buttonUp").attr("aria-label","Empty link");n.n.resultsDiv.find("a.mCSBap_buttonDown").attr("aria-label","Empty link");n.n.searchsettings.find("input.chosen-search-input").attr("aria-label","Chosen search")},fixTryThisPosition:function(){var n=this;n.n.trythis.css({left:n.n.container.position().left})},fixResultsPosition:function(i){i=typeof i=="undefined"?!1:i;var r=this,e=r.n.resultsDiv.css("position");if(e=="fixed"||e=="absolute"){var o=0;if(n("body").css("position")!="static"&&(o=n("body").offset().top),i==!0||r.n.resultsDiv.css("visibility")=="visible"){var s=0,l=0,u=r.n.container.offset();if(e=="fixed"&&(o=0,s=n(document).scrollTop(),l=n(document).scrollLeft(),t()&&f()&&r.n.text.is(":focus")&&(s=r.savedScrollTop,u.top=r.savedContainerTop)),typeof u!="undefined"){var v=r.n.container.outerWidth()<240?240:r.n.container.outerWidth(),a;a=h()=="phone"?r.o.results.width_phone:h()=="tablet"?r.o.results.width_tablet:r.o.results.width;a=="auto"&&r.n.resultsDiv.outerWidth(v);var c=0;r.o.resultsSnapTo=="right"?c=r.n.resultsDiv.outerWidth()-r.n.container.outerWidth():r.o.resultsSnapTo=="center"&&(c=parseInt((r.n.resultsDiv.outerWidth()-r.n.container.outerWidth())/2));r.n.resultsDiv.css({top:u.top+r.n.container.outerHeight(!0)-o-s,left:u.left-l-c})}}}},fixSettingsPosition:function(i){i=typeof i=="undefined"?!1:i;var r=this,s=0;if(n("body").css("position")!="static"&&(s=n("body").offset().top),(i==!0||r.n.prosettings.data("opened")!=0)&&r.o.blocking!=!0){if(r.fixSettingsWidth(),r.n.prosettings.css("display")!="none")var e=r.n.prosettings;else var e=r.n.promagnifier;var u=e.offset(),o=0,h=0;r.n.searchsettings.css("position")=="fixed"&&(o=n(window).scrollTop(),h=n(window).scrollLeft(),t()&&f()&&r.n.text.is(":focus")&&(u.top=r.savedContainerTop,o=r.savedScrollTop));r.o.settingsimagepos=="left"?r.n.searchsettings.css({display:"block",top:u.top+e.height()-2-s-o,left:u.left-h}):r.n.searchsettings.css({display:"block",top:u.top+e.height()-2-s-o,left:u.left+e.width()-r.n.searchsettings.width()-h})}},fixSettingsWidth:function(){var t=this;if(!t.o.blocking&&t.o.fss_layout!="masonry"&&(t.n.searchsettings.css({width:"100%"}),t.n.searchsettings.innerWidth()%n("fieldset",t.n.searchsettings).outerWidth(!0)>10)){var i=parseInt(t.n.searchsettings.innerWidth()/n("fieldset",t.n.searchsettings).outerWidth(!0));i=i<=0?1:i;t.n.searchsettings.css({width:i*n("fieldset",t.n.searchsettings).outerWidth(!0)+8})}},liveLoad:function(t,i){if(t=="body"||t=="html")return console.log("Ajax Search Pro: Do not use html or body as the live loader selector."),!1;var f=["#content","#Content","div[role=main]","main[role=main]","div.theme-content","div.td-ss-main-content","main.l-content"];if(t!="#main"&&f.unshift("#main"),n(t).length<1&&(n.each(f,function(i,r){if(n(r).length>0)return t=r,!1}),n(t).length<1))return console.log("Ajax Search Pro: The live search selector does not exist on the page."),!1;var u=n(t).first(),r=this;r.post!=null&&r.post.abort();u.css("opacity",.4);r.post=n.ajax({url:i,success:function(f){f!=""&&n(f).length>0&&n(f).find(t).length>0&&(u.replaceWith(n(f).find(t).first()),document.title=n(f).filter("title").text(),history.pushState({},null,i),ASP.fixClones(),ASP.initialize(),r.lastSuccesfulSearch=n("form",r.n.searchsettings).serialize()+r.n.text.val().trim(),r.lastSearchData=f);r.hideLoader();u.css("opacity",1);r.searching=!1;r.n.proclose.css({display:"block"})},dataType:"html"}).fail(function(n,t){(u.css("opacity",1),n.aborted||t=="abort")||(u.html("This request has failed. Please check your connection."),r.hideLoader(),r.searching=!1,r.n.proclose.css({display:"block"}))})},getRedirectURL:function(t){var i=this,r,f;if(t=typeof t!="undefined"?t:"enter",f=t=="click"?i.o.redirectClickTo:t=="button"?i.o.sb.redirect_action:i.o.redirectEnterTo,r=f=="results_page"?"?s="+c(i.n.text.val()):f=="woo_results_page"?"?post_type=product&s="+c(i.n.text.val()):t=="button"?i.parseCustomRedirectURL(i.o.sb.redirect_url,i.n.text.val()):i.parseCustomRedirectURL(i.o.redirect_url,i.n.text.val()),i.o.homeurl.indexOf("?")>1&&r.indexOf("?")==0&&(r=r.replace("?","&")),i.o.overridewpdefault){var e=r+"&asp_active=1&p_asid="+i.o.id+"&p_asp_data="+u.encode(n("form",i.n.searchsettings).serialize());return i.o.homeurl+e}return i.o.homeurl+r},parseCustomRedirectURL:function(t,i){var r=this,u=t.replace(/\{phrase\}/g,c(i)),f=u.match(/\{(.*?)\}/g);return f!==null&&n.each(f,function(t,i){i=i.replace(/[{}]/g,"");var f=n('input[type=radio][name*="aspf['+i+'_"]:checked',r.n.searchsettings);if(f.length==0&&(f=n('input[type=text][name*="aspf['+i+'_"]',r.n.searchsettings)),f.length==0&&(f=n('input[type=hidden][name*="aspf['+i+'_"]',r.n.searchsettings)),f.length==0&&(f=n('select[name*="aspf['+i+'_"]:not([multiple])',r.n.searchsettings)),f.length==0)return!0;var e=f.val();e=""+e;u=u.replace("{"+i+"}",e)}),u},setFilterStateInput:function(t){var i=this;typeof t=="undefined"&&(t=65);setTimeout(function(){JSON.stringify(i.originalFormData)!=JSON.stringify(e(n("form",i.n.searchsettings)))?i.n.searchsettings.find("input[name=filters_initial]").val(0):i.n.searchsettings.find("input[name=filters_initial]").val(1)},t)},resetSearchFilters:function(){var t=this,i=e(n("form",t.n.searchsettings));t.noUiSliders.length>0&&n.each(t.noUiSliders,function(n,t){typeof t.noUiSlider!="undefined"&&t.noUiSlider.reset()});t.n.searchsettings.find("fieldset").find("option, input").each(function(){var i=n(this).prop("tagName").toLowerCase();if(i=="option")n(this).removeAttr("selected");else if(i=="input"){var t=n(this).attr("type").toLowerCase();t=="radio"?n(this).parent().parent().find("input[type=radio]").attr("checked",!1):t=="checkbox"?n(this).parent().parent().find("input[type=checkbox]").attr("checked",!1):(t=="hidden"||t=="text")&&n(this).val("")}});t.n.searchsettings.find("fieldset *[data-origvalue]").each(function(){var u=n(this).prop("tagName").toLowerCase();if(u=="option")n(this).attr("selected","selected");else if(u=="input"){var i=n(this).attr("type").toLowerCase();if(i=="radio")n(this).attr("checked",!0);else if(i=="checkbox")n(this).attr("checked",!0);else if((i=="hidden"||i=="text")&&(n(this).val(n(this).data("origvalue")),n(this).hasClass("asp_datepicker_field")||n(this).hasClass("asp_datepicker"))){var r=window.jQuery,f=r(n(this).get(0)).datepicker("option","dateFormat"),t=n(this).data("origvalue");r(n(this).get(0)).datepicker("option","dateFormat","yy-mm-dd");n(this).hasClass("asp_datepicker_field")&&(t=t=="0"?"":t==""?"+0":t);r(n(this).get(0)).datepicker("setDate",t);r(n(this).get(0)).datepicker("option","dateFormat",f)}}});t.n.searchsettings.find(".asp_gochosen").trigger("chosen:updated");t.n.text.val("");t.n.proloading.css("display","none");t.hideLoader();t.post!=null&&t.post.abort();t.o.rb.action=="live"&&JSON.stringify(i)!=JSON.stringify(e(n("form",t.n.searchsettings)))?t.search():t.o.rb.action=="close"&&t.hideResults()},stat_addKeyword:function(t,i){var r={action:"ajaxsearchpro_addkeyword",id:t,keyword:i};n.post(ASP.ajaxurl,r,function(){})},hideOnInvisibleBox:function(){var n=this;n.o.detectVisibility!=1||n.o.compact.enabled!=0||n.n.container.hasClass("hiddend")||!n.n.container.is(":hidden")&&n.n.container.is(":visible")||(n.hideSettings(),n.hideResults())},searchFor:function(t){var r=n(this).attr("id").match(/^ajaxsearchpro(.*)/)[1];if(typeof i[r]!="undefined"){var u=i[r];u.n.text.val(t);u.search(!1,!1,!1,!0)}else console.log("This instance: "+r+" does not exist :(")},searchRedirect:function(t){var e=n(this).attr("id").match(/^ajaxsearchpro(.*)/)[1];if(typeof i[e]!="undefined"){var r=i[e],f=r.parseCustomRedirectURL(r.o.redirect_url,t);r.o.homeurl.indexOf("?")>1&&f.indexOf("?")==0&&(f=f.replace("?","&"));r.o.overridewpdefault?r.o.override_method=="post"?o(r.o.homeurl+f,"post",{asp_active:1,p_asid:r.o.id,p_asp_data:n("form",r.n.searchsettings).serialize()}):location.href=r.o.homeurl+f+"&asp_active=1&p_asid="+r.o.id+"&p_asp_data="+u.encode(n("form",r.n.searchsettings).serialize()):o(r.o.homeurl+f,"post",{np_asid:r.o.id,np_asp_data:n("form",r.n.searchsettings).serialize()})}else console.log("This instance: "+e+" does not exist :(")},toggleSettings:function(t){var u=n(this).attr("id").match(/^ajaxsearchpro(.*)/)[1];if(typeof i[u]!="undefined"){var r=i[u];typeof t!="undefined"?t=="show"?r.showSettings():r.hideSettings():r.n.prosettings.data("opened")?r.hideSettings():r.showSettings()}else console.log("This instance: "+u+" does not exist :(")},closeResults:function(t){var u=n(this).attr("id").match(/^ajaxsearchpro(.*)/)[1];if(typeof i[u]!="undefined"){var r=i[u];typeof t!="undefined"&&t&&(r.n.text.val(""),r.n.textAutocomplete.val(""));r.hideResults();r.n.proloading.css("display","none");r.hideLoader();r.post!=null&&r.post.abort()}else console.log("This instance: "+u+" does not exist :(")},getStateURL:function(){var r=n(this).attr("id").match(/^ajaxsearchpro(.*)/)[1];if(typeof i[r]!="undefined"){var f=i[r],t=location.href;t=t.split("p_asid");t=t[0];t=t.replace("&asp_active=1","");t=t.replace("?asp_active=1","");t=t.slice(-1)=="?"?t.slice(0,-1):t;t=t.slice(-1)=="&"?t.slice(0,-1):t;var e=t.indexOf("?")>1?"&":"?";return t+e+"p_asid="+f.o.id+"&p_asp_data="+u.encode(n("form",f.n.searchsettings).serialize())}return console.log("This instance: "+r+" does not exist :("),!1},resetSearch:function(){var t=n(this).attr("id").match(/^ajaxsearchpro(.*)/)[1];if(typeof i[t]!="undefined"){var r=i[t];r.resetSearchFilters()}else return console.log("This instance: "+t+" does not exist :("),!1},filtersInitial:function(){var t=n(this).attr("id").match(/^ajaxsearchpro(.*)/)[1];if(typeof i[t]!="undefined"){var r=i[t];return r.n.searchsettings.find("input[name=filters_initial]").val()==1}return console.log("This instance: "+t+" does not exist :("),!1},filtersChanged:function(){var t=n(this).attr("id").match(/^ajaxsearchpro(.*)/)[1];if(typeof i[t]!="undefined"){var r=i[t];return r.n.searchsettings.find("input[name=filters_changed]").val()==1}return console.log("This instance: "+t+" does not exist :("),!1}};function c(n){return encodeURIComponent(n).replace(/\%20/g,"+")}function o(t,i,r,u){"use strict";var f;f=n("<form />",{action:t,method:i,style:"display: none;"});typeof r!="undefined"&&r!==null&&n.each(r,function(t,i){n("<input />",{type:"hidden",name:t,value:i}).appendTo(f)});typeof u!="undefined"&&u=="new"&&f.attr("target","_blank");f.appendTo("body").submit()}function l(t){n('<a href="'+t+'" target="_blank">').get(0).click()}function s(n,t){var i=0;return n=n+"",i=n.indexOf("px")>-1?parseInt(n,10):n.indexOf("%")>-1?typeof t!="undefined"&&t!=null?parseInt(parseInt(n,10)/100*t,10):parseInt(n,10):parseInt(n,10),i<100?100:i}function y(){return!("ontouchstart"in window)?0:1}function w(){var n=window.navigator.userAgent,t=n.indexOf("MSIE "),i=n.indexOf("Trident/"),r=n.indexOf("Edge/");return t>0||i>0||r>0?!0:!1}function f(){return typeof navigator!="undefined"&&typeof window.navigator.userAgent!="undefined"?window.navigator.userAgent.match(/(iPod|iPhone|iPad)/)!=null:!1}function b(){var n=window.navigator.userAgent,t=n.indexOf("MSIE ");return t>0?!0:!1}function k(){for(var t="transform WebkitTransform MozTransform OTransform msTransform".split(" "),i=document.createElement("div"),n=0;n<t.length;n++)if(i&&i.style[t[n]]!==undefined)return t[n];return!1}function p(n){var t=document.createElement("div");return n&&typeof n=="string"&&(n=n.replace(/<script[^>]*>([\S\s]*?)<\/script>/gmi,""),n=n.replace(/<\/?\w(?:[^"'>]|"[^"]*"|'[^']*')*>/gmi,""),t.innerHTML=n,n=t.textContent,t.textContent=""),n}typeof Object.create!="function"&&(Object.create=function(n){function t(){}return t.prototype=n,new t});function t(){try{return document.createEvent("TouchEvent"),!0}catch(n){return!1}}function h(){var t=n(window).width();return t<=640?"phone":t<=1024?"tablet":"desktop"}function e(t,i){var r=t.find(":input").get();return arguments.length===1?(i={},n.each(r,function(){this.name&&!this.disabled&&(this.checked||/select|textarea/i.test(this.nodeName)||/text/i.test(this.type)||n(this).hasClass("asp_datepicker_hidden")||n(this).hasClass("asp_slider_hidden"))&&(i[this.name]==undefined&&(i[this.name]=[]),i[this.name].push(n(this).val()))}),JSON.stringify(i)):(typeof i!="object"&&(i=JSON.parse(i)),n.each(r,function(){if(this.name)if(i[this.name]){var t=i[this.name],r=n(this);if(Object.prototype.toString.call(t)!=="[object Array]"&&(t=[t]),this.type=="checkbox"||this.type=="radio"){for(var o=r.val(),e=!1,f=0;f<t.length;f++)if(t[f]==o){e=!0;break}r.attr("checked",e)}else if(r.val(t[0]),n(this).hasClass("asp_gochosen")&&n(this).trigger("chosen:updated"),n(this).hasClass("asp_datepicker_field")||n(this).hasClass("asp_datepicker")){var u=window.jQuery,s=u(r.get(0)).datepicker("option","dateFormat");u(r.get(0)).datepicker("option","dateFormat","yy-mm-dd");u(r.get(0)).datepicker("setDate",t[0]);u(r.get(0)).datepicker("option","dateFormat",s)}}else(this.type=="checkbox"||this.type=="radio")&&n(this).attr("checked",!1)}),t)}n.plugin=function(t,i){n.fn[t]=function(r){return typeof r!="undefined"&&i[r]?i[r].apply(this,Array.prototype.slice.call(arguments,1)):this.each(function(){n.data(this,t)||n.data(this,t,Object.create(i).init(r,this))})}};n.plugin("ajaxsearchpro",v);var u={_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",encode:function(n){var e="",o,t,i,h,c,s,r,f=0;for(n=u._utf8_encode(n);f<n.length;)o=n.charCodeAt(f++),t=n.charCodeAt(f++),i=n.charCodeAt(f++),h=o>>2,c=(o&3)<<4|t>>4,s=(t&15)<<2|i>>6,r=i&63,isNaN(t)?s=r=64:isNaN(i)&&(r=64),e=e+this._keyStr.charAt(h)+this._keyStr.charAt(c)+this._keyStr.charAt(s)+this._keyStr.charAt(r);return e},decode:function(n){var t="",o,s,h,c,f,r,e,i=0;for(n=n.replace(/[^A-Za-z0-9\+\/\=]/g,"");i<n.length;)c=this._keyStr.indexOf(n.charAt(i++)),f=this._keyStr.indexOf(n.charAt(i++)),r=this._keyStr.indexOf(n.charAt(i++)),e=this._keyStr.indexOf(n.charAt(i++)),o=c<<2|f>>4,s=(f&15)<<4|r>>2,h=(r&3)<<6|e,t=t+String.fromCharCode(o),r!=64&&(t=t+String.fromCharCode(s)),e!=64&&(t=t+String.fromCharCode(h));return u._utf8_decode(t)},_utf8_encode:function(n){n=n.replace(/\r\n/g,"\n");for(var i="",r=0;r<n.length;r++){var t=n.charCodeAt(r);t<128?i+=String.fromCharCode(t):t>127&&t<2048?(i+=String.fromCharCode(t>>6|192),i+=String.fromCharCode(t&63|128)):(i+=String.fromCharCode(t>>12|224),i+=String.fromCharCode(t>>6&63|128),i+=String.fromCharCode(t&63|128))}return i},_utf8_decode:function(n){for(var r="",t=0,i=c1=c2=0;t<n.length;)i=n.charCodeAt(t),i<128?(r+=String.fromCharCode(i),t++):i>191&&i<224?(c2=n.charCodeAt(t+1),r+=String.fromCharCode((i&31)<<6|c2&63),t+=2):(c2=n.charCodeAt(t+1),c3=n.charCodeAt(t+2),r+=String.fromCharCode((i&15)<<12|(c2&63)<<6|c3&63),t+=3);return r}}})(jQuery);jQuery(function(n){n("body").on("click touchend","p.asp-try a",function(t){t.preventDefault();t.stopImmediatePropagation();for(var u=n(this).parent().attr("id").match(/^asp-try-(.*)/)[1],i=n("#ajaxsearchpro"+u),r=1;i.hasClass("asp_main_container")==!1;)if(i=i.prev(),r++,r>15)return;if(i.hasClass("asp_compact")){var f=i.attr("asp-compact")||"closed";f=="closed"&&n(".promagnifier .innericon",i).click()}document.activeElement.blur();n("input",i).val("");n("input.orig",i).val(n(this).html());setTimeout(function(){n("input.orig",i).trigger("input")},50)});n(".ajaxsearchprotop").each(function(){var t=n(this).data("aspdata"),i=t.id;t.action==0?n("a",this).click(function(n){n.preventDefault()}):t.action==2?n("a",this).click(function(t){t.preventDefault();ASP.api(i,"searchFor",n(this).html());n("html,body").animate({scrollTop:n("div[id*=ajaxsearchpro"+i+"_]").first().offset().top-40},"slow")}):t.action==1&&n("a",this).click(function(t){if(ASP.api(i,"exists"))return t.preventDefault(),ASP.api(i,"searchRedirect",n(this).html())})})});window.ASP=window.ASP||{};window.ASP.getScope=function(){return typeof jQuery!="undefined"?jQuery:typeof window[ASP.js_scope]!="undefined"?window[ASP.js_scope]:eval(ASP.js_scope)};window.ASP.initialized=!1;window.ASP.initialize=function(n){var i=this;if(typeof i.getScope=="undefined")return!1;var t=i.getScope(),r=".asp_init_data",u=function(n){for(var r="",t=0,i=c1=c2=0;t<n.length;)i=n.charCodeAt(t),i<128?(r+=String.fromCharCode(i),t++):i>191&&i<224?(c2=n.charCodeAt(t+1),r+=String.fromCharCode((i&31)<<6|c2&63),t+=2):(c2=n.charCodeAt(t+1),c3=n.charCodeAt(t+2),r+=String.fromCharCode((i&15)<<12|(c2&63)<<6|c3&63),t+=3);return r},f=function(n){var t="",s,h,c,l,e,r,o,i=0,f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";for(n=n.replace(/[^A-Za-z0-9\+\/\=]/g,"");i<n.length;)l=f.indexOf(n.charAt(i++)),e=f.indexOf(n.charAt(i++)),r=f.indexOf(n.charAt(i++)),o=f.indexOf(n.charAt(i++)),s=l<<2|e>>4,h=(e&15)<<4|r>>2,c=(r&3)<<6|o,t=t+String.fromCharCode(s),r!=64&&(t=t+String.fromCharCode(h)),o!=64&&(t=t+String.fromCharCode(c));return u(t)};typeof ASP_INSTANCES!="undefined"&&Object.keys(ASP_INSTANCES).length>0?t.each(ASP_INSTANCES,function(n,i){return typeof i=="undefined"?!1:t("#ajaxsearchpro"+n).hasClass("hasASP")?!1:(t("#ajaxsearchpro"+n).addClass("hasASP"),t("#ajaxsearchpro"+n).ajaxsearchpro(i))}):(typeof n!="undefined"&&(r="div[id*=asp_init_id_"+n+"]"),t(r).each(function(){var i=t(this).attr("id").match(/^asp_init_id_(.*)/)[1],n=t(this).data("aspdata");if(typeof n=="undefined"||(n=f(n),typeof n=="undefined"||n=="")||t("#ajaxsearchpro"+i).hasClass("hasASP"))return!0;t("#ajaxsearchpro"+i).addClass("hasASP");var r=JSON.parse(n);return t("#ajaxsearchpro"+i).ajaxsearchpro(r)}));i.initialized=!0};window.ASP.fixClones=function(){var t=this;if((t.fix_duplicates=t.fix_duplicates||0,t.fix_duplicates==0)||typeof t.getScope=="undefined")return!1;var n=t.getScope(),i={};n(".asp_init_data").each(function(){var t=n(this).attr("id").match(/^asp_init_id_(.*)/)[1],r=t.match(/^(.*)_(.*)/);typeof i[t]=="undefined"?i[t]={rid:t,id:r[1],inst:r[2],count:1}:i[t].count++});n.each(i,function(i,r){r.count>1&&n(".asp_m_"+r.rid).each(function(i){if(i==0)return!0;for(var e=n(this).parent(),f=2,u=r.id+"_"+f;n("#ajaxsearchpro"+u).length!=0;)++f,u=r.id+"_"+f;n(this).attr("id","ajaxsearchpro"+u);n(this).attr("data-instance",f);n(this).removeClass("asp_m_"+r.rid).addClass("asp_m_"+u);n(this).removeClass("hasASP");n(".asp_r_"+r.rid,this).length==0&&n(".asp_r_"+r.rid).clone().appendTo(n(this));n(".asp_r_"+r.rid,this).attr("id","ajaxsearchprores"+u);n(".asp_r_"+r.rid,this).attr("data-instance",f);n(".asp_s_"+r.rid,this).length==0&&n(".asp_s_"+r.rid).length!=0&&n(".asp_s_"+r.rid).clone().appendTo(n(this));n(".asp_sb_"+r.rid,this).length==0&&n(".asp_sb_"+r.rid).length!=0&&n(".asp_sb_"+r.rid).clone().appendTo(n(this));n(".asp_s_"+r.rid,this).attr("id","ajaxsearchprosettings"+u);n(".asp_sb_"+r.rid,e).attr("id","ajaxsearchprobsettings"+u);n(".asp_s_"+r.rid,this).attr("data-instance",f);n(".asp_sb_"+r.rid,this).attr("data-instance",f);n(".asp_hidden_data",e).length>0&&n(".asp_hidden_data",e).attr("id","asp_hidden_data_"+u);n(".asp_init_data",e).length>0&&n(".asp_init_data",e).attr("id","asp_init_id_"+u);t.initialize(r.id,parseInt(r.inst)+i)})})};window.ASP.ready=function(){var n=this,t=n.getScope(),i=null,r=null,u=0;r=setInterval(function(){if(u++,n.css_loaded==1||u>80){t(document).ready(function(){n.initialize();setTimeout(function(){n.fixClones()},2500)});t(window).on("load",function(){n.initialized||(n.initialize(),setTimeout(function(){n.fixClones()},2500),console.log("ASP initialized via window.load"))});clearInterval(r)}},50);typeof ASP.detect_ajax!="undefined"&&ASP.detect_ajax==1&&t("body").bind("DOMSubtreeModified",function(){clearTimeout(i);i=setTimeout(function(){n.initialize()},500)});var f;t(window).on("resize",function(){clearTimeout(f);f=setTimeout(function(){n.fixClones()},2e3)})};window.ASP.eventsList=[{name:"asp_init_search_bar",args:"id, instance"},{name:"asp_search_start",args:"id, instance, phrase"},{name:"asp_search_end",args:"id, instance, phrase, results_info"},{name:"asp_results_show",args:"id, instance"},{name:"asp_results_hide",args:"id, instance"},{name:"asp_settings_show",args:"id, instance"},{name:"asp_settings_hide",args:"id, instance"}];window.ASP.printEventsList=function(){for(var t=window.ASP.eventsList,n=0;n<t.length;n++)typeof t[n].args!="undefined"?console.log(t[n].name+" | args: "+t[n].args):console.log(t[n].name)};window.ASP.functionsList=[{name:"exists",args:"id"},{name:"searchFor",args:"id, (optional) instance, 'phrase'"},{name:"searchRedirect",args:"id, (optional) instance, 'phrase'"},{name:"toggleSettings",args:"id, (optional) instance, (optional) 'show' | 'hide'"},{name:"closeResults",args:"id, (optional)instance"},{name:"getStateURL",args:"id, (optional)instance"},{name:"resetSearch",args:"id, (optional)instance"},{name:"filtersInitial",args:"id, (optional)instance"},{name:"filtersChanged",args:"id, (optional)instance"}];window.ASP.printFunctionsList=function(){for(var t=window.ASP.functionsList,n=0;n<t.length;n++)typeof t[n].args!="undefined"?console.log(t[n].name+" | args: "+t[n].args):console.log(t[n].name)};window.ASP.api=function(){var n=function(n,t,i,r){var f=this,u=f.getScope();if(u("#ajaxsearchpro"+n+"_"+t).length>0)return u("#ajaxsearchpro"+n+"_"+t).ajaxsearchpro(i,r)},t=function(n,t,i){var f=this,r=f.getScope(),u=!1;if(!isNaN(parseFloat(t))&&isFinite(t)){if(r("#ajaxsearchpro"+n+"_"+t).length>0)return r("#ajaxsearchpro"+n+"_"+t).ajaxsearchpro(i)}else n==0?r(".asp_main_container.hasASP").length>0&&r(".asp_main_container.hasASP").each(function(){u=r(this).ajaxsearchpro(t,i)}):r("div.asp_m_"+n).length>0&&r("div.asp_m_"+n).each(function(){u=r(this).ajaxsearchpro(t,i)});return u},i=function(n,t){var u=this,i=u.getScope(),r=!1;return t=="exists"?i("div.asp_m_"+n).length>0:(n==0?i(".asp_main_container.hasASP").length>0&&i(".asp_main_container.hasASP").each(function(){r=i(this).ajaxsearchpro(t)}):i("div.asp_m_"+n).length>0&&i("div.asp_m_"+n).each(function(){r=i(this).ajaxsearchpro(t)}),r)};return arguments.length==4?n.apply(this,arguments):arguments.length==3?t.apply(this,arguments):arguments.length==2?i.apply(this,arguments):arguments.length==0?(console.log("Usage: ASP.api(id, [optional]instance, function, [optional]args);"),console.log("---------------------------------"),console.log("functions list:"),window.ASP.printFunctionsList()):void 0};window._ASP=ASP;window._ASP.ready();